SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";

CREATE TABLE IF NOT EXISTS `ajax_chat_bans`
(
    `userID`   int(11)       NOT NULL,
    `userName` varchar(64)   NOT NULL,
    `dateTime` datetime      NOT NULL,
    `ip`       varbinary(16) NOT NULL
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `ajax_chat_invitations`
(
    `userID`   int(11)  NOT NULL,
    `channel`  int(11)  NOT NULL,
    `dateTime` datetime NOT NULL
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `ajax_chat_messages`
(
    `id`       int(11)       NOT NULL AUTO_INCREMENT,
    `userID`   int(11)       NOT NULL,
    `userName` varchar(64)   NOT NULL,
    `userRole` int(1)        NOT NULL,
    `channel`  int(11)       NOT NULL,
    `dateTime` datetime      NOT NULL,
    `ip`       varbinary(16) NOT NULL,
    `text`     text DEFAULT NULL,
    PRIMARY KEY (`id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `ajax_chat_online`
(
    `userID`   int(11)       NOT NULL,
    `userName` varchar(64)   NOT NULL,
    `userRole` int(1)        NOT NULL,
    `channel`  int(11)       NOT NULL,
    `dateTime` datetime      NOT NULL,
    `ip`       varbinary(16) NOT NULL
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_ads`
(
    `ad_id`          mediumint(8) unsigned NOT NULL auto_increment,
    `ad_block_ids`   varchar(255)          NOT NULL default '',
    `ad_start_time`  datetime              NOT NULL default '0000-00-00 00:00:00',
    `ad_active_days` smallint(6)           NOT NULL default '0',
    `ad_status`      tinyint(4)            NOT NULL default '1',
    `ad_desc`        varchar(255)          NOT NULL default '',
    `ad_html`        text                  NOT NULL,
    PRIMARY KEY (`ad_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8
  AUTO_INCREMENT = 1;

CREATE TABLE IF NOT EXISTS `bb_ads_megafon`
(
    `id`       int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
    `start_ip` varchar(15)      NOT NULL,
    `end_ip`   varchar(15)      NOT NULL,
    PRIMARY KEY (`id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_ads_yandex`
(
    `id`       int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
    `start_ip` varchar(15)      NOT NULL,
    `end_ip`   varchar(15)      NOT NULL,
    PRIMARY KEY (`id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_attachments`
(
    `attach_id` mediumint(8) unsigned NOT NULL default '0',
    `post_id`   mediumint(8) unsigned NOT NULL default '0',
    `user_id_1` mediumint(8)          NOT NULL default '0',
    PRIMARY KEY (`attach_id`, `post_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_attachments_config`
(
    `config_name`  varchar(255) NOT NULL default '',
    `config_value` varchar(255) NOT NULL default '',
    PRIMARY KEY (`config_name`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

INSERT INTO `bb_attachments_config` (`config_name`, `config_value`)
VALUES ('allow_ftp_upload', '0'),
       ('allow_pm_attach', '1'),
       ('attachment_quota', '5242880000'),
       ('attach_version', '2.3.14'),
       ('default_pm_quota', '0'),
       ('default_upload_quota', '0'),
       ('disable_mod', '0'),
       ('display_order', '0'),
       ('download_path', ''),
       ('flash_autoplay', '0'),
       ('ftp_pass', ''),
       ('ftp_pasv_mode', '1'),
       ('ftp_path', ''),
       ('ftp_server', ''),
       ('ftp_user', ''),
       ('img_create_thumbnail', '0'),
       ('img_display_inlined', '1'),
       ('img_imagick', '/usr/bin/convert'),
       ('img_link_height', '0'),
       ('img_link_width', '0'),
       ('img_max_height', '200'),
       ('img_max_width', '200'),
       ('img_min_thumb_filesize', '12000'),
       ('max_attachments', '1'),
       ('max_attachments_pm', '1'),
       ('max_filesize', '20971520'),
       ('max_filesize_pm', '1048576'),
       ('topic_icon', 'images/icon_clip.gif'),
       ('upload_dir', 'files'),
       ('upload_img', 'images/icon_clip.gif'),
       ('use_gd2', '1'),
       ('wma_autoplay', '0');

CREATE TABLE IF NOT EXISTS `bb_attachments_desc`
(
    `attach_id`         mediumint(8) unsigned NOT NULL auto_increment,
    `physical_filename` varchar(255)          NOT NULL default '',
    `real_filename`     varchar(255)          NOT NULL default '',
    `download_count`    mediumint(8) unsigned NOT NULL default '0',
    `comment`           varchar(255)          NOT NULL default '',
    `extension`         varchar(100)          NOT NULL default '',
    `mimetype`          varchar(100)          NOT NULL default '',
    `filesize`          int(20)               NOT NULL default '0',
    `filetime`          int(11)               NOT NULL default '0',
    `thumbnail`         tinyint(1)            NOT NULL default '0',
    `tracker_status`    tinyint(1)            NOT NULL default '0',
    PRIMARY KEY (`attach_id`),
    KEY `filetime` (`filetime`),
    KEY `filesize` (`filesize`),
    KEY `physical_filename` (`physical_filename`(10))
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8
  AUTO_INCREMENT = 1;

CREATE TABLE IF NOT EXISTS `bb_attach_quota`
(
    `user_id`        mediumint(8) unsigned NOT NULL default '0',
    `group_id`       mediumint(8) unsigned NOT NULL default '0',
    `quota_type`     smallint(2)           NOT NULL default '0',
    `quota_limit_id` mediumint(8) unsigned NOT NULL default '0',
    KEY `quota_type` (`quota_type`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_auth_access`
(
    `group_id`   mediumint(8)         NOT NULL default '0',
    `forum_id`   smallint(5) unsigned NOT NULL default '0',
    `forum_perm` int(11)              NOT NULL default '0',
    PRIMARY KEY (`group_id`, `forum_id`),
    KEY `forum_id` (`forum_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_auth_access_snap`
(
    `user_id`    mediumint(9) NOT NULL default '0',
    `forum_id`   smallint(6)  NOT NULL default '0',
    `forum_perm` int(11)      NOT NULL default '0',
    PRIMARY KEY (`user_id`, `forum_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_awards`
(
    `award_id`          int(11)      NOT NULL AUTO_INCREMENT,
    `award_category`    int(11)      NOT NULL DEFAULT 0,
    `award_order`       int(11)      NOT NULL DEFAULT 0,
    `award_title`       varchar(255) NOT NULL,
    `award_description` text         NOT NULL,
    `award_moder`       int(11)      NOT NULL,
    `award_file`        text         NOT NULL,
    `award_holders`     int(11)      NOT NULL,
    PRIMARY KEY (`award_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

INSERT INTO `bb_awards` (`award_id`, `award_category`, `award_order`, `award_title`, `award_description`, `award_moder`,
                         `award_file`, `award_holders`)
VALUES (1, 1, 1, 'Пафосный нуб', 'Специальное звание.', 2, 'prikol.gif', 3),
       (2, 1, 2, 'Царь горы', 'Специальное звание.', 2, 'medal1.gif', 1),
       (3, 1, 3, 'Жадина-говядина', 'Выдается пользователям, особо \"отличившимся\" в плане нежелания сидировать.', 2,
        'medal7.gif', 131),
       (4, 1, 4, 'Душа компании',
        'Выдается общительным пользователям, поддерживающим на трекере дружественную атмосферу.', 2, 'smail.gif', 0),
       (5, 2, 5, '100 релизов', 'Выдается за 100 оформленных релизов.', 2, '100rel.gif', 78),
       (6, 2, 6, '250 релизов', 'Выдается за 250 оформленных релизов.', 2, '250rel.gif', 49),
       (7, 2, 7, '500 релизов', 'Выдается за 500 оформленных релизов.', 2, '500rel.gif', 31),
       (21, 1, 0, 'Образцовый модератор',
        'Выдается хорошо себя зарекомендовавшим в управлении своим разделом модераторам.', 2, 'medal11.gif', 3),
       (20, 1, 0, 'Донор', 'Выдается за добровольное пожертвование на сумму более 1000 руб.', 2, 'donor.gif', 71),
       (19, 1, 0, 'Китайская грамота',
        'Выдается любителям пЕсать кАменты, а также просить \"дать скОчать рИлиз\" и т.д.', 2, 'chinese.gif', 1),
       (8, 2, 8, '1000 релизов', 'Выдается за 1000 оформленных релизов.', 2, '1000rel.gif', 23),
       (16, 3, 16, '2-е место', 'Выдается за 2-е место в конкурсах (подробности указываются в комментарии).', 2,
        '2nd.gif', 3),
       (17, 3, 17, '3-е место', 'Выдается за 3-е место в конкурсах (подробности указываются в комментарии).', 2,
        '3rd.gif', 2),
       (15, 3, 15, '1-е место', 'Выдается за 1-е место в конкурсах (подробности указываются в комментарии).', 2,
        '1st.gif', 3),
       (12, 2, 11, '10000 сид-бонусов',
        'Выдается за 10000 накопленных сид-бонусов (не отбирается при их использовании).', 2, '10kbonus.gif', 2945),
       (13, 2, 12, '25000 сид-бонусов',
        'Выдается за 25000 накопленных сид-бонусов (не отбирается при их использовании).', 2, '25kbonus.gif', 762),
       (14, 2, 13, '50000 сид-бонусов',
        'Выдается за 50000 накопленных сид-бонусов (не отбирается при их использовании).', 2, '50kbonus.gif', 141),
       (22, 1, 0, 'Всегда на посту', 'Выдается активным модераторам с высоким онлайном.', 2, 'activemoder.gif', 9),
       (23, 1, 0, 'Няка', 'Да-да, няка. И этим все сказано.', 2, 'girl.gif', 1),
       (24, 2, 9, '2000 релизов', 'Выдается за 2000 оформленных релизов. А вам слабо, да?', 2, '2000rel.gif', 11),
       (25, 1, 0, 'Грузит апельсины бочками', 'За регулярное снабжение трекера свежими релизами.', 2,
        'megareleaser.gif', 27),
       (26, 2, 14, '100000 сид-бонусов',
        'Выдается за 100000 накопленных сид-бонусов (не отбирается при их использовани). Слабо?', 2, '100kbonus.gif',
        3),
       (27, 1, 0, 'Крутейший перец', 'Переходящий орден, выдается обладателю первого места по \"крутости\"', 2,
        'coolest.gif', 1),
       (28, 2, 10, '5000 релизов', 'Выдается за 5000 оформленных релизов. А ну-ка догони!', 2, '5000rel.gif', 3),
       (29, 2, 10, '10000 релизов', 'Выдается за 10000 оформленных релизов. Такое под силу только богам!', 2,
        '10000rel.gif', 3);

CREATE TABLE IF NOT EXISTS `bb_awards_categories`
(
    `award_category_id`   int(11)      NOT NULL AUTO_INCREMENT,
    `award_category_name` varchar(255) NOT NULL,
    PRIMARY KEY (`award_category_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

INSERT INTO `bb_awards_categories` (`award_category_id`, `award_category_name`)
VALUES (1, 'Особые достижения'),
       (2, 'Достижения'),
       (3, 'Награды в каком-либо конкурсе');

CREATE TABLE IF NOT EXISTS `bb_award_holders`
(
    `award_hid`    int(11)      NOT NULL AUTO_INCREMENT,
    `award_id`     int(11)      NOT NULL,
    `award_holder` int(11)      NOT NULL,
    `award_reason` varchar(255) NOT NULL,
    `award_time`   int(11)      NOT NULL,
    PRIMARY KEY (`award_hid`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_banlist`
(
    `ban_id`     mediumint(8) unsigned NOT NULL auto_increment,
    `ban_userid` mediumint(8)          NOT NULL default '0',
    `ban_ip`     varchar(32)           NOT NULL default '',
    `ban_email`  varchar(255)          NOT NULL default '',
    PRIMARY KEY (`ban_id`),
    KEY `ban_ip_user_id` (`ban_ip`, `ban_userid`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8
  AUTO_INCREMENT = 1;

CREATE TABLE IF NOT EXISTS `bb_bonus`
(
    `bonus_id`     int(10) NOT NULL AUTO_INCREMENT,
    `bonus_name`   varchar(24)      DEFAULT NULL,
    `bonus_points` int(10) NOT NULL DEFAULT 0,
    `bonus_add`    int(10) NOT NULL DEFAULT 0,
    PRIMARY KEY (`bonus_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

INSERT INTO `bb_bonus` (`bonus_id`, `bonus_name`, `bonus_points`, `bonus_add`)
VALUES (1, 'ГБ аплоада', 150, 2),
       (2, 'ГБ аплоада', 75, 1),
       (3, 'ГБ аплоада', 250, 5),
       (4, 'ГБ аплоада', 350, 10),
       (5, 'ГБ аплоада', 500, 15),
       (6, 'ГБ аплоада', 1000, 35),
       (7, 'ГБ аплоада', 2000, 80),
       (8, 'ГБ аплоада', 3000, 150),
       (9, 'ГБ аплоада', 4000, 200),
       (10, 'ГБ аплоада', 5000, 300);

CREATE TABLE IF NOT EXISTS `bb_bt_dlstatus_main`
(
    `user_id`                mediumint(9)          NOT NULL default '0',
    `topic_id`               mediumint(8) unsigned NOT NULL default '0',
    `user_status`            tinyint(1)            NOT NULL default '0',
    `last_modified_dlstatus` timestamp             NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
    PRIMARY KEY (`user_id`, `topic_id`),
    KEY `topic_id` (`topic_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_bt_dlstatus_new`
(
    `user_id`                mediumint(9)          NOT NULL default '0',
    `topic_id`               mediumint(8) unsigned NOT NULL default '0',
    `user_status`            tinyint(1)            NOT NULL default '0',
    `last_modified_dlstatus` timestamp             NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
    PRIMARY KEY (`user_id`, `topic_id`),
    KEY `topic_id` (`topic_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_bt_dlstatus_mrg`
(
    `user_id`                mediumint(9)          NOT NULL default '0',
    `topic_id`               mediumint(8) unsigned NOT NULL default '0',
    `user_status`            tinyint(1)            NOT NULL default '0',
    `last_modified_dlstatus` timestamp             NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
    KEY `user_topic` (`user_id`, `topic_id`),
    KEY `topic_id` (`topic_id`)
) ENGINE = MRG_MyISAM
  DEFAULT CHARSET = utf8
  UNION = (`bb_bt_dlstatus_main`,`bb_bt_dlstatus_new`);

CREATE TABLE IF NOT EXISTS `bb_bt_dlstatus_snap`
(
    `topic_id`    mediumint(8) unsigned NOT NULL default '0',
    `dl_status`   tinyint(4)            NOT NULL default '0',
    `users_count` smallint(5) unsigned  NOT NULL default '0',
    KEY `topic_id` (`topic_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_bt_last_torstat`
(
    `topic_id`    mediumint(8) unsigned NOT NULL default '0',
    `user_id`     mediumint(9)          NOT NULL default '0',
    `dl_status`   tinyint(1)            NOT NULL default '0',
    `up_add`      bigint(20) unsigned   NOT NULL default '0',
    `down_add`    bigint(20) unsigned   NOT NULL default '0',
    `release_add` bigint(20) unsigned   NOT NULL default '0',
    `bonus_add`   bigint(20) unsigned   NOT NULL default '0',
    `speed_up`    bigint(20) unsigned   NOT NULL default '0',
    `speed_down`  bigint(20) unsigned   NOT NULL default '0',
    PRIMARY KEY USING BTREE (`topic_id`, `user_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_bt_last_userstat`
(
    `user_id`     mediumint(9)        NOT NULL default '0',
    `up_add`      bigint(20) unsigned NOT NULL default '0',
    `down_add`    bigint(20) unsigned NOT NULL default '0',
    `release_add` bigint(20) unsigned NOT NULL default '0',
    `bonus_add`   bigint(20) unsigned NOT NULL default '0',
    `speed_up`    bigint(20) unsigned NOT NULL default '0',
    `speed_down`  bigint(20) unsigned NOT NULL default '0',
    PRIMARY KEY (`user_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_bt_rating`
(
    `attach_id`    mediumint(8) UNSIGNED NOT NULL DEFAULT 0,
    `voter_id`     mediumint(8)          NOT NULL DEFAULT 0,
    `voter_ip`     varchar(32)           NOT NULL,
    `rating_value` tinyint(2) UNSIGNED   NOT NULL DEFAULT 0
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_bt_scrape`
(
    `topic_id`    mediumint(8) UNSIGNED NOT NULL DEFAULT 0,
    `seeders`     mediumint(8) UNSIGNED NOT NULL DEFAULT 0,
    `leechers`    mediumint(8) UNSIGNED NOT NULL DEFAULT 0,
    `scrape_time` int(11)               NOT NULL DEFAULT 0,
    PRIMARY KEY (`topic_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_bt_torhelp`
(
    `user_id`      mediumint(9) NOT NULL default '0',
    `topic_id_csv` text         NOT NULL,
    PRIMARY KEY (`user_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_bt_torrents`
(
    `info_hash`        varbinary(20)         NOT NULL,
    `post_id`          mediumint(8) unsigned NOT NULL default '0',
    `poster_id`        mediumint(9)          NOT NULL default '0',
    `topic_id`         mediumint(8) unsigned NOT NULL default '0',
    `forum_id`         smallint(5) unsigned  NOT NULL default '0',
    `attach_id`        mediumint(8) unsigned NOT NULL default '0',
    `size`             bigint(20) unsigned   NOT NULL default '0',
    `reg_time`         int(11)               NOT NULL default '0',
    `call_seed_time`   int(11)               NOT NULL default '0',
    `complete_count`   mediumint(8) unsigned NOT NULL default '0',
    `seeder_last_seen` int(11)               NOT NULL default '0',
    `tor_status`       tinyint(4)            NOT NULL default '0',
    `checked_user_id`  mediumint(8)          NOT NULL default '0',
    `checked_time`     int(11)               NOT NULL default '0',
    `private`          tinyint(1)            NOT NULL DEFAULT 0,
    PRIMARY KEY (`info_hash`),
    UNIQUE KEY `post_id` (`post_id`),
    UNIQUE KEY `topic_id` (`topic_id`),
    UNIQUE KEY `attach_id` (`attach_id`),
    KEY `reg_time` (`reg_time`),
    KEY `forum_id` (`forum_id`),
    KEY `poster_id` (`poster_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_bt_torstat`
(
    `topic_id`              mediumint(8) unsigned NOT NULL default '0',
    `user_id`               mediumint(9)          NOT NULL default '0',
    `last_modified_torstat` timestamp             NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
    `completed`             tinyint(1)            NOT NULL default '0',
    PRIMARY KEY (`topic_id`, `user_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_bt_tracker`
(
    `peer_hash`     varchar(32) character set utf8 collate utf8_bin NOT NULL default '',
    `topic_id`      mediumint(8) unsigned                           NOT NULL default '0',
    `user_id`       mediumint(9)                                    NOT NULL default '0',
    `ip`            char(8) character set utf8 collate utf8_bin     NOT NULL default '0',
    `port`          smallint(5) unsigned                            NOT NULL default '0',
    `client`        varchar(50)                                              DEFAULT NULL,
    `seeder`        tinyint(1)                                      NOT NULL default '0',
    `releaser`      tinyint(1)                                      NOT NULL default '0',
    `uploaded`      bigint(20) unsigned                             NOT NULL default '0',
    `downloaded`    bigint(20) unsigned                             NOT NULL default '0',
    `remain`        bigint(20) unsigned                             NOT NULL default '0',
    `speed_up`      mediumint(8) unsigned                           NOT NULL default '0',
    `speed_down`    mediumint(8) unsigned                           NOT NULL default '0',
    `up_add`        bigint(20) unsigned                             NOT NULL default '0',
    `down_add`      bigint(20) unsigned                             NOT NULL default '0',
    `update_time`   int(11)                                         NOT NULL default '0',
    `user_vip`      tinyint(1)                                      NOT NULL DEFAULT 0,
    `user_releaser` tinyint(1)                                      NOT NULL DEFAULT 0,
    `user_half_dl`  tinyint(1)                                      NOT NULL DEFAULT 0,
    PRIMARY KEY (`peer_hash`),
    KEY `topic_id` (`topic_id`),
    KEY `user_id` (`user_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_bt_tracker_snap`
(
    `topic_id`     mediumint(8) unsigned NOT NULL default '0',
    `seeders`      mediumint(8) unsigned NOT NULL default '0',
    `leechers`     mediumint(8) unsigned NOT NULL default '0',
    `seeders_ext`  mediumint(8) unsigned NOT NULL default '0',
    `leechers_ext` mediumint(8) unsigned NOT NULL default '0',
    `speed_up`     int(10) unsigned      NOT NULL default '0',
    `speed_down`   int(10) unsigned      NOT NULL default '0',
    PRIMARY KEY (`topic_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_bt_users`
(
    `user_id`              mediumint(9)                                 NOT NULL default '0',
    `auth_key`             char(10) character set utf8 collate utf8_bin NOT NULL default '',
    `u_up_total`           bigint(20) unsigned                          NOT NULL default '0',
    `u_down_total`         bigint(20) unsigned                          NOT NULL default '0',
    `u_up_release`         bigint(20) unsigned                          NOT NULL default '0',
    `u_up_bonus`           bigint(20) unsigned                          NOT NULL default '0',
    `user_bonus`           float(8, 1)                                  NOT NULL DEFAULT 0.0,
    `user_votetime_top`    date                                         NOT NULL DEFAULT '0000-00-00',
    `user_votetime_toptrk` date                                         NOT NULL DEFAULT '0000-00-00',
    PRIMARY KEY (`user_id`),
    UNIQUE KEY `auth_key` (`auth_key`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_bt_user_settings`
(
    `user_id`        mediumint(9) NOT NULL default '0',
    `tor_search_set` text         NOT NULL,
    `last_modified`  int(11)      NOT NULL default '0',
    PRIMARY KEY (`user_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_categories`
(
    `cat_id`    smallint(5) unsigned NOT NULL auto_increment,
    `cat_title` varchar(100)         NOT NULL default '',
    `cat_order` smallint(5) unsigned NOT NULL default '0',
    PRIMARY KEY (`cat_id`),
    KEY `cat_order` (`cat_order`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8
  AUTO_INCREMENT = 2;

INSERT INTO `bb_categories`
VALUES (1, 'Test category 1', 10);

CREATE TABLE IF NOT EXISTS `bb_config`
(
    `config_name`  varchar(255) NOT NULL default '',
    `config_value` text         NOT NULL,
    PRIMARY KEY (`config_name`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

INSERT INTO `bb_config` (`config_name`, `config_value`)
VALUES ('active_ads', 'a:0:{}'),
       ('allow_autologin', '1'),
       ('allow_avatar_local', '1'),
       ('allow_avatar_remote', '0'),
       ('allow_avatar_upload', '1'),
       ('allow_bbcode', '1'),
       ('allow_namechange', '0'),
       ('allow_sig', '1'),
       ('allow_smilies', '1'),
       ('avatar_filesize', '90000'),
       ('avatar_gallery_path', 'images/avatars/gallery'),
       ('avatar_max_height', '120'),
       ('avatar_max_width', '120'),
       ('avatar_path', 'images/avatars'),
       ('birthday_check_day', '7'),
       ('birthday_greeting', '0'),
       ('birthday_required', '0'),
       ('board_disable', '0'),
       ('board_email', 'board_email@yourdomain.com'),
       ('board_email_form', '0'),
       ('board_email_sig', 'Thanks, The Management'),
       ('gauge_1', '100'),
       ('gauge_3', '0'),
       ('gauge_4', '0'),
       ('gauge_5', '0'),
       ('board_startdate', '1211477514'),
       ('board_timezone', '0'),
       ('bt_add_auth_key', '1'),
       ('bt_add_comment', ''),
       ('bt_add_publisher', 'YourSiteName'),
       ('bt_allow_spmode_change', '1'),
       ('bt_announce_url', 'http://yourdomain.com/bt/announce.php'),
       ('bt_check_announce_url', '0'),
       ('bt_del_addit_ann_urls', '1'),
       ('bt_dl_list_only_1st_page', '1'),
       ('bt_dl_list_only_count', '1'),
       ('bt_gen_passkey_on_reg', '1'),
       ('bt_newtopic_auto_reg', '1'),
       ('bt_replace_ann_url', '1'),
       ('bt_search_bool_mode', '1'),
       ('bt_set_dltype_on_tor_reg', '1'),
       ('bt_show_dl_but_cancel', '1'),
       ('bt_show_dl_but_compl', '1'),
       ('bt_show_dl_but_down', '0'),
       ('bt_show_dl_but_will', '1'),
       ('bt_show_dl_list', '0'),
       ('bt_show_dl_list_buttons', '1'),
       ('bt_show_dl_stat_on_index', '1'),
       ('bt_show_ip_only_moder', '1'),
       ('bt_show_peers', '1'),
       ('bt_show_peers_mode', '1'),
       ('bt_show_port_only_moder', '1'),
       ('bt_tor_browse_only_reg', '0'),
       ('bt_unset_dltype_on_tor_unreg', '0'),
       ('config_id', '1'),
       ('coppa_fax', ''),
       ('coppa_mail', ''),
       ('cron_last_check', '1612486762'),
       ('default_dateformat', 'd.m.Y H:i'),
       ('default_lang', 'russian'),
       ('enable_confirm', '1'),
       ('flood_interval', '15'),
       ('hot_threshold', '300'),
       ('login_reset_time', '30'),
       ('max_autologin_time', '180'),
       ('max_inbox_privmsgs', '200'),
       ('max_login_attempts', '5'),
       ('max_poll_options', '50'),
       ('max_savebox_privmsgs', '50'),
       ('max_sentbox_privmsgs', '25'),
       ('max_sig_chars', '900'),
       ('max_user_age', '100'),
       ('min_user_age', '5'),
       ('posts_per_page', '15'),
       ('privmsg_disable', '0'),
       ('prune_enable', '1'),
       ('record_online_date', '1444148396'),
       ('record_online_users', '4420'),
       ('report_hack_count', '85'),
       ('report_list_admin', '0'),
       ('report_modules_cache', '1'),
       ('report_new_window', '1'),
       ('report_notify', '0'),
       ('report_subject_auth', '1'),
       ('require_activation', '0'),
       ('sendmail_fix', '1'),
       ('sitename', 'yourdomain.com'),
       ('site_desc', 'A _little_ text to describe your forum'),
       ('smilies_path', 'images/smiles'),
       ('smtp_delivery', '0'),
       ('smtp_host', ''),
       ('smtp_password', ''),
       ('smtp_username', ''),
       ('topics_per_page', '50'),
       ('tp_release_date', '2008-12-31'),
       ('tp_release_state', 'svn beta'),
       ('tp_version', '1.0.1.0'),
       ('version', '.0.22'),
       ('xs_add_comments', '0'),
       ('xs_auto_compile', '1'),
       ('xs_auto_recompile', '1'),
       ('xs_php', 'php'),
       ('xs_shownav', '17'),
       ('xs_template_time', '0'),
       ('xs_use_cache', '1'),
       ('xs_version', '8'),
       ('gauge_2', '0'),
       ('gauge_6', '0'),
       ('gauge_7', '0');

CREATE TABLE IF NOT EXISTS `bb_confirm`
(
    `confirm_id` char(12) character set utf8 collate utf8_bin NOT NULL default '',
    `session_id` char(20) character set utf8 collate utf8_bin NOT NULL default '',
    `code`       char(6)                                      NOT NULL default '',
    PRIMARY KEY (`session_id`, `confirm_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_countries`
(
    `country_id`    mediumint(3) NOT NULL auto_increment,
    `country_code`  varchar(3)   NOT NULL default '0',
    `country_code2` varchar(2)   NOT NULL,
    `country_code3` varchar(3)   NOT NULL,
    PRIMARY KEY (`country_id`),
    KEY `country_code2` (`country_code2`),
    KEY `country_code3` (`country_code3`),
    KEY `country_code` (`country_code`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8
  AUTO_INCREMENT = 245;

INSERT INTO `bb_countries` (`country_id`, `country_code`, `country_code2`, `country_code3`)
VALUES (1, '036', 'AU', 'AUS'),
       (2, '040', 'AT', 'AUT'),
       (3, '031', 'AZ', 'AZE'),
       (4, '248', 'AX', 'ALA'),
       (5, '008', 'AL', 'ALB'),
       (6, '012', 'DZ', 'DZA'),
       (7, '581', 'UM', 'UMI'),
       (8, '850', 'VI', 'VIR'),
       (9, '016', 'AS', 'ASM'),
       (10, '660', 'AI', 'AIA'),
       (11, '024', 'AO', 'AGO'),
       (12, '020', 'AD', 'AND'),
       (13, '010', 'AQ', 'ATA'),
       (14, '028', 'AG', 'ATG'),
       (15, '032', 'AR', 'ARG'),
       (16, '051', 'AM', 'ARM'),
       (17, '533', 'AW', 'ABW'),
       (18, '004', 'AF', 'AFG'),
       (19, '044', 'BS', 'BHS'),
       (20, '050', 'BD', 'BGD'),
       (21, '052', 'BB', 'BRB'),
       (22, '048', 'BH', 'BHR'),
       (23, '084', 'BZ', 'BLZ'),
       (24, '112', 'BY', 'BLR'),
       (25, '056', 'BE', 'BEL'),
       (26, '204', 'BJ', 'BEN'),
       (27, '060', 'BM', 'BMU'),
       (28, '100', 'BG', 'BGR'),
       (29, '068', 'BO', 'BOL'),
       (30, '070', 'BA', 'BIH'),
       (31, '072', 'BW', 'BWA'),
       (32, '076', 'BR', 'BRA'),
       (33, '086', 'IO', 'IOT'),
       (34, '092', 'VG', 'VGB'),
       (35, '096', 'BN', 'BRN'),
       (36, '854', 'BF', 'BFA'),
       (37, '108', 'BI', 'BDI'),
       (38, '064', 'BT', 'BTN'),
       (39, '548', 'VU', 'VUT'),
       (40, '336', 'VA', 'VAT'),
       (41, '826', 'GB', 'GBR'),
       (42, '348', 'HU', 'HUN'),
       (43, '862', 'VE', 'VEN'),
       (44, '626', 'TL', 'TLS'),
       (45, '704', 'VN', 'VNM'),
       (46, '266', 'GA', 'GAB'),
       (47, '332', 'HT', 'HTI'),
       (48, '328', 'GY', 'GUY'),
       (49, '270', 'GM', 'GMB'),
       (50, '288', 'GH', 'GHA'),
       (51, '312', 'GP', 'GLP'),
       (52, '320', 'GT', 'GTM'),
       (53, '324', 'GN', 'GIN'),
       (54, '624', 'GW', 'GNB'),
       (55, '276', 'DE', 'DEU'),
       (56, '292', 'GI', 'GIB'),
       (57, '340', 'HN', 'HND'),
       (58, '344', 'HK', 'HKG'),
       (59, '308', 'GD', 'GRD'),
       (60, '304', 'GL', 'GRL'),
       (61, '300', 'GR', 'GRC'),
       (62, '268', 'GE', 'GEO'),
       (63, '316', 'GU', 'GUM'),
       (64, '208', 'DK', 'DNK'),
       (65, '180', 'CD', 'COD'),
       (66, '262', 'DJ', 'DJI'),
       (67, '212', 'DM', 'DMA'),
       (68, '214', 'DO', 'DOM'),
       (69, 'EU', 'EU', ''),
       (70, '818', 'EG', 'EGY'),
       (71, '894', 'ZM', 'ZMB'),
       (72, '732', 'EH', 'ESH'),
       (73, '716', 'ZW', 'ZWE'),
       (74, '376', 'IL', 'ISR'),
       (75, '356', 'IN', 'IND'),
       (76, '360', 'ID', 'IDN'),
       (77, '400', 'JO', 'JOR'),
       (78, '368', 'IQ', 'IRQ'),
       (79, '364', 'IR', 'IRN'),
       (80, '372', 'IE', 'IRL'),
       (81, '352', 'IS', 'ISL'),
       (82, '724', 'ES', 'ESP'),
       (83, '380', 'IT', 'ITA'),
       (84, '887', 'YE', 'YEM'),
       (85, '408', 'KP', 'PRK'),
       (86, '132', 'CV', 'CPV'),
       (87, '398', 'KZ', 'KAZ'),
       (88, '136', 'KY', 'CYM'),
       (89, '116', 'KH', 'KHM'),
       (90, '120', 'CM', 'CMR'),
       (91, '124', 'CA', 'CAN'),
       (92, '634', 'QA', 'QAT'),
       (93, '404', 'KE', 'KEN'),
       (94, '196', 'CY', 'CYP'),
       (95, '417', 'KG', 'KGZ'),
       (96, '296', 'KI', 'KIR'),
       (97, '156', 'CN', 'CHN'),
       (98, '166', 'CC', 'CCK'),
       (99, '170', 'CO', 'COL'),
       (100, '174', 'KM', 'COM'),
       (101, '188', 'CR', 'CRI'),
       (102, '384', 'CI', 'CIV'),
       (103, '192', 'CU', 'CUB'),
       (104, '414', 'KW', 'KWT'),
       (105, '418', 'LA', 'LAO'),
       (106, '428', 'LV', 'LVA'),
       (107, '426', 'LS', 'LSO'),
       (108, '430', 'LR', 'LBR'),
       (109, '422', 'LB', 'LBN'),
       (110, '434', 'LY', 'LBY'),
       (111, '440', 'LT', 'LTU'),
       (112, '438', 'LI', 'LIE'),
       (113, '442', 'LU', 'LUX'),
       (114, '480', 'MU', 'MUS'),
       (115, '478', 'MR', 'MRT'),
       (116, '450', 'MG', 'MDG'),
       (117, '175', 'YT', 'MYT'),
       (118, '446', 'MO', 'MAC'),
       (119, '807', 'MK', 'MKD'),
       (120, '454', 'MW', 'MWI'),
       (121, '458', 'MY', 'MYS'),
       (122, '466', 'ML', 'MLI'),
       (123, '462', 'MV', 'MDV'),
       (124, '470', 'MT', 'MLT'),
       (125, '504', 'MA', 'MAR'),
       (126, '474', 'MQ', 'MTQ'),
       (127, '584', 'MH', 'MHL'),
       (128, '484', 'MX', 'MEX'),
       (129, '508', 'MZ', 'MOZ'),
       (130, '498', 'MD', 'MDA'),
       (131, '492', 'MC', 'MCO'),
       (132, '496', 'MN', 'MNG'),
       (133, '500', 'MS', 'MSR'),
       (134, '104', 'MM', 'MMR'),
       (135, '516', 'NA', 'NAM'),
       (136, '520', 'NR', 'NRU'),
       (137, '524', 'NP', 'NPL'),
       (138, '562', 'NE', 'NER'),
       (139, '566', 'NG', 'NGA'),
       (140, '530', 'AN', 'ANT'),
       (141, '528', 'NL', 'NLD'),
       (142, '558', 'NI', 'NIC'),
       (143, '570', 'NU', 'NIU'),
       (144, '540', 'NC', 'NCL'),
       (145, '554', 'NZ', 'NZL'),
       (146, '578', 'NO', 'NOR'),
       (147, '784', 'AE', 'ARE'),
       (148, '512', 'OM', 'OMN'),
       (149, '162', 'CX', 'CXR'),
       (150, '184', 'CK', 'COK'),
       (151, '334', 'HM', 'HMD'),
       (152, '586', 'PK', 'PAK'),
       (153, '585', 'PW', 'PLW'),
       (154, '275', 'PS', 'PSE'),
       (155, '591', 'PA', 'PAN'),
       (156, '598', 'PG', 'PNG'),
       (157, '600', 'PY', 'PRY'),
       (158, '604', 'PE', 'PER'),
       (159, '612', 'PN', 'PCN'),
       (160, '616', 'PL', 'POL'),
       (161, '620', 'PT', 'PRT'),
       (162, '630', 'PR', 'PRI'),
       (163, '178', 'CG', 'COG'),
       (164, '638', 'RE', 'REU'),
       (165, '643', 'RU', 'RUS'),
       (166, '646', 'RW', 'RWA'),
       (167, '642', 'RO', 'ROU'),
       (168, '840', 'US', 'USA'),
       (169, '222', 'SV', 'SLV'),
       (170, '882', 'WS', 'WSM'),
       (171, '674', 'SM', 'SMR'),
       (172, '678', 'ST', 'STP'),
       (173, '682', 'SA', 'SAU'),
       (174, '748', 'SZ', 'SWZ'),
       (175, '744', 'SJ', 'SJM'),
       (176, '580', 'MP', 'MNP'),
       (177, '690', 'SC', 'SYC'),
       (178, '686', 'SN', 'SEN'),
       (179, '670', 'VC', 'VCT'),
       (180, '659', 'KN', 'KNA'),
       (181, '662', 'LC', 'LCA'),
       (182, '666', 'PM', 'SPM'),
       (183, '688', 'RS', 'SRB'),
       (184, '891', 'CS', 'SCG'),
       (185, '702', 'SG', 'SGP'),
       (186, '760', 'SY', 'SYR'),
       (187, '703', 'SK', 'SVK'),
       (188, '705', 'SI', 'SVN'),
       (189, '090', 'SB', 'SLB'),
       (190, '706', 'SO', 'SOM'),
       (191, '736', 'SD', 'SDN'),
       (192, '740', 'SR', 'SUR'),
       (193, '694', 'SL', 'SLE'),
       (194, '810', 'SU', 'SUN'),
       (195, '762', 'TJ', 'TJK'),
       (196, '764', 'TH', 'THA'),
       (197, '158', 'TW', 'TWN'),
       (198, '834', 'TZ', 'TZA'),
       (199, '768', 'TG', 'TGO'),
       (200, '772', 'TK', 'TKL'),
       (201, '776', 'TO', 'TON'),
       (202, '780', 'TT', 'TTO'),
       (203, '798', 'TV', 'TUV'),
       (204, '788', 'TN', 'TUN'),
       (205, '795', 'TM', 'TKM'),
       (206, '792', 'TR', 'TUR'),
       (207, '800', 'UG', 'UGA'),
       (208, '860', 'UZ', 'UZB'),
       (209, '804', 'UA', 'UKR'),
       (210, '858', 'UY', 'URY'),
       (211, '234', 'FO', 'FRO'),
       (212, '583', 'FM', 'FSM'),
       (213, '242', 'FJ', 'FJI'),
       (214, '608', 'PH', 'PHL'),
       (215, '246', 'FI', 'FIN'),
       (216, '238', 'FK', 'FLK'),
       (217, '250', 'FR', 'FRA'),
       (218, '254', 'GF', 'GUF'),
       (219, '258', 'PF', 'PYF'),
       (220, '260', 'TF', 'ATF'),
       (221, '191', 'HR', 'HRV'),
       (222, '140', 'CF', 'CAF'),
       (223, '148', 'TD', 'TCD'),
       (224, '499', 'ME', 'MNE'),
       (225, '203', 'CZ', 'CZE'),
       (226, '152', 'CL', 'CHL'),
       (227, '756', 'CH', 'CHE'),
       (228, '752', 'SE', 'SWE'),
       (229, '144', 'LK', 'LKA'),
       (230, '218', 'EC', 'ECU'),
       (231, '226', 'GQ', 'GNQ'),
       (232, '232', 'ER', 'ERI'),
       (233, '233', 'EE', 'EST'),
       (234, '231', 'ET', 'ETH'),
       (235, '710', 'ZA', 'ZAF'),
       (236, '410', 'KR', 'KOR'),
       (237, '239', 'GS', 'SGS'),
       (238, '388', 'JM', 'JAM'),
       (239, '392', 'JP', 'JPN'),
       (240, '074', 'BV', 'BVT'),
       (241, '574', 'NF', 'NFK'),
       (242, '654', 'SH', 'SHN'),
       (243, '796', 'TC', 'TCA'),
       (244, '876', 'WF', 'WLF');

CREATE TABLE IF NOT EXISTS `bb_cron`
(
    `cron_id`         smallint(5) unsigned                                  NOT NULL auto_increment,
    `cron_active`     tinyint(4)                                            NOT NULL                                                                            default '1',
    `cron_title`      char(120)                                             NOT NULL                                                                            default '',
    `cron_script`     char(120)                                             NOT NULL                                                                            default '',
    `schedule`        enum ('hourly','daily','weekly','monthly','interval') NOT NULL                                                                            default 'daily',
    `run_day`         enum ('1','2','3','4','5','6','7','8','9','10','11','12','13','14','15','16','17','18','19','20','21','22','23','24','25','26','27','28') default NULL,
    `run_time`        time                                                                                                                                      default '04:00:00',
    `run_order`       tinyint(4) unsigned                                   NOT NULL,
    `last_run`        datetime                                              NOT NULL                                                                            default '0000-00-00 00:00:00',
    `next_run`        datetime                                              NOT NULL                                                                            default '0000-00-00 00:00:00',
    `run_interval`    time                                                                                                                                      default NULL,
    `log_enabled`     tinyint(1)                                            NOT NULL                                                                            default '0',
    `log_file`        char(120)                                             NOT NULL                                                                            default '',
    `log_sql_queries` tinyint(4)                                            NOT NULL                                                                            default '0',
    `disable_board`   tinyint(1)                                            NOT NULL                                                                            default '0',
    `run_counter`     bigint(20) unsigned                                   NOT NULL                                                                            default '0',
    PRIMARY KEY (`cron_id`),
    UNIQUE KEY `title` (`cron_title`),
    UNIQUE KEY `script` (`cron_script`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

INSERT INTO `bb_cron` (`cron_id`, `cron_active`, `cron_title`, `cron_script`, `schedule`, `run_day`, `run_time`,
                       `run_order`, `last_run`, `next_run`, `run_interval`, `log_enabled`, `log_file`,
                       `log_sql_queries`, `disable_board`, `run_counter`)
VALUES (1, 0, 'Site backup', 'site_backup.php', 'daily', '1', '05:00:00', 10, '0000-00-00 00:00:00',
        '0000-00-00 00:00:00', NULL, 1, '', 0, 1, 0),
       (2, 0, 'DB backup', 'db_backup.php', 'daily', '1', '05:00:00', 20, '0000-00-00 00:00:00', '0000-00-00 00:00:00',
        NULL, 1, '', 0, 1, 0),
       (3, 1, 'Avatars cleanup', 'avatars_cleanup.php', 'weekly', '1', '05:00:00', 30, '2021-02-01 05:01:27',
        '2021-02-08 05:00:00', NULL, 1, '', 0, 1, 628),
       (4, 1, 'Board maintenance', 'bb_maintenance.php', 'daily', '', '05:00:00', 40, '2021-02-04 05:00:49',
        '2021-02-05 05:00:00', '00:00:00', 1, '', 0, 1, 4375),
       (5, 1, 'Prune forums', 'prune_forums.php', 'daily', NULL, '05:00:00', 50, '2021-02-04 05:00:52',
        '2021-02-05 05:00:00', NULL, 1, '', 0, 1, 4375),
       (6, 1, 'Prune topic moved stubs', 'prune_topic_moved.php', 'daily', NULL, '05:00:00', 60, '2021-02-04 05:00:55',
        '2021-02-05 05:00:00', NULL, 1, '', 0, 1, 4375),
       (7, 1, 'Logs cleanup', 'clean_log.php', 'daily', NULL, '05:00:00', 70, '2021-02-04 05:00:58',
        '2021-02-05 05:00:00', NULL, 1, '', 0, 1, 4375),
       (8, 1, 'Tracker maintenance', 'tr_maintenance.php', 'daily', NULL, '05:00:00', 90, '2021-02-04 05:01:01',
        '2021-02-05 05:00:00', NULL, 1, '', 0, 1, 4375),
       (9, 1, 'Clean dlstat', 'clean_dlstat.php', 'daily', NULL, '05:00:00', 100, '2021-02-04 05:01:42',
        '2021-02-05 05:00:00', NULL, 1, '', 0, 1, 4375),
       (10, 1, 'Prune inactive users', 'prune_inactive_users.php', 'daily', NULL, '05:00:00', 110,
        '2021-02-04 05:01:46', '2021-02-05 05:00:00', NULL, 1, '', 0, 1, 4375),
       (11, 1, 'Sessions cleanup', 'sessions_cleanup.php', 'interval', NULL, NULL, 255, '2021-02-05 03:57:12',
        '2021-02-05 04:00:12', '00:03:00', 0, '', 0, 0, 1460918),
       (12, 1, 'DS update \'cat_forums\'', 'ds_update_cat_forums.php', 'interval', NULL, NULL, 255,
        '2021-02-05 03:57:15', '2021-02-05 04:02:15', '00:05:00', 0, '', 0, 0, 925592),
       (13, 1, 'DS update \'stats\'', 'ds_update_stats.php', 'interval', NULL, NULL, 255, '2021-02-05 03:57:19',
        '2021-02-05 04:07:19', '00:10:00', 0, '', 0, 0, 493869),
       (14, 1, 'Flash topic view', 'flash_topic_view.php', 'interval', NULL, NULL, 255, '2021-02-05 03:57:22',
        '2021-02-05 04:07:22', '00:10:00', 0, '', 0, 0, 493699),
       (15, 1, 'Clean search results', 'clean_search_results.php', 'interval', NULL, NULL, 255, '2021-02-05 03:53:11',
        '2021-02-05 04:03:11', '00:10:00', 0, '', 0, 0, 493575),
       (16, 1, 'Tracker cleanup and dlstat', 'tr_cleanup_and_dlstat.php', 'interval', NULL, NULL, 20,
        '2021-02-05 03:59:03', '2021-02-05 04:14:03', '00:15:00', 0, '', 0, 0, 373980),
       (17, 1, 'Make tracker snapshot', 'tr_make_snapshot.php', 'interval', NULL, NULL, 10, '2021-02-05 03:57:04',
        '2021-02-05 04:07:04', '00:10:00', 0, '', 0, 0, 558585),
       (18, 1, 'Seeder last seen', 'tr_update_seeder_last_seen.php', 'interval', NULL, NULL, 255, '2021-02-05 03:09:21',
        '2021-02-05 04:09:21', '01:00:00', 0, '', 0, 0, 100239),
       (19, 1, 'Clean torrents search options', 'clean_tor_search_options.php', 'interval', NULL, NULL, 255,
        '2021-02-05 00:27:21', '2021-02-05 06:27:21', '06:00:00', 0, '', 0, 0, 17344),
       (20, 1, 'Tracker dl-complete count', 'tr_complete_count.php', 'interval', NULL, NULL, 255, '2021-02-05 00:33:13',
        '2021-02-05 06:33:13', '06:00:00', 0, '', 0, 0, 17339),
       (21, 1, 'Cache garbage collector', 'cache_gc.php', 'interval', NULL, NULL, 255, '2021-02-05 03:59:06',
        '2021-02-05 04:04:06', '00:05:00', 0, '', 0, 0, 924634),
       (22, 0, 'Birthday update', 'ds_update_birthday.php', 'daily', '', '04:05:00', 120, '2019-10-27 04:06:17',
        '2019-10-28 04:05:00', '00:00:00', 1, '', 0, 1, 3941),
       (23, 1, 'Update medal/pozor', 'ds_update_medal.php', 'daily', '', '06:00:00', 255, '2021-02-04 06:01:07',
        '2021-02-05 06:00:00', '00:00:00', 1, '', 0, 0, 4333),
       (24, 1, 'Update user seed bonuses (bubliks)', 'tr_bonus_add.php', 'interval', '', '00:00:00', 255,
        '2021-02-05 03:59:09', '2021-02-05 04:59:09', '01:00:00', 1, '', 0, 0, 96396),
       (25, 1, 'Update untrusted IPs (anti-brute)', 'bb_manage_untrusted.php', 'interval', '', '00:00:00', 255,
        '2021-02-05 03:55:03', '2021-02-05 04:00:03', '00:05:00', 0, '', 0, 0, 901821),
       (26, 1, 'Warnings & Bans Maintenance', 'bb_expire_warn.php', 'interval', '', '00:00:00', 255,
        '2021-02-05 03:55:06', '2021-02-05 04:00:06', '00:05:00', 0, '', 0, 0, 855625),
       (27, 0, 'Export XML releases', 'bb_export_xml.php', 'hourly', '', '00:00:00', 255, '2019-10-29 21:28:23',
        '2019-10-29 22:28:23', '00:00:00', 1, '', 0, 0, 76083),
       (28, 0, 'Update Counter-Strike stats', 'ds_update_cstrike_stats.php', 'interval', '', '12:48:00', 255,
        '2016-11-22 18:22:39', '2016-11-22 18:23:39', '00:01:00', 0, '', 0, 0, 214404);

CREATE TABLE IF NOT EXISTS `bb_datastore`
(
    `ds_title` varchar(255) NOT NULL default '',
    `ds_data`  longtext     NOT NULL,
    PRIMARY KEY (`ds_title`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_disallow`
(
    `disallow_id`       mediumint(8) unsigned NOT NULL auto_increment,
    `disallow_username` varchar(25)           NOT NULL default '',
    PRIMARY KEY (`disallow_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8
  AUTO_INCREMENT = 1;

CREATE TABLE IF NOT EXISTS `bb_extensions`
(
    `ext_id`    mediumint(8) unsigned NOT NULL auto_increment,
    `group_id`  mediumint(8) unsigned NOT NULL default '0',
    `extension` varchar(100)          NOT NULL default '',
    `comment`   varchar(100)          NOT NULL default '',
    PRIMARY KEY (`ext_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8
  AUTO_INCREMENT = 31;

INSERT INTO `bb_extensions` (`ext_id`, `group_id`, `extension`, `comment`)
VALUES (1, 1, 'gif', ''),
       (2, 1, 'png', ''),
       (3, 1, 'jpeg', ''),
       (4, 1, 'jpg', ''),
       (5, 1, 'tif', ''),
       (6, 1, 'tga', ''),
       (7, 2, 'gtar', ''),
       (8, 2, 'gz', ''),
       (9, 2, 'tar', ''),
       (10, 2, 'zip', ''),
       (11, 2, 'rar', ''),
       (12, 2, 'ace', ''),
       (13, 3, 'txt', ''),
       (14, 3, 'c', ''),
       (15, 3, 'h', ''),
       (16, 3, 'cpp', ''),
       (17, 3, 'hpp', ''),
       (18, 3, 'diz', ''),
       (19, 4, 'xls', ''),
       (20, 4, 'doc', ''),
       (21, 4, 'dot', ''),
       (22, 4, 'pdf', ''),
       (23, 4, 'ai', ''),
       (24, 4, 'ps', ''),
       (25, 4, 'ppt', ''),
       (26, 5, 'rm', ''),
       (27, 6, 'wma', ''),
       (28, 7, 'swf', ''),
       (29, 8, 'torrent', ''),
       (30, 2, 'exe', '');

CREATE TABLE IF NOT EXISTS `bb_extension_groups`
(
    `group_id`          mediumint(8)        NOT NULL auto_increment,
    `group_name`        varchar(20)         NOT NULL default '',
    `cat_id`            tinyint(2)          NOT NULL default '0',
    `allow_group`       tinyint(1)          NOT NULL default '0',
    `download_mode`     tinyint(1) unsigned NOT NULL default '1',
    `upload_icon`       varchar(100)        NOT NULL default '',
    `max_filesize`      int(20)             NOT NULL default '0',
    `forum_permissions` text                NOT NULL,
    PRIMARY KEY (`group_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8
  AUTO_INCREMENT = 9;

INSERT INTO `bb_extension_groups` (`group_id`, `group_name`, `cat_id`, `allow_group`, `download_mode`, `upload_icon`,
                                   `max_filesize`, `forum_permissions`)
VALUES (1, 'Images', 1, 1, 1, '', 20971520, ''),
       (2, 'Archives', 0, 1, 1, '', 20971520, ''),
       (3, 'Plain Text', 0, 0, 1, '', 20971520, ''),
       (4, 'Documents', 0, 0, 1, '', 20971520, ''),
       (5, 'Real Media', 0, 0, 2, '', 20971520, ''),
       (6, 'Streams', 2, 0, 1, '', 20971520, ''),
       (7, 'Flash Files', 3, 0, 1, '', 20971520, ''),
       (8, 'Torrent', 0, 1, 1, '', 3145728, '');

CREATE TABLE IF NOT EXISTS `bb_files_priv`
(
    `id`              int(11)      NOT NULL,
    `poster_id`       mediumint(8) NOT NULL DEFAULT 0,
    `file_name`       varchar(255) NOT NULL DEFAULT '',
    `file_source`     varchar(255) NOT NULL DEFAULT '',
    `file_time`       int(11)      NOT NULL DEFAULT 0,
    `user_ip_address` varchar(255) NOT NULL DEFAULT '',
    PRIMARY KEY (`id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_forums`
(
    `forum_id`              smallint(5) unsigned  NOT NULL auto_increment,
    `cat_id`                smallint(5) unsigned  NOT NULL default '0',
    `forum_name`            varchar(150)          NOT NULL default '',
    `forum_desc`            text                  NOT NULL,
    `forum_annotation_html` text                  NOT NULL,
    `forum_status`          tinyint(4)            NOT NULL default '0',
    `forum_order`           smallint(5) unsigned  NOT NULL default '1',
    `forum_posts`           mediumint(8) unsigned NOT NULL default '0',
    `forum_topics`          mediumint(8) unsigned NOT NULL default '0',
    `forum_last_post_id`    mediumint(8) unsigned NOT NULL default '0',
    `prune_days`            smallint(5) unsigned  NOT NULL default '0',
    `auth_view`             tinyint(2)            NOT NULL default '0',
    `auth_read`             tinyint(2)            NOT NULL default '0',
    `auth_post`             tinyint(2)            NOT NULL default '0',
    `auth_reply`            tinyint(2)            NOT NULL default '0',
    `auth_edit`             tinyint(2)            NOT NULL default '0',
    `auth_delete`           tinyint(2)            NOT NULL default '0',
    `auth_sticky`           tinyint(2)            NOT NULL default '0',
    `auth_announce`         tinyint(2)            NOT NULL default '0',
    `auth_vote`             tinyint(2)            NOT NULL default '0',
    `auth_pollcreate`       tinyint(2)            NOT NULL default '0',
    `auth_attachments`      tinyint(2)            NOT NULL default '0',
    `auth_download`         tinyint(2)            NOT NULL default '0',
    `allow_reg_tracker`     tinyint(1)            NOT NULL default '0',
    `allow_dl_topic`        tinyint(1)            NOT NULL default '0',
    `self_moderated`        tinyint(1)            NOT NULL default '0',
    `forum_parent`          smallint(5) unsigned  NOT NULL default '0',
    `show_on_index`         tinyint(1)            NOT NULL default '1',
    `show_on_index_guest`   tinyint(1)            NOT NULL DEFAULT '1',
    `forum_display_sort`    tinyint(1)            NOT NULL default '0',
    `forum_display_order`   tinyint(1)            NOT NULL default '0',
    `topic_tpl_id`          smallint(6)           NOT NULL default '0',
    `forum_icon`            varchar(128)          NOT NULL DEFAULT '',
    `forum_icon_new`        varchar(128)          NOT NULL DEFAULT '',
    `forum_icon_locked`     varchar(128)          NOT NULL DEFAULT '',
    `forum_archive`         tinyint(1)            NOT NULL DEFAULT 0,
    PRIMARY KEY (`forum_id`),
    KEY `forums_order` (`forum_order`),
    KEY `cat_id` (`cat_id`),
    KEY `forum_last_post_id` (`forum_last_post_id`),
    KEY `forum_parent` (`forum_parent`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_forums_watch`
(
    `forum_id`      mediumint(8) UNSIGNED NOT NULL DEFAULT 0,
    `user_id`       mediumint(8)          NOT NULL DEFAULT 0,
    `notify_status` tinyint(1)            NOT NULL DEFAULT 0,
    KEY `forum_id` (`forum_id`) USING BTREE,
    KEY `user_id` (`user_id`) USING BTREE,
    KEY `notify_status` (`notify_status`) USING BTREE
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_groups`
(
    `group_id`          mediumint(8) NOT NULL auto_increment,
    `group_type`        tinyint(4)   NOT NULL default '1',
    `group_name`        varchar(40)  NOT NULL default '',
    `group_description` varchar(255) NOT NULL default '',
    `group_moderator`   mediumint(8) NOT NULL default '0',
    `group_single_user` tinyint(1)   NOT NULL default '1',
    `group_vip`         tinyint(1)   NOT NULL DEFAULT '0',
    `group_releaser`    tinyint(1)   NOT NULL DEFAULT '0',
    `group_half_dl`     tinyint(1)   NOT NULL DEFAULT '0',
    `group_color`       varchar(7)   NOT NULL DEFAULT '',
    `group_rank`        smallint(5)  NOT NULL DEFAULT '0',
    PRIMARY KEY (`group_id`),
    KEY `group_single_user` (`group_single_user`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8
  AUTO_INCREMENT = 1;

CREATE TABLE IF NOT EXISTS `bb_log`
(
    `log_type_id`         mediumint(8) unsigned                           NOT NULL default '0',
    `log_user_id`         mediumint(9)                                    NOT NULL default '0',
    `log_username`        varchar(25)                                     NOT NULL default '',
    `log_user_ip`         varchar(32) character set utf8 collate utf8_bin NOT NULL default '',
    `log_forum_id`        smallint(5) unsigned                            NOT NULL default '0',
    `log_forum_id_new`    smallint(5) unsigned                            NOT NULL default '0',
    `log_topic_id`        mediumint(8) unsigned                           NOT NULL default '0',
    `log_topic_id_new`    mediumint(8) unsigned                           NOT NULL default '0',
    `log_topic_title`     varchar(250)                                    NOT NULL default '',
    `log_topic_title_new` varchar(250)                                    NOT NULL default '',
    `log_time`            int(11)                                         NOT NULL default '0',
    `log_msg`             text                                            NOT NULL,
    KEY `log_time` (`log_time`),
    FULLTEXT KEY `log_topic_title` (`log_topic_title`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_order`
(
    `order_id`                int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
    `order_forum_id`          smallint(5)      NOT NULL DEFAULT 0,
    `order_name`              text                      DEFAULT NULL,
    `order_desc`              text                      DEFAULT NULL,
    `order_time`              int(11)          NOT NULL,
    `order_user_performed_id` int(1)           NOT NULL DEFAULT 0,
    `order_topic_id`          mediumint(8)     NOT NULL DEFAULT 0,
    `order_yes`               int(1)           NOT NULL DEFAULT 0,
    `order_user_id`           int(10)          NOT NULL DEFAULT 0,
    `order_vote`              int(10)          NOT NULL DEFAULT 0,
    `order_abuse`             int(1)           NOT NULL DEFAULT 0,
    PRIMARY KEY (`order_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_order_comment`
(
    `comment_id`      int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
    `order_id`        int(10) UNSIGNED NOT NULL,
    `comment`         text                      DEFAULT NULL,
    `comment_time`    int(11)          NOT NULL,
    `comment_user_id` int(10)          NOT NULL DEFAULT 0,
    PRIMARY KEY (`comment_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_photos`
(
    `photo_id`   mediumint(9) UNSIGNED NOT NULL AUTO_INCREMENT,
    `poster_id`  mediumint(8) UNSIGNED NOT NULL DEFAULT 0,
    `photo_date` int(11)               NOT NULL DEFAULT 0,
    `photo_path` varchar(255)          NOT NULL,
    `photo_hash` char(32)              NOT NULL DEFAULT '',
    `photo_desc` varchar(255)          NOT NULL,
    PRIMARY KEY (`photo_id`),
    KEY `poster_id` (`poster_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_posts`
(
    `post_id`         mediumint(8) unsigned                        NOT NULL auto_increment,
    `topic_id`        mediumint(8) unsigned                        NOT NULL default '0',
    `forum_id`        smallint(5) unsigned                         NOT NULL default '0',
    `poster_id`       mediumint(8)                                 NOT NULL default '0',
    `post_time`       int(11)                                      NOT NULL default '0',
    `poster_ip`       char(32) character set utf8 collate utf8_bin NOT NULL default '',
    `post_username`   varchar(25)                                  NOT NULL default '',
    `enable_bbcode`   tinyint(1)                                   NOT NULL default '1',
    `enable_smilies`  tinyint(1)                                   NOT NULL default '1',
    `enable_sig`      tinyint(1)                                   NOT NULL default '1',
    `post_edit_time`  int(11)                                      NOT NULL default '0',
    `post_edit_count` smallint(5) unsigned                         NOT NULL default '0',
    `post_attachment` tinyint(1)                                   NOT NULL default '0',
    `post_reported`   tinyint(1)                                   NOT NULL default '0',
    `post_reviews`    mediumint(8) unsigned                        NOT NULL default '0',
    `post_warned`     tinyint(1)                                   NOT NULL DEFAULT 0,
    `post_has_hidden` tinyint(1)                                   NOT NULL DEFAULT 0,
    PRIMARY KEY (`post_id`),
    KEY `topic_id` (`topic_id`),
    KEY `poster_id` (`poster_id`),
    KEY `post_time` (`post_time`),
    KEY `forum_id_post_time` (`forum_id`, `post_time`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_posts_html`
(
    `post_id`        mediumint(9) NOT NULL default '0',
    `post_html_time` timestamp    NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
    `post_html`      longtext     NOT NULL,
    PRIMARY KEY (`post_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_posts_search`
(
    `post_id`      mediumint(8) unsigned NOT NULL default '0',
    `search_words` text                  NOT NULL,
    PRIMARY KEY (`post_id`),
    FULLTEXT KEY `search_words` (`search_words`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_posts_text`
(
    `post_id`      mediumint(8) unsigned NOT NULL default '0',
    `bbcode_uid`   varchar(10)           NOT NULL default '',
    `post_subject` enum ('','kFpILr5')   NOT NULL default '',
    `post_text`    longtext              NOT NULL,
    PRIMARY KEY (`post_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_privmsgs`
(
    `privmsgs_id`             mediumint(8) unsigned                           NOT NULL auto_increment,
    `privmsgs_type`           tinyint(4)                                      NOT NULL default '0',
    `privmsgs_subject`        varchar(255)                                    NOT NULL default '0',
    `privmsgs_from_userid`    mediumint(8)                                    NOT NULL default '0',
    `privmsgs_to_userid`      mediumint(8)                                    NOT NULL default '0',
    `privmsgs_date`           int(11)                                         NOT NULL default '0',
    `privmsgs_ip`             varchar(32) character set utf8 collate utf8_bin NOT NULL default '',
    `privmsgs_enable_bbcode`  tinyint(1)                                      NOT NULL default '1',
    `privmsgs_enable_smilies` tinyint(1)                                      NOT NULL default '1',
    `privmsgs_reported`       tinyint(1)                                      NOT NULL DEFAULT 0,
    `privmsgs_public`         tinyint(1)                                      NOT NULL DEFAULT 0,
    PRIMARY KEY (`privmsgs_id`),
    KEY `privmsgs_from_userid` (`privmsgs_from_userid`),
    KEY `privmsgs_to_userid` (`privmsgs_to_userid`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8
  AUTO_INCREMENT = 1;

CREATE TABLE IF NOT EXISTS `bb_privmsgs_text`
(
    `privmsgs_text_id`    mediumint(8) unsigned NOT NULL default '0',
    `privmsgs_bbcode_uid` varchar(10)           NOT NULL default '0',
    `privmsgs_text`       text                  NOT NULL,
    PRIMARY KEY (`privmsgs_text_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_quota_limits`
(
    `quota_limit_id` mediumint(8) unsigned NOT NULL auto_increment,
    `quota_desc`     varchar(20)           NOT NULL default '',
    `quota_limit`    bigint(20) unsigned   NOT NULL default '0',
    PRIMARY KEY (`quota_limit_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8
  AUTO_INCREMENT = 5;

INSERT INTO `bb_quota_limits` (`quota_limit_id`, `quota_desc`, `quota_limit`)
VALUES (1, 'Low', 104857600),
       (2, 'Medium', 262144000),
       (3, 'High', 335544320),
       (4, 'Admin', 1048576000);

CREATE TABLE IF NOT EXISTS `bb_ranks`
(
    `rank_id`      smallint(5) unsigned NOT NULL auto_increment,
    `rank_title`   varchar(50)          NOT NULL default '',
    `rank_min`     mediumint(8)         NOT NULL default '0',
    `rank_special` tinyint(1)           NOT NULL default '1',
    `rank_image`   varchar(255)         NOT NULL default '',
    PRIMARY KEY (`rank_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

INSERT INTO `bb_ranks` (`rank_id`, `rank_title`, `rank_min`, `rank_special`, `rank_image`)
VALUES (1, 'Admin', -1, 1, 'images/rungs/admin_runk.png'),
       (2, 'Модератор Музыки', -1, 1, 'images/rungs/audio_runk.png'),
       (3, 'Модератор Видео', -1, 1, 'images/rungs/video_runk.png'),
       (4, 'Модератор Общения', -1, 1, 'images/rungs/speak_runk.png'),
       (5, 'C-Girls', -1, 1, 'images/rungs/girls.png'),
       (6, 'Club-Design', -1, 1, 'images/rungs/Club-Design.png'),
       (7, 'VIP-Club', -1, 1, 'images/rungs/vip.png'),
       (8, 'Главный Модератор', -1, 1, 'images/rungs/main_moder.png'),
       (9, 'Модератор HQ-Audio', -1, 1, 'images/rungs/hq_audio_moder.png'),
       (10, 'Модератор DVD & HD-Video', -1, 1, 'images/rungs/hq_video_moder.png'),
       (11, 'Модератор Аниме', -1, 1, 'images/rungs/anime_moder.png'),
       (12, 'Модератор Домомучитель', -1, 1, 'images/rungs/home_moder.png'),
       (13, 'Модератор Игр', -1, 1, 'images/rungs/game_moder.png'),
       (14, 'Модератор Литературы', -1, 1, 'images/rungs/books_moder.png'),
       (15, 'Модератор Мультфильмов', -1, 1, 'images/rungs/mults_moder.png'),
       (16, 'Модератор Софта', -1, 1, 'images/rungs/soft_moder.png'),
       (17, 'Релизер', -1, 1, 'images/rungs/releaser.png'),
       (18, 'Support', -1, 1, 'images/rungs/support.png'),
       (19, 'Модератор Сериалов', -1, 1, '/images/rungs/serial_runk.png'),
       (20, 'Дизайнер', -1, 1, 'images/rungs/floatrx_runk.png'),
       (21, 'Главный Администратор', -1, 1, 'images/rungs/dj_maxx.png'),
       (23, 'Admin', -1, 1, 'images/rungs/admin_dark.png'),
       (24, 'V.I.P Леди Power-Club', -1, 1, '/images/rungs/avril.png'),
       (25, 'Редактор', -1, 1, 'images/rungs/runk_editors.png'),
       (26, 'AVC-релизер', -1, 1, 'images/rungs/avc.png'),
       (27, 'Модератор Консолей', -1, 1, 'images/rungs/mod_k.png'),
       (29, 'Координатор', -1, 1, 'images/rungs/koordinator.png'),
       (30, 'Модератор Документального кино', -1, 1, 'images/rungs/dok_runk.png'),
       (31, 'RG Anime Club', -1, 1, 'images/rungs/anime.png'),
       (33, 'Audiobooks of underverse', -1, 1, 'images/rungs/audiobooks.png'),
       (32, 'Злой бот', -1, 1, 'templates/default/images/bot.png'),
       (53, 'Radio Underverse', -1, 1, 'images/rungs/radio_uv.png'),
       (35, 'R.G. Gamers of Underverse', -1, 1, 'images/rungs/gamers.png'),
       (38, 'Победитель конкурса релизомёт-=1 место=-', -1, 1, 'images/rungs/relizomet1.png'),
       (37, 'Юридический Отдел', -1, 1, 'images/rungs/urist.png'),
       (39, 'Победитель конкурса релизомёт-=2 место=-', -1, 1, 'images/rungs/relizomet2.png'),
       (40, 'Победитель конкурса релизомёт-=3 место=-', -1, 1, 'images/rungs/relizomet3.png'),
       (46, 'RG MasterSoft', -1, 1, 'images/rungs/master_soft.png'),
       (41, 'Super', -1, 1, 'http://i060.radikal.ru/0910/15/3f1d5c11ee23.gif'),
       (42, 'Победитель конкурса софтомания :1 место:', -1, 1, 'images/rungs/soft_1.png'),
       (43, 'Победитель конкурса софтомания :2 место:', -1, 1, 'images/rungs/soft_2.png'),
       (44, 'Победитель конкурса софтомания :3 место:', -1, 1, 'images/rungs/soft_3.png'),
       (45, 'Победитель конкурса софтомания :4 место:', -1, 1, 'images/rungs/soft_4.png'),
       (47, 'Креативщик', -1, 1, 'images/rungs/creative.png'),
       (48, 'RG Books Of Underverse', -1, 1, 'images/rungs/books.png'),
       (49, 'R.G. ALL Cinema', -1, 1, 'images/rungs/allcinema.png'),
       (50, 'R.G. MusicLife', -1, 1, 'images/rungs/musiclife.png'),
       (51, 'HQ-Music', -1, 1, 'images/rungs/hq_music.png'),
       (52, 'RG Seed aid', -1, 1, 'images/rungs/seedaid.png'),
       (54, 'СПС Модератор', -1, 1, 'images/rungs/Sps_moder.png'),
       (55, 'СПС Техническая помощь', -1, 1, 'images/rungs/Sps_support.png'),
       (56, 'Аниме-няка', -1, 1, 'images/rungs/anime_nyaka.png'),
       (57, 'Вездесущая', -1, 1, ''),
       (59, 'RG Fatal1ty', -1, 1, 'images/rungs/fatality.png'),
       (60, 'RG СПС', -1, 1, 'images/rungs/rgsps.png'),
       (61, 'R.G. Rising', -1, 1, 'images/rungs/rising.png'),
       (64, 'Крутой перец 3', 0, 0, 'images/rungs/coolness3.png'),
       (62, 'Крутой перец 1', 1, 0, 'images/rungs/coolness1.png'),
       (63, 'Крутой перец 2', 1, 0, 'images/rungs/coolness2.png'),
       (65, 'Нубас года 2013', -1, 1, 'images/rungs/n00bas_2013.png'),
       (66, 'Релизер года 2013', -1, 1, 'images/rungs/releaser_2013.png'),
       (67, 'Модератор года 2013', -1, 1, 'images/rungs/moder_2013.png'),
       (68, 'Меломан года 2013', -1, 1, 'images/rungs/meloman_2013.png'),
       (69, 'Геймер года 2013', -1, 1, 'images/rungs/gamer_2013.png'),
       (70, 'Дебютант года 2013', -1, 1, 'images/rungs/debutant_2013.png'),
       (71, 'Книгоед года 2013', -1, 1, 'images/rungs/bookworm_2013.png'),
       (72, 'Релизер года 2014', -1, 1, 'images/rungs/releaser_2014.png'),
       (73, 'Модератор года 2014', -1, 1, 'images/rungs/moder_2014.png'),
       (74, 'Нубас года 2014', -1, 1, 'images/rungs/n00bas_2014.png'),
       (75, 'Книгоед года 2014', -1, 1, 'images/rungs/bookworm_2014.png'),
       (76, 'Дебютант года 2014', -1, 1, 'images/rungs/debutant_2014.png'),
       (77, 'Меломан года 2014', -1, 1, 'images/rungs/meloman_2014.png'),
       (78, 'Геймер года 2014', -1, 1, 'images/rungs/gamer_2014.png'),
       (79, 'Модератор Искусствовед', -1, 1, 'images/rungs/art_moder.png'),
       (80, 'Меломан года 2017', -1, 1, 'images/rungs/meloman_2017.png'),
       (81, 'Релизер года 2017', -1, 1, 'images/rungs/releaser_2017.png'),
       (82, 'Геймер года 2017', -1, 1, 'images/rungs/gamer_2017.png'),
       (83, 'Книгоед года 2017', -1, 1, 'images/rungs/bookworm_2017.png'),
       (84, 'Нубас года 2017', -1, 1, 'images/rungs/n00bas_2017.png'),
       (85, 'Круче Чака Норриса', -1, 1, 'images/rungs/chuck.png'),
       (86, 'Герой нашего времени', -1, 1, 'images/rungs/hero.png'),
       (87, 'Снабженец', -1, 1, 'images/rungs/loader.png');

CREATE TABLE IF NOT EXISTS `bb_reports`
(
    `report_id`           mediumint(8) unsigned NOT NULL auto_increment,
    `user_id`             mediumint(8)          NOT NULL,
    `report_time`         int(11)               NOT NULL,
    `report_last_change`  mediumint(8) unsigned default NULL,
    `report_module_id`    mediumint(8) unsigned NOT NULL,
    `report_status`       tinyint(1)            NOT NULL,
    `report_reason_id`    mediumint(8) unsigned NOT NULL,
    `report_subject`      int(11)               NOT NULL,
    `report_subject_data` mediumtext,
    `report_title`        varchar(255)          NOT NULL,
    `report_desc`         text                  NOT NULL,
    PRIMARY KEY (`report_id`),
    KEY `user_id` (`user_id`),
    KEY `report_time` (`report_time`),
    KEY `report_type_id` (`report_module_id`),
    KEY `report_status` (`report_status`),
    KEY `report_reason_id` (`report_reason_id`),
    KEY `report_subject` (`report_subject`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8
  AUTO_INCREMENT = 1;

CREATE TABLE IF NOT EXISTS `bb_reports_changes`
(
    `report_change_id`      mediumint(8) unsigned NOT NULL auto_increment,
    `report_id`             mediumint(8) unsigned NOT NULL,
    `user_id`               mediumint(8)          NOT NULL,
    `report_change_time`    int(11)               NOT NULL,
    `report_status`         tinyint(1)            NOT NULL,
    `report_change_comment` text                  NOT NULL,
    PRIMARY KEY (`report_change_id`),
    KEY `report_id` (`report_id`),
    KEY `user_id` (`user_id`),
    KEY `report_change_time` (`report_change_time`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8
  AUTO_INCREMENT = 1;

CREATE TABLE IF NOT EXISTS `bb_reports_modules`
(
    `report_module_id`         mediumint(8) unsigned NOT NULL auto_increment,
    `report_module_order`      mediumint(8) unsigned NOT NULL,
    `report_module_notify`     tinyint(1)            NOT NULL,
    `report_module_prune`      smallint(6)           NOT NULL,
    `report_module_last_prune` int(11) default NULL,
    `report_module_name`       varchar(50)           NOT NULL,
    `auth_write`               tinyint(1)            NOT NULL,
    `auth_view`                tinyint(1)            NOT NULL,
    `auth_notify`              tinyint(1)            NOT NULL,
    `auth_delete`              tinyint(1)            NOT NULL,
    PRIMARY KEY (`report_module_id`),
    KEY `report_module_order` (`report_module_order`),
    KEY `auth_view` (`auth_view`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8
  AUTO_INCREMENT = 6;

INSERT INTO `bb_reports_modules` (`report_module_id`, `report_module_order`, `report_module_notify`,
                                  `report_module_prune`, `report_module_last_prune`, `report_module_name`, `auth_write`,
                                  `auth_view`, `auth_notify`, `auth_delete`)
VALUES (1, 1, 0, 0, NULL, 'report_general', 0, 1, 1, 1),
       (2, 2, 0, 0, NULL, 'report_post', 0, 1, 1, 1),
       (3, 3, 0, 0, NULL, 'report_topic', 0, 1, 1, 1),
       (4, 4, 0, 0, NULL, 'report_user', 0, 1, 1, 1),
       (5, 5, 0, 0, NULL, 'report_privmsg', 0, 1, 1, 1);

CREATE TABLE IF NOT EXISTS `bb_reports_reasons`
(
    `report_reason_id`    mediumint(8) unsigned NOT NULL auto_increment,
    `report_module_id`    mediumint(8) unsigned NOT NULL,
    `report_reason_order` mediumint(8) unsigned NOT NULL,
    `report_reason_desc`  varchar(255)          NOT NULL,
    PRIMARY KEY (`report_reason_id`),
    KEY `report_type_id` (`report_module_id`),
    KEY `report_reason_order` (`report_reason_order`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8
  AUTO_INCREMENT = 1;

CREATE TABLE IF NOT EXISTS `bb_retrackers`
(
    `id_retracker`   mediumint(8) UNSIGNED                                       NOT NULL AUTO_INCREMENT,
    `retracker_name` varchar(50) CHARACTER SET cp1251 COLLATE cp1251_general_ci  NOT NULL,
    `retracker_url`  varchar(300) CHARACTER SET cp1251 COLLATE cp1251_general_ci NOT NULL,
    PRIMARY KEY (`id_retracker`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_retracker_addrs`
(
    `id_retracker_addr` mediumint(8) UNSIGNED NOT NULL AUTO_INCREMENT,
    `id_retracker`      mediumint(8) UNSIGNED NOT NULL,
    `ip_beg`            int(11) UNSIGNED      NOT NULL,
    `ip_end`            int(11) UNSIGNED      NOT NULL,
    PRIMARY KEY (`id_retracker_addr`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_reviews`
(
    `review_id`          mediumint(8) UNSIGNED            NOT NULL AUTO_INCREMENT,
    `poster_id`          mediumint(8) UNSIGNED            NOT NULL DEFAULT 0,
    `poster_ip`          varchar(32)                      NOT NULL,
    `editor_ip`          varchar(32)                      NOT NULL DEFAULT '',
    `user_id`            mediumint(8) UNSIGNED            NOT NULL DEFAULT 0,
    `post_id`            mediumint(8) UNSIGNED            NOT NULL DEFAULT 0,
    `review_type`        enum ('reputation','warn','ban') NOT NULL,
    `review_value`       tinyint(4)                       NOT NULL DEFAULT 0,
    `review_date`        int(11)                          NOT NULL DEFAULT 0,
    `review_edit_date`   int(11)                          NOT NULL DEFAULT 0,
    `review_expire_date` int(11)                          NOT NULL DEFAULT 0,
    PRIMARY KEY (`review_id`),
    KEY `review_type` (`poster_id`, `review_type`) USING BTREE
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_reviews_text`
(
    `review_id`   mediumint(8) UNSIGNED NOT NULL,
    `review_text` text                  NOT NULL,
    PRIMARY KEY (`review_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_search_cloak`
(
    `user_ip`        int(11) UNSIGNED NOT NULL,
    `user_timestamp` int(11) UNSIGNED NOT NULL,
    `user_referer`   varchar(255)     NOT NULL,
    `user_agent`     varchar(255)     NOT NULL DEFAULT '',
    PRIMARY KEY (`user_ip`) USING BTREE
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_search_log`
(
    `sl_id`      int(11)          NOT NULL AUTO_INCREMENT,
    `sl_text`    varchar(255)     NOT NULL,
    `sl_found`   int(11)          NOT NULL,
    `sl_time`    int(11) UNSIGNED NOT NULL,
    `sl_ua`      varchar(255) DEFAULT NULL,
    `sl_referer` varchar(255) DEFAULT NULL,
    `sl_ip`      varchar(15)      NOT NULL,
    PRIMARY KEY (`sl_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_search_rebuild`
(
    `rebuild_session_id`     mediumint(8) unsigned NOT NULL auto_increment,
    `start_post_id`          mediumint(8) unsigned NOT NULL default '0',
    `end_post_id`            mediumint(8) unsigned NOT NULL default '0',
    `start_time`             int(11)               NOT NULL default '0',
    `end_time`               int(11)               NOT NULL default '0',
    `last_cycle_time`        int(11)               NOT NULL default '0',
    `session_time`           int(11)               NOT NULL default '0',
    `session_posts`          mediumint(8) unsigned NOT NULL default '0',
    `session_cycles`         mediumint(8) unsigned NOT NULL default '0',
    `search_size`            int(10) unsigned      NOT NULL default '0',
    `rebuild_session_status` tinyint(1)            NOT NULL default '0',
    PRIMARY KEY (`rebuild_session_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8
  AUTO_INCREMENT = 1;

CREATE TABLE IF NOT EXISTS `bb_search_results`
(
    `session_id`      char(20) character set utf8 collate utf8_bin    NOT NULL default '',
    `search_type`     tinyint(4)                                      NOT NULL default '0',
    `search_id`       varchar(12) character set utf8 collate utf8_bin NOT NULL default '',
    `search_time`     int(11)                                         NOT NULL default '0',
    `search_settings` text                                            NOT NULL,
    `search_array`    text                                            NOT NULL,
    PRIMARY KEY (`session_id`, `search_type`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_sessions`
(
    `session_id`        char(20) character set utf8 collate utf8_bin NOT NULL default '',
    `session_user_id`   mediumint(8)                                 NOT NULL default '0',
    `session_start`     int(11)                                      NOT NULL default '0',
    `session_time`      int(11)                                      NOT NULL default '0',
    `session_ip`        char(32) character set utf8 collate utf8_bin NOT NULL default '',
    `session_logged_in` tinyint(1)                                   NOT NULL default '0',
    `session_admin`     tinyint(2)                                   NOT NULL default '0',
    PRIMARY KEY (`session_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_slot_machine`
(
    `user_id`   mediumint(8) NOT NULL DEFAULT 0,
    `spin1`     tinyint(2)   NOT NULL DEFAULT 0,
    `spin2`     tinyint(2)   NOT NULL DEFAULT 0,
    `spin3`     tinyint(2)   NOT NULL DEFAULT 0,
    `spin_time` int(11)      NOT NULL DEFAULT 0,
    PRIMARY KEY (`user_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_smilies`
(
    `smilies_id` smallint(5) unsigned NOT NULL auto_increment,
    `code`       varchar(50)          NOT NULL default '',
    `smile_url`  varchar(100)         NOT NULL default '',
    `emoticon`   varchar(75)          NOT NULL default '',
    PRIMARY KEY (`smilies_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

INSERT INTO `bb_smilies` (`smilies_id`, `code`, `smile_url`, `emoticon`)
VALUES (169, ':angel:', 'angel.gif', ':angel:'),
       (170, ':unknown:', 'unknw.gif', ':unknown:'),
       (171, ':fool:', 'fool.gif', ':fool:'),
       (172, ':implication:', 'pleasantry.gif', ':implication:'),
       (173, ':O:', 'shout.gif', ':O:'),
       (174, ':shout:', 'shout.gif', ':shout:'),
       (120, ':)', 'smile.gif', ':)'),
       (121, ':-)', 'smile.gif', ':-)'),
       (122, ':smile:', 'smile.gif', ':smile:'),
       (123, ':(', 'sad.gif', ':('),
       (124, ':-(', 'sad.gif', ':-('),
       (125, ':sad:', 'sad.gif', ':sad:'),
       (126, ':D', 'biggrin.gif', ':D'),
       (127, ':-D', 'biggrin.gif', ':-D'),
       (128, ':grin:', 'biggrin.gif', ':grin:'),
       (129, ':lol:', 'lol.gif', ':lol:'),
       (130, ':ROFL:', 'rofl.gif', ':ROFL:'),
       (131, '8)', 'dirol.gif', '8)'),
       (132, '8-)', 'dirol.gif', '8-)'),
       (133, ':cool:', 'dirol.gif', ':cool:'),
       (134, ':Yahoo!:', 'yahoo.gif', ':Yahoo!:'),
       (135, ':x', 'aggressive.gif', ':x'),
       (136, ':-x', 'aggressive.gif', ':-x'),
       (137, ':mad:', 'aggressive.gif', ':mad:'),
       (138, ':oops:', 'blush.gif', ':oops:'),
       (139, ':cry:', 'cray.gif', ':cry:'),
       (140, ':evil:', 'diablo.gif', ':evil:'),
       (141, ':twisted:', 'spiteful.gif', ':twisted:'),
       (142, ':roll:', 'rolleyes.gif', ':roll:'),
       (143, ':wink:', 'wink.gif', ':wink:'),
       (144, ';)', 'wink.gif', ';)'),
       (145, ';-)', 'wink.gif', ';-)'),
       (146, ':o', 'mega_shok.gif', ':o'),
       (147, ':-o', 'mega_shok.gif', ':-o'),
       (148, ':eek:', 'mega_shok.gif', ':eek:'),
       (149, ':shock:', 'shok.gif', ':shock:'),
       (150, ':crazy:', 'crazy.gif', ':crazy:'),
       (151, '%)', 'wacko.gif', '%)'),
       (152, ':P', 'tease.gif', ':P'),
       (153, ':-P', 'tease.gif', ':-P'),
       (154, ':razz:', 'tease.gif', ':razz:'),
       (155, ':Rose:', 'give_rose.gif', ':Rose:'),
       (156, ':Search:', 'search.gif', ':Search:'),
       (157, '=@', 'bomb.gif', '=@'),
       (158, ':Bravo:', 'clapping.gif', ':Bravo:'),
       (159, ':good:', 'good.gif', ':good:'),
       (160, ':bad:', 'bad.gif', ':bad:'),
       (161, ':sorry:', 'sorry.gif', ':sorry:'),
       (163, ':beer:', 'drinks.gif', ':beer:'),
       (164, ':drinks:', 'drinks.gif', ':drinks:'),
       (165, ':no:', 'nea.gif', ':no:'),
       (166, ':friends:', 'friends.gif', ':friends:'),
       (167, 'O:-)', 'angel.gif', 'O:-)'),
       (168, 'O:)', 'angel.gif', 'O:)'),
       (175, ':help:', 'help.gif', ':help:'),
       (176, ':stinker:', 'stinker.gif', ':stinker:'),
       (177, ':treaten:', 'treaten.gif', ':treaten:'),
       (178, ':new_russian:', 'new_russian.gif', ':new_russian:'),
       (179, ':pardon:', 'pardon.gif', ':pardon:'),
       (180, ':beach:', 'beach.gif', ':beach:'),
       (181, ':boredom:', 'boredom.gif', ':boredom:'),
       (182, ':dance:', 'dance.gif', ':dance:'),
       (183, ':kiss2:', 'kiss2.gif', ':kiss2:'),
       (184, ':heart:', 'heart.gif', ':heart:'),
       (186, ':mamba:', 'mamba.gif', ':mamba:'),
       (187, ':vampire:', 'vampire.gif', ':vampire:'),
       (188, ':secret:', 'secret.gif', ':secret:'),
       (189, ':acute:', 'acute.gif', ':acute:'),
       (190, ':focus:', 'focus.gif', ':focus:'),
       (191, ':kissed:', 'air_kiss.gif', ':kissed:'),
       (192, ':-*', 'kiss2.gif', ':-*'),
       (193, ':yu:', 'yu.gif', ':yu:'),
       (194, ':blush:', 'blush.gif', ':blush:'),
       (195, ':blum:', 'blum.gif', ':blum:'),
       (196, ':beee:', 'beee.gif', ':beee:'),
       (197, ':hi:', 'hi.gif', ':hi:'),
       (198, ':king:', 'king.gif', ':king:'),
       (199, ':lazy:', 'lazy.gif', ':lazy:'),
       (200, ':ok:', 'ok.gif', ':ok:'),
       (201, ':pilot:', 'pilot.gif', ':pilot:'),
       (202, ':rtfm:', 'rtfm.gif', ':rtfm:'),
       (203, ':scare:', 'scare.gif', ':scare:'),
       (204, ':yes:', 'yes3.gif', ':yes:'),
       (205, ':yess:', 'yess.gif', ':yess:'),
       (206, ':girl devil:', 'girl_devil.gif', ':girl devil:'),
       (207, ':man in love:', 'man_in_love.gif', ':man in love:'),
       (208, ':scratch:', 'scratch_one-s_head.gif', ':scratch:'),
       (209, ':whistle:', 'whistle3.gif', ':whistle:'),
       (210, ':dance2:', 'dance2.gif', ':dance2:'),
       (211, ':this:', 'this.gif', ':this:'),
       (212, ':bye:', 'bye.gif', ':bye:'),
       (213, ':buba:', 'buba.gif', ':buba:'),
       (214, ':flirt:', 'flirt.gif', ':flirt:'),
       (215, ':spruce up:', 'spruce_up.gif', ':spruce up:'),
       (216, ':suicide2:', 'suicide2.gif', ':suicide2:'),
       (217, ':heat:', 'heat.gif', ':heat:'),
       (218, ':first move:', 'first_move.gif', ':first move:'),
       (219, ':give heart:', 'give_heart.gif', ':give heart:'),
       (220, ':give heart 2:', 'give_heart2.gif', ':give heart 2:'),
       (221, ':punish:', 'punish.gif', ':punish:'),
       (222, ':mda:', 'mda.gif', ':mda:'),
       (223, ':thank you:', 'thank_you2.gif', ':thank you:'),
       (224, ':dance3:', 'dance3.gif', ':dance3:'),
       (225, ':kiss:', 'kiss.gif', ':kiss:'),
       (226, ':swoon:', 'swoon.gif', ':swoon:'),
       (227, ':buba phone:', 'bomb_phone.gif', ':buba phone:'),
       (228, ':slow:', 'slow.gif', ':slow:'),
       (229, ':happy:', 'i-m_so_happy.gif', ':happy:'),
       (230, ':declare:', 'declare.gif', ':declare:'),
       (231, ':moil:', 'moil.gif', ':moil:'),
       (232, ':big boss:', 'big_boss.gif', ':big boss:'),
       (233, ':umnik2:', 'umnik2.gif', ':umnik2:'),
       (234, ':superstition:', 'superstition.gif', ':superstition:'),
       (235, ':american:', 'english_en.gif', ':american:'),
       (236, ':russian:', 'russian_ru.gif', ':russian:'),
       (237, ':parting:', 'parting.gif', ':parting:'),
       (238, ':padonak:', 'padonak.gif', ':padonak:'),
       (239, ':hysteric:', 'hysteric.gif', ':hysteric:'),
       (240, ':babruysk:', 'to_babruysk.gif', ':babruysk:'),
       (241, ':curtsey:', 'curtsey.gif', ':curtsey:'),
       (242, ':tender:', 'tender.gif', ':tender:'),
       (243, ':on the quiet:', 'on_the_quiet2.gif', ':on the quiet:'),
       (244, ':wink2:', 'wink2.gif', ':wink2:'),
       (245, ':wink3:', 'wink3.gif', ':wink3:'),
       (246, ':boast:', 'boast.gif', ':boast:'),
       (247, ':prankster2:', 'prankster2.gif', ':prankster2:'),
       (248, ':girl hospital:', 'girl_hospital.gif', ':girl hospital:'),
       (249, ':girl smile:', 'girl_smile.gif', ':girl smile:'),
       (250, ':girl in love:', 'girl_in_love.gif', ':girl in love:'),
       (251, ':girl sigh:', 'girl_sigh.gif', ':girl sigh:'),
       (252, ':girl hide:', 'girl_hide.gif', ':girl hide:'),
       (253, ':girl mad:', 'girl_mad.gif', ':girl mad:'),
       (254, ':girl wacko:', 'girl_wacko.gif', ':girl wacko:'),
       (255, ':girl blum:', 'girl_blum.gif', ':girl blum:'),
       (256, ':girl sad:', 'girl_sad.gif', ':girl sad:'),
       (257, ':girl haha:', 'girl_haha.gif', ':girl haha:'),
       (258, ':girl crazy:', 'girl_crazy.gif', ':girl crazy:'),
       (259, ':girl prepare fish:', 'girl_prepare_fish.gif', ':girl prepare fish:'),
       (260, ':girl cry:', 'girl_cray.gif', ':girl cry:'),
       (261, ':girl impossible:', 'girl_impossible.gif', ':girl impossible:'),
       (262, ':girl isterika:', 'girl_cray2.gif', ':girl isterika:'),
       (263, ':sarcastic:', 'sarcastic.gif', ':sarcastic:'),
       (264, ':girl wink:', 'girl_wink.gif', ':girl wink:'),
       (265, ':sarcastic hand:', 'sarcastic_hand.gif', ':sarcastic hand:'),
       (266, ':music:', 'music.gif', ':music:'),
       (267, ':party:', 'party.gif', ':party:'),
       (268, ':girl dance:', 'girl_dance.gif', ':girl dance:'),
       (269, ':dance4:', 'dance4.gif', ':dance4:'),
       (270, ':preved:', 'preved.gif', ':preved:'),
       (271, ':censored:', 'sensored.gif', ':censored:'),
       (272, ':paint2:', 'paint2.gif', ':paint2:'),
       (273, ':paint3:', 'paint3.gif', ':paint3:'),
       (274, ':scout:', 'scaut.gif', ':scout:'),
       (275, ':download:', 'download.gif', ':download:'),
       (276, ':pioneer:', 'pioneer.gif', ':pioneer:'),
       (277, ':hunter:', 'hunter.gif', ':hunter:'),
       (278, ':training1:', 'training1.gif', ':training1:'),
       (279, ':girl drink:', 'girl_drink4.gif', ':girl drink:'),
       (280, ':girl pinkglasses:', 'girl_pinkglassesf.gif', ':girl pinkglasses:'),
       (281, ':wizard:', 'wizard.gif', ':wizard:'),
       (282, ':pioneer smoke:', 'pioneer_smoke.gif', ':pioneer smoke:'),
       (283, ':hang:', 'hang3.gif', ':hang:'),
       (284, ':bugaga', 'Koshechka_08.gif', ':bugaga'),
       (285, ':bugaga:', 'Koshechka_08.gif', ':bugaga:'),
       (286, 'P.S.', 'ps.gif', 'P.S.'),
       (287, ':!:', 'excl.gif', ':!:'),
       (288, ':left:', 'left.gif', ':left:'),
       (289, ':right:', 'right.gif', ':right:'),
       (290, ':porka:', 'dz.gif', ':porka:'),
       (291, ':atatashko:', 'dz.gif', ':atatashko:'),
       (292, ':medal:', 'medal_week.gif', ':medal:'),
       (293, ':big_thanks:', 'big_thanks.gif', ':big_thanks:'),
       (342, ':super:', 'super.gif', ':super:'),
       (295, ':travka:', '1043269172.gif', ':travka:'),
       (296, ':zapoy:', '33.gif', ':zapoy:'),
       (297, ':orel:', '60.gif', ':orel:'),
       (298, ':durdom:', '66.gif', ':durdom:'),
       (299, ':admin_ya:', 'admintutja.gif', ':admin_ya:'),
       (300, ':flud:', 'aiwan-flood.gif', ':flud:'),
       (301, ':offtop:', 'aiwan-offtopic.gif', ':offtop:'),
       (302, ':assassin:', 'assassin.gif', ':assassin:'),
       (303, ':banned:', 'banned.gif', ':banned:'),
       (304, ':butcher:', 'butcher.gif', ':butcher:'),
       (305, ':comando:', 'comando.gif', ':comando:'),
       (306, ':danuvas:', 'danuvas.gif', ':danuvas:'),
       (307, ':closetopic:', 'dd_035.gif', ':closetopic:'),
       (308, ':dotua:', 'dotua.gif', ':dotua:'),
       (309, ':gigi:', 'gigi.gif', ':gigi:'),
       (310, ':img:', 'img.gif', ':img:'),
       (311, ':jalamo:', 'jalamo.gif', ':jalamo:'),
       (312, ':japrotiv:', 'japrotiv.gif', ':japrotiv:'),
       (313, ':cheburashko:', 'meowth.gif', ':cheburashko:'),
       (314, ':mlja:', 'mlja.gif', ':mlja:'),
       (315, ':noflood:', 'noflood.gif', ':noflood:'),
       (316, ':offtopchik:', 'offtopchik.gif', ':offtopchik:'),
       (317, ':pig_ball:', 'pig_ball.gif', ':pig_ball:'),
       (318, ':pooh_go:', 'pooh_go.gif', ':pooh_go:'),
       (319, ':pooh_on_ball:', 'pooh_on_ball.gif', ':pooh_on_ball:'),
       (320, ':moskal:', 'russian.gif', ':moskal:'),
       (321, ':champion:', 'shablon_04.gif', ':champion:'),
       (322, ':skull:', 'skull.gif', ':skull:'),
       (323, ':spam_light:', 'spam_light.gif', ':spam_light:'),
       (324, ':spartak:', 'spartak.gif', ':spartak:'),
       (325, ':superman2:', 'superman2.gif', ':superman2:'),
       (326, ':dobriy:', 'zz_068.gif', ':dobriy:'),
       (327, ':basketball:', 'basketball.gif', ':basketball:'),
       (328, ':connie_33:', 'connie_33.gif', ':connie_33:'),
       (329, ':connie_36:', 'connie_36.gif', ':connie_36:'),
       (330, ':connie_38:', 'connie_38.gif', ':connie_38:'),
       (331, ':d_sunny:', 'd_sunny.gif', ':d_sunny:'),
       (332, ':d_teddy:', 'd_teddy.gif', ':d_teddy:'),
       (335, ':jc_cupidboy:', 'JC_cupidboy.gif', ':jc_cupidboy:'),
       (336, ':jc_cupidgirl:', 'JC_cupidgirl.gif', ':jc_cupidgirl:'),
       (337, ':l_daisy:', 'l_daisy.gif', ':l_daisy:'),
       (338, ':l_good_luck:', 'l_good_luck.gif', ':l_good_luck:'),
       (339, ':laie_10:', 'Laie_10.gif', ':laie_10:'),
       (340, ':laie_12:', 'Laie_12.gif', ':laie_12:'),
       (341, ':moderator:', 'moderator.gif', ':moderator:');

CREATE TABLE IF NOT EXISTS `bb_topics`
(
    `topic_id`             mediumint(8) unsigned NOT NULL auto_increment,
    `forum_id`             smallint(8) unsigned  NOT NULL default '0',
    `topic_title`          varchar(250)          NOT NULL default '',
    `topic_poster`         mediumint(8)          NOT NULL default '0',
    `topic_time`           int(11)               NOT NULL default '0',
    `topic_views`          mediumint(8) unsigned NOT NULL default '0',
    `topic_replies`        mediumint(8) unsigned NOT NULL default '0',
    `topic_status`         tinyint(3)            NOT NULL default '0',
    `topic_vote`           tinyint(1)            NOT NULL default '0',
    `topic_type`           tinyint(3)            NOT NULL default '0',
    `topic_first_post_id`  mediumint(8) unsigned NOT NULL default '0',
    `topic_last_post_id`   mediumint(8) unsigned NOT NULL default '0',
    `topic_moved_id`       mediumint(8) unsigned NOT NULL default '0',
    `topic_attachment`     tinyint(1)            NOT NULL default '0',
    `topic_reported`       tinyint(1)            NOT NULL default '0',
    `topic_dl_type`        tinyint(1)            NOT NULL default '0',
    `topic_dl_discount`    tinyint(2) UNSIGNED   NOT NULL DEFAULT 0,
    `allow_guest`          tinyint(1) UNSIGNED   NOT NULL DEFAULT 0,
    `allow_guest_magnet`   tinyint(1) UNSIGNED   NOT NULL DEFAULT 1,
    `topic_last_post_time` int(11)               NOT NULL DEFAULT 0,
    `topic_color`          varchar(10)           NOT NULL DEFAULT '',
    PRIMARY KEY (`topic_id`),
    KEY `forum_id` (`forum_id`),
    KEY `topic_last_post_id` (`topic_last_post_id`),
    KEY `topic_last_post_time` (`topic_last_post_time`),
    FULLTEXT KEY `topic_title` (`topic_title`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8
  AUTO_INCREMENT = 1;

CREATE TABLE IF NOT EXISTS `bb_topics_bookmark`
(
    `topic_id`        mediumint(8) unsigned NOT NULL default '0',
    `user_id`         mediumint(8)          NOT NULL default '0',
    `bookmark_status` tinyint(1)            NOT NULL default '0',
    KEY `topic_id` (`topic_id`),
    KEY `user_id` (`user_id`),
    KEY `bookmark_status` (`bookmark_status`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_topics_watch`
(
    `topic_id`      mediumint(8) unsigned NOT NULL default '0',
    `user_id`       mediumint(8)          NOT NULL default '0',
    `notify_status` tinyint(1)            NOT NULL default '0',
    KEY `topic_id` (`topic_id`),
    KEY `user_id` (`user_id`),
    KEY `notify_status` (`notify_status`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_topic_templates`
(
    `tpl_id`       smallint(6)  NOT NULL auto_increment,
    `tpl_name`     varchar(20)  NOT NULL default '',
    `tpl_script`   varchar(30)  NOT NULL default '',
    `tpl_template` varchar(30)  NOT NULL default '',
    `tpl_desc`     varchar(255) NOT NULL default '',
    PRIMARY KEY (`tpl_id`),
    UNIQUE KEY `tpl_name` (`tpl_name`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8
  AUTO_INCREMENT = 15;

INSERT INTO `bb_topic_templates` (`tpl_id`, `tpl_name`, `tpl_script`, `tpl_template`, `tpl_desc`)
VALUES (1, 'video', 'video', 'video', 'Video (basic)'),
       (2, 'video_home', 'video', 'video_home', 'Video (home)'),
       (3, 'video_simple', 'video', 'video_simple', 'Video (simple)'),
       (4, 'video_lesson', 'video', 'video_lesson', 'Video (lesson)'),
       (5, 'games', 'games', 'games', 'Games'),
       (6, 'games_ps', 'games', 'games_ps', 'Games PS/PS2'),
       (7, 'games_psp', 'games', 'games_psp', 'Games PSP'),
       (8, 'games_xbox', 'games', 'games_xbox', 'Games XBOX'),
       (9, 'progs', 'progs', 'progs', 'Programs'),
       (10, 'progs_mac', 'progs', 'progs_mac', 'Programs Mac OS'),
       (11, 'music', 'music', 'music', 'Music'),
       (12, 'books', 'books', 'books', 'Books'),
       (13, 'audiobooks', 'audiobooks', 'audiobooks', 'Audiobooks'),
       (14, 'sport', 'sport', 'sport', 'Sport');

CREATE TABLE IF NOT EXISTS `bb_untrusted_ips`
(
    `untrusted_ip`       varchar(32)           NOT NULL,
    `untrusted_reason`   enum ('bruteforce')   NOT NULL,
    `untrusted_attempts` mediumint(8) UNSIGNED NOT NULL DEFAULT 0,
    `untrusted_pending`  tinyint(1) UNSIGNED   NOT NULL DEFAULT 0,
    UNIQUE KEY `untrusted_ip` (`untrusted_ip`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_users`
(
    `user_id`                     mediumint(8)                                    NOT NULL AUTO_INCREMENT,
    `user_active`                 tinyint(1)                                      NOT NULL DEFAULT 1,
    `username`                    varchar(25)                                     NOT NULL DEFAULT '',
    `user_password`               varchar(32) character set utf8 collate utf8_bin NOT NULL default '',
    `user_session_time`           int(11)                                         NOT NULL DEFAULT 0,
    `user_timer`                  int(11)                                         NOT NULL,
    `user_lastvisit`              int(11)                                         NOT NULL DEFAULT 0,
    `user_regdate`                int(11)                                         NOT NULL DEFAULT 0,
    `user_level`                  tinyint(4)                                      NOT NULL DEFAULT 0,
    `user_posts`                  mediumint(8) UNSIGNED                           NOT NULL DEFAULT 0,
    `user_timezone`               decimal(5, 2)                                   NOT NULL DEFAULT 0.00,
    `user_lang`                   varchar(255)                                    NOT NULL DEFAULT '',
    `user_dateformat`             varchar(14)                                     NOT NULL DEFAULT '',
    `user_new_privmsg`            smallint(5) UNSIGNED                            NOT NULL DEFAULT 0,
    `user_unread_privmsg`         smallint(5) UNSIGNED                            NOT NULL DEFAULT 0,
    `user_last_privmsg`           int(11)                                         NOT NULL DEFAULT 0,
    `user_opt`                    int(11)                                         NOT NULL DEFAULT 0,
    `user_allowavatar`            tinyint(1)                                      NOT NULL DEFAULT 1,
    `user_allow_posting`          tinyint(1)                                      NOT NULL DEFAULT 1,
    `user_allow_pm`               tinyint(1)                                      NOT NULL DEFAULT 1,
    `user_allow_viewonline`       tinyint(1)                                      NOT NULL DEFAULT 1,
    `user_use_https`              tinyint(1)                                      NOT NULL DEFAULT 0,
    `user_notify`                 tinyint(1)                                      NOT NULL DEFAULT 1,
    `user_notify_pm`              tinyint(1)                                      NOT NULL DEFAULT 0,
    `user_notify_massmail`        tinyint(1)                                      NOT NULL DEFAULT 0,
    `user_rank`                   int(11)                                         NOT NULL DEFAULT 0,
    `user_rank_2`                 int(11)                                         NOT NULL DEFAULT 0,
    `user_avatar`                 varchar(100)                                    NOT NULL DEFAULT '',
    `user_avatar_type`            tinyint(4)                                      NOT NULL DEFAULT 0,
    `user_email`                  varchar(255)                                    NOT NULL DEFAULT '',
    `user_icq`                    varchar(15)                                     NOT NULL DEFAULT '',
    `user_website`                varchar(100)                                    NOT NULL DEFAULT '',
    `user_from`                   varchar(100)                                    NOT NULL DEFAULT '',
    `user_awards`                 text                                            NOT NULL,
    `user_sig`                    text                                            NOT NULL,
    `user_sig_bbcode_uid`         varchar(10)                                     NOT NULL DEFAULT '',
    `user_aim`                    varchar(255)                                    NOT NULL DEFAULT '',
    `user_yim`                    varchar(255)                                    NOT NULL DEFAULT '',
    `user_msnm`                   varchar(255)                                    NOT NULL DEFAULT '',
    `user_occ`                    varchar(100)                                    NOT NULL DEFAULT '',
    `user_interests`              varchar(255)                                    NOT NULL DEFAULT '',
    `user_actkey`                 varchar(32)                                     NOT NULL DEFAULT '',
    `user_newpasswd`              varchar(32)                                     NOT NULL,
    `user_allow_passkey`          tinyint(1)                                      NOT NULL DEFAULT 1,
    `user_from_flag`              varchar(25)                                     NOT NULL DEFAULT '',
    `ignore_srv_load`             tinyint(1)                                      NOT NULL DEFAULT 0,
    `autologin_id`                varchar(12) character set utf8 collate utf8_bin NOT NULL default '',
    `user_newest_pm_id`           mediumint(8)                                    NOT NULL DEFAULT 0,
    `user_gender`                 tinyint(4)                                      NOT NULL DEFAULT 0,
    `user_birthday`               int(11)                                         NOT NULL DEFAULT 999999,
    `user_next_birthday_greeting` int(11)                                         NOT NULL DEFAULT 0,
    `user_vip`                    tinyint(1)                                      NOT NULL DEFAULT 0,
    `user_releaser`               tinyint(1)                                      NOT NULL DEFAULT 0,
    `user_half_dl`                tinyint(1)                                      NOT NULL DEFAULT 0,
    `user_custom_color`           varchar(7)                                      NOT NULL DEFAULT '',
    `user_ip`                     varchar(32)                                     NOT NULL DEFAULT '7f000001',
    `user_rip`                    varchar(32)                                     NOT NULL DEFAULT '7f000001',
    `user_reputation`             mediumint(8)                                    NOT NULL DEFAULT 0,
    `user_warnings`               tinyint(1)                                      NOT NULL DEFAULT 0,
    `user_bans`                   tinyint(1)                                      NOT NULL DEFAULT 0,
    `user_coolness`               float(11, 5) UNSIGNED                           NOT NULL DEFAULT 0.00000,
    `user_read_announce`          tinyint(1)                                      NOT NULL DEFAULT 0,
    PRIMARY KEY (`user_id`),
    KEY `username` (`username`(10)),
    KEY `user_email` (`user_email`(10)),
    KEY `user_level` (`user_level`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

INSERT INTO `bb_users` (`user_id`, `user_active`, `username`, `user_password`, `user_session_time`, `user_timer`,
                        `user_lastvisit`, `user_regdate`, `user_level`, `user_posts`, `user_timezone`, `user_lang`,
                        `user_dateformat`, `user_new_privmsg`, `user_unread_privmsg`, `user_last_privmsg`, `user_opt`,
                        `user_allowavatar`, `user_allow_posting`, `user_allow_pm`, `user_allow_viewonline`,
                        `user_use_https`, `user_notify`, `user_notify_pm`, `user_notify_massmail`, `user_rank`,
                        `user_rank_2`, `user_avatar`, `user_avatar_type`, `user_email`, `user_icq`, `user_website`,
                        `user_from`, `user_awards`, `user_sig`, `user_sig_bbcode_uid`, `user_aim`, `user_yim`,
                        `user_msnm`, `user_occ`, `user_interests`, `user_actkey`, `user_newpasswd`,
                        `user_allow_passkey`, `user_from_flag`, `ignore_srv_load`, `autologin_id`, `user_newest_pm_id`,
                        `user_gender`, `user_birthday`, `user_next_birthday_greeting`, `user_vip`, `user_releaser`,
                        `user_half_dl`, `user_custom_color`, `user_ip`, `user_rip`, `user_reputation`, `user_warnings`,
                        `user_bans`, `user_coolness`, `user_read_announce`)
VALUES (-746, 0, 'robot', '', 0, 0, 0, 1117114766, 0, 0, 0.00, '', '', 0, 0, 0, 150, 1, 1, 1, 1, 1, 0, 0, 0, 32, 0, '',
        0, 'bot@bot.bot', '', '', '', '', '', '', '', '', '', '', '', '', '', 1, '', 0, '', 0, 0, 999999, 0, 0, 0, 0,
        '', '', '', 0, 0, 0, 0.00000, 0),
       (-1, 0, 'Anonymous', '', 0, 0, 0, 1117103663, 0, 0, 0.00, '', '', 0, 0, 0, 220, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, '',
        0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', 1, '', 0, '', 0, 0, 999999, 0, 0, 0, 0, '', '', '',
        0, 0, 0, 0.00000, 0),
       (2, 1, 'admin', '21232f297a57a5a743894a0e4a801fc3', 0, 0, 0, 1234614840, 1, 0, 0.00, '', '', 0, 0, 0, 670, 1, 1,
        1, 0, 1, 0, 1, 1, 1, 83, '', 1, 'admin@torrentpier.com', '', '', '', '', '', '', '', '', '', '', '', '', '', 1,
        '', 0, '', 0, 0, 999999, 0, 0, 0, 0, '', '', '', 0, 0, 0, 0.00000, 0),
       (1, 1, 'Guest/MultiTrk', '21232f297a57a5a743894a0e4a801fc3', 0, 0, 0, 1117103663, 0, 0, 0.00, '', '', 0, 0, 0,
        159, 1, 1, 1, 1, 1, 0, 1, 1, 0, 0, '', 0, 'guest@underverse.su', '', '', '', '', '', '', '', '', '', '', '', '',
        '', 1, '', 0, '', 0, 0, 999999, 0, 0, 0, 0, '', '7f000001', '7f000001', 0, 0, 0, 0.00000, 0);

CREATE TABLE IF NOT EXISTS `bb_user_group`
(
    `group_id`     mediumint(8) NOT NULL default '0',
    `user_id`      mediumint(8) NOT NULL default '0',
    `user_pending` tinyint(1)   NOT NULL default '0',
    PRIMARY KEY (`group_id`, `user_id`),
    KEY `user_id` (`user_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_vote_desc`
(
    `vote_id`     mediumint(8) unsigned NOT NULL auto_increment,
    `topic_id`    mediumint(8) unsigned NOT NULL default '0',
    `vote_text`   text                  NOT NULL,
    `vote_start`  int(11)               NOT NULL default '0',
    `vote_length` int(11)               NOT NULL default '0',
    PRIMARY KEY (`vote_id`),
    KEY `topic_id` (`topic_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8
  AUTO_INCREMENT = 1;

CREATE TABLE IF NOT EXISTS `bb_vote_results`
(
    `vote_id`          mediumint(8) unsigned NOT NULL default '0',
    `vote_option_id`   tinyint(4) unsigned   NOT NULL default '0',
    `vote_option_text` varchar(255)          NOT NULL default '',
    `vote_result`      int(11)               NOT NULL default '0',
    KEY `vote_option_id` (`vote_option_id`),
    KEY `vote_id` (`vote_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_vote_voters`
(
    `vote_id`      mediumint(8) unsigned NOT NULL default '0',
    `vote_user_id` mediumint(8)          NOT NULL default '0',
    `vote_user_ip` char(32)              NOT NULL default '',
    KEY `vote_id` (`vote_id`),
    KEY `vote_user_id` (`vote_user_id`),
    KEY `vote_user_ip` (`vote_user_ip`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `bb_words`
(
    `word_id`     mediumint(8) unsigned NOT NULL auto_increment,
    `word`        char(100)             NOT NULL default '',
    `replacement` char(100)             NOT NULL default '',
    PRIMARY KEY (`word_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

INSERT INTO `bb_words` (`word_id`, `word`, `replacement`)
VALUES (1, 'megashara.com', '*другой трекер*'),
       (2, 'torrents.ru', '*другой трекер*'),
       (3, 'free-torrents.org', '*другой трекер*'),
       (4, 'powertracker.org', '*другой трекер*'),
       (5, 'uniongang.ru', '*другой трекер*'),
       (6, 'hdtracker.ru', '*другой трекер*'),
       (7, 'x-torrents.ru', '*другой трекер*'),
       (8, 'pornolab.net', '*другой трекер*'),
       (9, 'tracker.hdclub.com.ua', '*другой трекер*'),
       (10, 'vanogroup.ru', '*другой трекер*'),
       (11, 'interfilm.nu', '*другой трекер*'),
       (12, 'tracker.0day.kiev.ua', '*другой трекер*'),
       (13, 'animereactor.ru', '*другой трекер*'),
       (14, 'narutofilm.tv', '*другой трекер*'),
       (15, 'pirat.ca', '*другой трекер*'),
       (16, 'disneyjazz.net', '*другой трекер*'),
       (17, 'nnm-club.ru', '*другой трекер*'),
       (18, 'i.piccy.info', '*другой хостинг картинок*'),
       (21, 'hotregion.ru', '*другой трекер*'),
       (22, 'Русский щит', '*некая организация*'),
       (23, 'piratbit.net', '*другой трекер*'),
       (24, 'bit-torrent.bz', '*другой трекер*'),
       (25, 'kinofans.tv', '*другой трекер*'),
       (26, 'pslan.com', '*другой трекер*'),
       (27, 'torrent.rus.ec', '*другой трекер*'),
       (28, 'streamzone.org', '*другой трекер*'),
       (29, 'file-tracker.net', '*другой трекер*'),
       (30, 'tracker.dxp.ru', '*другой трекер*'),
       (31, 'tr.anidub.com', '*другой трекер*'),
       (32, 'torrents.newdeaf.net', '*другой трекер*'),
       (33, 'demax.kiev.ua', '*другой трекер*'),
       (34, 'kinoarena.tv', '*другой трекер*'),
       (35, 'torrentclub.su', '*другой трекер*'),
       (36, 'kinorun.com', '*другой трекер*'),
       (37, 'rutracker.org', '*другой трекер*'),
       (38, 'goldenshara.com', '*другой трекер*'),
       (41, 'seedoff.net', '*другой трекер*'),
       (40, 'kinozal.tv', '*другой трекер*'),
       (42, 'tfile.ru', '*другой трекер*'),
       (43, 'bit2bit.org', '*другой трекер*'),
       (44, 'kinozalsat.com', '*другой трекер*'),
       (45, 'rutor.org', '*другой трекер*'),
       (46, 'opensharing.org', '*другой трекер*'),
       (47, 'ya-torrent.com', '*другой трекер*'),
       (48, 'bt-team.org', '*другой трекер*'),
       (49, 'exkinoray.tv', '*другой трекер*'),
       (50, 'dht-tracker.org', '*другой трекер*'),
       (51, 'bithouse.org', '*другой трекер*'),
       (52, 'club-films.tv', '*другой трекер*'),
       (53, 'wtracker.net', '*другой трекер*'),
       (54, 'riper.am', '*другой трекер*'),
       (55, 'kinozal.md', '*другой трекер*'),
       (56, 'book.libertorrent.com', '*другой трекер*'),
       (57, 'novafilm.tv', '*другой трекер*'),
       (58, 'dc.ru-board.com', '*другой трекер*'),
       (59, 'tt.animedia.tv', '*другой трекер*'),
       (60, 'freetorrents.org.ua', '*другой трекер*'),
       (61, 'games-portal.org', '*другой трекер*'),
       (62, 'newstudio.tv', '*другой трекер*'),
       (63, 'thepiratebay.org', '*другой трекер*'),
       (64, 'beeretracker.ru', '*другой трекер*'),
       (65, 'relizlab.com', '*другой трекер*'),
       (66, 'x-tracker.ru', '*другой трекер*'),
       (67, 'kinozalsat.net', '*другой трекер*'),
       (68, '1001cinema.ru', '*другой трекер*'),
       (69, 'othfilm.ru', '*другой трекер*'),
       (70, 'zone360.net', '*другой трекер*'),
       (71, '1-hd.tv', '*другой трекер*'),
       (72, 'etorrent.ru', '*другой трекер*'),
       (73, 'friends-torrent.com', '*другой трекер*'),
       (74, 'evolution-trek.com', '*другой трекер*'),
       (75, 'deaf-arena.tv', '*другой трекер*'),
       (76, 'openpron.com', '*другой трекер*'),
       (77, 'x360-club.org', '*другой трекер*'),
       (78, 'bit-tracker.ru', '*другой трекер*'),
       (79, 'torrent.4free.in.ua', '*другой трекер*'),
       (80, 'media-torrent.net', '*другой трекер*'),
       (81, '24-x.info', '*другой трекер*'),
       (82, 'butovogroup.ru', '*другой трекер*'),
       (83, 'muzkino.net.ua', '*другой трекер*'),
       (84, 'interfilm.info', '*другой трекер*'),
       (85, 'torrent-online.ru', '*другой трекер*'),
       (86, 'ua-torrent.com', '*другой трекер*'),
       (87, 'torrent-tracker.ru', '*другой трекер*'),
       (88, 'bwtorrents.ru', '*другой трекер*'),
       (89, 'cinemastreet.org', '*другой трекер*'),
       (90, 'space-ua.net', '*другой трекер*'),
       (91, 'loadmd.com', '*другой трекер*'),
       (92, 'abcool.ru', '*другой трекер*'),
       (93, 'tr.opendub.ru', '*другой трекер*'),
       (94, 'audiobit.ru', '*другой трекер*'),
       (95, 'tapochek.net', '*другой трекер*'),
       (96, 'kinomir.us', '*другой трекер*'),
       (97, 'xt13.net', '*другой трекер*'),
       (98, 'empirekino.net', '*другой трекер*'),
       (99, 'rus-torrents.ru', '*другой трекер*'),
       (100, 'torrente.md', '*другой трекер*'),
       (101, 'jesus-torrent.info', '*другой трекер*'),
       (102, 'bittorrent.od.ua', '*другой трекер*'),
       (103, 'soft-tracker.com', '*другой трекер*'),
       (104, 'm-media.by', '*другой трекер*'),
       (105, 'torrentmac.org', '*другой трекер*'),
       (106, 'generalfilm.ru', '*другой трекер*'),
       (107, 'tracker.psihov.net.ua', '*другой трекер*'),
       (108, 'muzbox.org', '*другой трекер*'),
       (109, 'losslessclub.com', '*другой трекер*'),
       (110, 'kinoclub.org', '*другой трекер*'),
       (111, 'flintfilms.ru', '*другой трекер*'),
       (112, 'kinofantasy.com', '*другой трекер*'),
       (113, 'kaztorka.org', '*другой трекер*'),
       (114, 'rustorka.com', '*другой трекер*'),
       (115, 'piratca.org', '*другой трекер*'),
       (120, 'http://tr.anidub.com', '*другой трекер*'),
       (121, 'порно', '*мурзилка*'),
       (123, 'porno', '*мурзилка*'),
       (122, 'porn', '*мурзилка*');

CREATE TABLE IF NOT EXISTS `buf_last_seeder`
(
    `topic_id`         mediumint(8) unsigned NOT NULL default '0',
    `seeder_last_seen` int(11)               NOT NULL default '0',
    PRIMARY KEY (`topic_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `buf_topic_view`
(
    `topic_id`    mediumint(8) unsigned NOT NULL default '0',
    `topic_views` mediumint(8) unsigned NOT NULL default '0',
    PRIMARY KEY (`topic_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `donor`
(
    `donor_id`   int(11)    NOT NULL,
    `donator_id` int(11)    NOT NULL,
    `data`       timestamp  NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
    `upload`     bigint(20) NOT NULL,
    KEY `donor_id` (`donor_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `donor_rules`
(
    `donor_group`   int(11) NOT NULL,
    `donator_group` int(11) NOT NULL,
    `ratio`         float   NOT NULL,
    PRIMARY KEY (`donor_group`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `seo_link_log`
(
    `uri`  varchar(255) NOT NULL,
    `link` text         NOT NULL,
    PRIMARY KEY (`uri`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `seo_urls`
(
    `topic_id` mediumint(8) UNSIGNED NOT NULL DEFAULT 0,
    `anchor`   varchar(255)          NOT NULL DEFAULT '',
    PRIMARY KEY (`topic_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `sph_counter`
(
    `counter_id` int(11) NOT NULL,
    `max_doc_id` int(11) NOT NULL,
    PRIMARY KEY (`counter_id`)
) ENGINE = MyISAM
  DEFAULT CHARSET = utf8;
