<?php

// ACP Header - START
if (!empty($setmodules))
{
	$module['Groups']['Manage'] = basename(__FILE__);
	return;
}
require('./pagestart.php');
// ACP Header - END

require(INC_DIR .'functions_group.'. PHP_EXT);

$group_id = (@$_REQUEST[POST_GROUPS_URL]) ? intval($_REQUEST[POST_GROUPS_URL]) : 0;
$mode     = (@$_REQUEST['mode']) ? strval($_REQUEST['mode']) : '';

attachment_quota_settings('group', @$_POST['group_update'], $mode);

if (!empty($_POST['edit']) || !empty($_POST['new']))
{
	if (!empty($_POST['edit']))
	{
		if (!$row = get_group_data($group_id))
		{
			bb_die($lang['Group_not_exist']);
		}
		$group_info = array(
			'group_name'        => $row['group_name'],
			'group_description' => $row['group_description'],
			'group_moderator'   => $row['group_moderator'],
			'group_mod_name'    => $row['moderator_name'],
			'group_type'        => $row['group_type'],
			// dj_maxx: add user rank select
                        'group_rank'        => $row['group_rank'], 
			// end of
			// dj_maxx: add custom group properties
			'group_vip'	    => (int) $row['group_vip'],
			'group_releaser'    => (int) $row['group_releaser'],
			'group_half_dl'	    => (int) $row['group_half_dl'],
			// dj_maxx: add group color
			'group_color'	    => $row['group_color'],
			// end of
			// end of
		);
		$mode = 'editgroup';
		$template->assign_block_vars('group_edit', array());
	}
	else if (!empty($_POST['new']))
	{
		$group_info = array(
			'group_name'        => '',
			'group_description' => '',
			'group_moderator'   => '',
			'group_mod_name'    => '',
			'group_type'        => GROUP_OPEN,
			// dj_maxx: add user rank select
                	'group_rank'        => '', 
			// end of
			// dj_maxx: add custom group properties
			'group_vip'	    => 0,
			'group_releaser'    => 0,
			'group_half_dl'	    => 0,
			// dj_maxx: add group color
			'group_color'	    => '',
			// end of
			// end of
		);
		$mode = 'newgroup';
	}

	// Ok, now we know everything about them, let's show the page.
	$s_hidden_fields = '
		<input type="hidden" name="mode" value="'. $mode .'" />
		<input type="hidden" name="'. POST_GROUPS_URL .'" value="'. $group_id .'" />
	';


	// dj_maxx: add user rank select
        $sql = "SELECT * FROM " . RANKS_TABLE . "
                WHERE rank_special = 1
                ORDER BY rank_title";

        if ( !($result = $db->sql_query($sql)) )
        {
               message_die(GENERAL_ERROR, 'Could not obtain ranks data', '', __LINE__, __FILE__, $sql);
        }

        $rank_select_box = '<option value="0">' . $lang['NO'] . '</option>';

        while ( $row = $db->sql_fetchrow($result) )
        {
                $rank = $row['rank_title'];
                $rank_id = $row['rank_id'];

                $selected = ( $group_info['group_rank'] == $rank_id ) ? ' selected="selected"' : '';
                $rank_select_box .= '<option value="' . $rank_id . '"' . $selected . '>' . $rank . '</option>';
        }
	// end of


	$template->assign_vars(array(
		'TPL_EDIT_GROUP'         => true,

		'GROUP_NAME'             => htmlspecialchars($group_info['group_name']),
		'GROUP_DESCRIPTION'      => htmlspecialchars($group_info['group_description']),
		'GROUP_MODERATOR'        => replace_quote($group_info['group_mod_name']),
		'T_GROUP_EDIT_DELETE'    => ($mode == 'newgroup') ? $lang['CREATE_NEW_GROUP'] : $lang['Edit_group'],
		'U_SEARCH_USER'          => append_sid(BB_ROOT ."search.$phpEx?mode=searchuser"),

		// dj_maxx: add user rank select
	        'RANK_SELECT_BOX'        => $rank_select_box,
            	'L_SELECT_RANK'          => $lang['Rank_title'],
      		'GROUP_RANK'             => replace_quote($group_info['group_rank']), 
		// end of

		// dj_maxx: add custom group properties
		'S_GROUP_PRIV_VIP'	=> $group_info['group_vip'],
		'S_GROUP_PRIV_RELEASER'	=> $group_info['group_releaser'],
		'S_GROUP_PRIV_HALF_DL'	=> $group_info['group_half_dl'],
		'S_GROUP_PRIV_VIP_CHECKED'	=> $group_info['group_vip'] == 1 ? HTML_CHECKED : '',
		'S_GROUP_PRIV_RELEASER_CHECKED'	=> $group_info['group_releaser'] == 1 ? HTML_CHECKED : '',
		'S_GROUP_PRIV_HALF_DL_CHECKED'	=> $group_info['group_half_dl'] == 1 ? HTML_CHECKED : '',
		// dj_maxx: add group color
		'GROUP_COLOR'			=> $group_info['group_color'],
		// end of
		// end of

		'S_GROUP_OPEN_TYPE'      => GROUP_OPEN,
		'S_GROUP_CLOSED_TYPE'    => GROUP_CLOSED,
		'S_GROUP_HIDDEN_TYPE'    => GROUP_HIDDEN,
		'S_GROUP_OPEN_CHECKED'   => ($group_info['group_type'] == GROUP_OPEN) ? HTML_CHECKED : '',
		'S_GROUP_CLOSED_CHECKED' => ($group_info['group_type'] == GROUP_CLOSED) ? HTML_CHECKED : '',
		'S_GROUP_HIDDEN_CHECKED' => ($group_info['group_type'] == GROUP_HIDDEN ) ? HTML_CHECKED : '',
		'S_GROUP_ACTION'         => append_sid("admin_groups.$phpEx"),
		'S_HIDDEN_FIELDS'        => $s_hidden_fields,
	));
}
else if (!empty($_POST['group_update']))
{
	if (!empty($_POST['group_delete']))
	{
		if (!$group_info = get_group_data($group_id))
		{
			bb_die($lang['Group_not_exist']);
		}
		// Delete Group
		delete_group($group_id);

		$message = $lang['Deleted_group'] .'<br /><br />';
		$message .= sprintf($lang['Click_return_groupsadmin'], '<a href="'. append_sid("admin_groups.$phpEx") .'">', '</a>') .'<br /><br />';
		$message .= sprintf($lang['Click_return_admin_index'], '<a href="'. append_sid("index.$phpEx?pane=right") .'">', '</a>');

		bb_die($message);
	}
	else
	{
		$group_type = isset($_POST['group_type']) ? intval($_POST['group_type']) : GROUP_OPEN;
		$group_name = isset($_POST['group_name']) ? trim($_POST['group_name']) : '';
		$group_desc = isset($_POST['group_description']) ? trim($_POST['group_description']) : '';

		// dj_maxx: add user rank select
	        $group_rank = isset($_POST['group_rank']) ? trim($_POST['group_rank']) : ''; 
		// end of


		$group_moderator = isset($_POST['username']) ? $HTTP_POST_VARS['username'] : '';

		// dj_maxx: add custom group properties
		$group_vip = isset($_POST['group_priv_vip']) ? 1 : 0;
		$group_releaser = isset($_POST['group_priv_releaser']) ? 1 : 0;
		$group_half_dl = isset($_POST['group_priv_half_dl']) ? 1 : 0;
		// dj_maxx: add group color
		$group_color = isset($_POST['group_color']) ? trim($_POST['group_color']) : '';
		// end of
		// end of

		if ($group_name === '')
		{
			bb_die($lang['No_group_name']);
		}
		else if ($group_moderator === '')
		{
			bb_die($lang['No_group_moderator']);
		}
		$this_userdata = get_userdata($group_moderator, true);

		if (!$group_moderator = $this_userdata['user_id'])
		{
			bb_die($lang['No_group_moderator']);
		}

		$sql_ary = array(
			'group_type'        => (int) $group_type,
			'group_name'        => (string) $group_name,
			'group_description' => (string) $group_desc,
			'group_moderator'   => (int) $group_moderator,
			'group_single_user' => 0,
			// dj_maxx: add user rank select
            		'group_rank' => (int) $group_rank, 
			// end of
			// dj_maxx: add custom group properties
			'group_vip'	    => $group_vip,
			'group_releaser'    => $group_releaser,
			'group_half_dl'	    => $group_half_dl,
			// dj_maxx: add group color
			'group_color'		=> $group_color,
			// end of
			// end of
		);

		if ($mode == "editgroup")
		{
			if (!$group_info = get_group_data($group_id))
			{
				bb_die($lang['Group_not_exist']);
			}

			if ($group_info['group_moderator'] != $group_moderator)
			{
				// Create user_group for new group's moderator
				add_user_into_group($group_id, $group_moderator);

				// Delete old moderator's user_group
				if (@$_POST['delete_old_moderator'])
				{
					delete_user_group($group_id, $group_info['group_moderator']);
				}
			}

			$sql_args = $db->build_array('UPDATE', $sql_ary);

			// Update group's data
			$db->query("UPDATE ". GROUPS_TABLE ." SET $sql_args WHERE group_id = $group_id");

			// dj_maxx: add custom group properties
			update_user_level('all');
			// end of

			$message = $lang['Updated_group'] .'<br /><br />';
			$message .= sprintf($lang['Click_return_groupsadmin'], '<a href="'. append_sid("admin_groups.$phpEx") .'">', '</a>') .'<br /><br />';
			$message .= sprintf($lang['Click_return_admin_index'], '<a href="'. append_sid("index.$phpEx?pane=right") .'">', '</a>');

			bb_die($message);
		}
		else if ($mode == 'newgroup')
		{
			$sql_args = $db->build_array('INSERT', $sql_ary);

			// Create new group
			$db->query("INSERT INTO ". GROUPS_TABLE ." $sql_args");
			$new_group_id = $db->sql_nextid();

			// Create user_group for group's moderator
			add_user_into_group($new_group_id, $group_moderator);

			$message = $lang['Added_new_group'] .'<br /><br />';
			$message .= sprintf($lang['Click_return_groupsadmin'], '<a href="'. append_sid("admin_groups.$phpEx") .'">', '</a>') .'<br /><br />';
			$message .= sprintf($lang['Click_return_admin_index'], '<a href="'. append_sid("index.$phpEx?pane=right") .'">', '</a>');

			bb_die($message);
		}
		else
		{
			bb_die($lang['No_group_action']);
		}
	}
}
else
{
	$template->assign_vars(array(
		'TPL_GROUP_SELECT' => true,

		'S_GROUP_ACTION'   => append_sid("admin_groups.$phpEx"),
		'S_GROUP_SELECT'   => get_select('groups'),
	));
}

print_page('admin_groups.tpl', 'admin');
