<?php

define('IN_ADMIN', true);
define('BB_ROOT', './../../');
require(BB_ROOT .'common.php');

$tmp_tbl = 'coolness';

$db->query("
	CREATE TEMPORARY TABLE $tmp_tbl (
		user_id  mediumint(8) UNSIGNED NOT NULL default '0',
		seed_bonus  float(8,1) NOT NULL default '0.0',
		longevity  float(8,1) NOT NULL default '0.0',
		lazyness  float(8,1) NOT NULL default '0.0',
		reputation  mediumint(8) NOT NULL default '0',
		releases  mediumint(8) NOT NULL default '0',
		released  bigint(20) NOT NULL default '0',
		PRIMARY KEY (user_id)
	) ENGINE = MYISAM
");

$db->query("
	INSERT INTO $tmp_tbl
	SELECT 
		u.user_id, 
		IFNULL(ut.user_bonus,0) as seed_bonus,
		(UNIX_TIMESTAMP() - u.user_regdate) / (3600*24) as longevity,
		(UNIX_TIMESTAMP() - u.user_session_time) / (3600*24) as lazyness,
		u.user_reputation as reputation,
		(SELECT count(*) FROM bb_bt_torrents t WHERE t.poster_id = u.user_id) as releases,
		(SELECT IFNULL(SUM(t.size),0) FROM bb_bt_torrents t WHERE t.poster_id = u.user_id) as released
	FROM 
		bb_users u
		LEFT JOIN bb_bt_users ut ON (u.user_id = ut.user_id)
	WHERE u.user_id > 1 AND u.user_active = 1
");

$max_seed_bonus = 0;
$max_longevity = 0;
$max_reputation = 0;
$max_releases = 0;
$max_released = 0;

$row = $db->fetch_row("
	SELECT 
		MAX(seed_bonus) as max_bonus,
		MAX(longevity)  as max_longevity,
		MAX(reputation) as max_reputation,
		MAX(releases)   as max_releases,
		MAX(released)   as max_released
	FROM $tmp_tbl
");

$max_seed_bonus = $row['max_bonus'];
$max_longevity = $row['max_longevity'];
$max_reputation = $row['max_reputation'];
$max_releases = $row['max_releases'];
$max_released = $row['max_released'];

// debug
echo $max_seed_bonus."<br>".$max_longevity."<br>".$max_reputation."<br>".$max_releases."<br>".$max_released;


$db->query("
	UPDATE bb_users u 
	INNER JOIN $tmp_tbl t ON (u.user_id = t.user_id)
	SET u.user_coolness = 1000.0 * ( (t.seed_bonus / $max_seed_bonus) + 0.5*((t.longevity - t.lazyness) / $max_longevity) + (t.reputation / $max_reputation) + (t.releases / $max_releases) + (t.released / $max_released) )

");




$db->query("DROP TEMPORARY TABLE $tmp_tbl");

?>