<?php
/**
 *
 * @name Awards moderator control panel
 * @package Awards Mod
 * @author lEx0 <lEx0.kz@gmail.com>
 *
 */

define('IN_PHPBB',   true);
define('BB_ROOT', './');
$phpEx = substr(strrchr(__FILE__, '.'), 1);
require(BB_ROOT ."common.php");

require 'includes/functions_awards.php';
$user->session_start( array( 'req_login' => TRUE ) );

$l = get_awards( );

if( count( $l ) <= 0 && !IS_ADMIN )
{
	message_die( GENERAL_ERROR, $lang['AW_ACCESS_DND'] );
}
elseif( count( $l ) <= 0 && IS_ADMIN )
{
	message_die( GENERAL_ERROR, $lang['AW_MCP_NOT_FND'] );
}

$mode = (string) @$_GET['mode'];
$template->assign_vars(array(
	'PAGE_TITLE' 	=> $lang['AW_AWD_CP']
));

switch ( $mode )
{
	case 'ctrl':
		if( !$award_id =  (int) @$_GET['aid'] )
		{
			message_die( GENERAL_ERROR, $lang['AW_INVALID_ID'] );
		}
		/* if( !award_auth( $userdata['user_id'], $award_id, $error_message ) )
		{
			message_die( GENERAL_ERROR, $lang['AW_ACCESS_DND'] );
		} */
		
		$template->assign_vars(array(
			'CTR'					=> TRUE,
			'USERS_HANDED_AWARD'	=> $lang['AW_AWD_HANDEDS'],
			'AW_USER'				=> $lang['AW_USER'],
			'AW_REASON'				=> $lang['AW_ZA'],
			'AW_DATE'				=> $lang['AW_KOGDA'],
			'AW_DELETE_THIS'		=> $lang['AW_CFR_DEL_AWD'],
			'AW_DELETE'				=> $lang['AW_DEL_USR_AWD'],
			'AW_FUNCTION'			=> $lang['AW_FUNCTION'],
			'AWD_MCP'				=> $lang['AW_AWD_CP'],
		));
		$aw_us = get_handed_users( $award_id );
		if( count($aw_us) <= 0 )
		{
			meta_refresh( 'awards.php', 3 );
			message_die( GENERAL_ERROR, $lang['AW_THS_AWD_N_H'] );
		}
		
		foreach( $aw_us AS $aw_g )
		{
			$template->assign_block_vars( 'awrow', array(
				'USER'		=> get_username($aw_g['award_holder']),
				'REASON'	=> $aw_g['award_reason'] ? $aw_g['award_reason'] : ' ',
				'DATE'		=> bb_date($aw_g['award_time'], $bb_cfg['post_date_format']),
				'HID'		=> $aw_g['award_hid']
			));
		}
		
		print_page( 'awards.tpl' );
		
		break;
	case 'add_pre':
		if( !$award_id =  (int) @$_GET['aid'] )
		{
			message_die( GENERAL_ERROR, $lang['AW_INVALID_ID'] );
		}
		$template->assign_vars( array(
			'ADD'			=> TRUE,
			'AW_HAND_AWARD'	=> $lang['AW_HAND_USER'],
			'AW_USERA'		=> $lang['AW_USERA'],
			'AW_REASON'		=> $lang['AW_ZA'],
			'AW_SEND'		=> $lang['AW_HAND'],
//			'AW_FIND_USER'	=> $lang['AW_FIND_USER'],
			'AWARD_ID'		=> $award_id
		));
		print_page( 'awards.tpl' );
		break;
	case 'add':
		if( !$award_id =  (int) @$_GET['aid'] )
		{
			message_die( GENERAL_ERROR, $lang['AW_INVALID_ID'] );
		}
		if( !$aw_user_list = (string) @$_GET['username'] )
		{
			message_die( GENERAL_ERROR, $lang['AW_USER_IN_VLD'] );
		}
		$reason = replace_special_chars( ((string) @$_GET['reason']) ? (string) @$_GET['reason'] : '' );
		
		$aw_users = explode("\r\n", $aw_user_list);
		$aw_users = array_filter($aw_users, 'trim');
		
		if( !award_auth( $userdata['user_id'], $award_id, $error_message ) )
		{
			message_die( GENERAL_ERROR, $lang['AW_ACCESS_DND'] );
		}
		
		$error = '';
		
		foreach ($aw_users as $line)
		{
		
		    $aw_s	= $db->fetch_row( "SELECT user_id FROM " . USERS_TABLE . " WHERE username = '" . $db->escape_string( (string) $line ) . "'" );
		    $aw_user 	= $aw_s['user_id'];
		
		    if( !$aw_user )
		    {
			    $error .= "$line - ".$lang['AW_USER_N_FND']."</br>\n";
		    }

		    if ( !set_user_award( $aw_user, $award_id, $error_message, $reason ) )
		    {
			    $error .= "$line - $error_message</br>\n";
		    }
		}

		meta_refresh( 'awards.php', 5 );
		
		if ($error != '')
		{
		    message_die( GENERAL_ERROR, $error);
		}
		else
		{
		    message_die( GENERAL_ERROR, $lang['AW_USER_I_HND'] . implode(', ', $aw_users) . '</b>');
		}
		
		break;
	case 'del':
		if( !$award_hid =  (int) @$_GET['hid'] )
		{
			message_die( GENERAL_ERROR, $lang['AW_INVALID_ID'] );
		}
		$award_id = $db->fetch_row( "SELECT award_id FROM " . BB_AWARD_HOLDERS . " WHERE award_hid = " . (int) $award_hid );
		if( !award_auth( $userdata['user_id'], $award_id['award_id'], $error_message ) )
		{
			message_die( GENERAL_ERROR, $lang['AW_ACCESS_DND'] );
		}
		
		if( !del_user_awards( $award_hid, $error_message ) )
		{
			message_die( GENERAL_ERROR, $error_message );
		}
		
		meta_refresh( 'awards.php?mode=ctrl&aid=' .$award_id['award_id'], 1 );
		message_die( GENERAL_MESSAGE, $lang['AW_USER_DLT_AW'] );
		
		break;
	default:
		
		$template->assign_vars( array(
			'DEF'			=> TRUE,
			'AWD_MCP'		=> $lang['AW_AWD_CP'],
			'AWD_TITLE'		=> $lang['AW_AWARD_NAME'],
			'AWD_DESCRIPTION' => $lang['Description'],
			'AWD_HOLDERS'	=> $lang['AW_HANDED'],
			'AWD_FUNCTION'	=> $lang['AW_FUNCTION'],
			'AWD_SET'		=> $lang['AW_HAND'],
			'AWD_ACP'		=> $lang['AW_DETAIL'],
		));
		
		foreach( $l as $r )
		{
			$template->assign_block_vars( 'aw', array(
				'award_title'	=> $r['award_title'],
				'award_file'	=> $r['award_file'],
				'award_holders'	=> isset($r['users']) ? $r['users'] : $lang['NO'],
			    'award_description'	=> $r['award_description'],
				'award_id'		=> $r['award_id'],
			    'award_my'      => ($r['award_moder'] == $userdata['user_id']),
			));
		}
		print_page( 'awards.tpl' );
		break;
}