<?php

define('IN_PHPBB', true);
define('IN_SCRAPER', true);

define('TR_ROOT', './');
define('BB_ROOT', './../');

define('SCRAPER_PREFIX', 'scr_');  // for cache

require(BB_ROOT .'common.php');
require(TR_ROOT .'includes/scraper/udptscraper.php');
require(TR_ROOT .'includes/scraper/httptscraper.php');

error_reporting(E_ALL ^ E_NOTICE);

// config
// public tracker list (same as can be glued to torrentfile) with scrape support
$trackerlist = array('udp://46.148.18.250:2710',
	                 'udp://tracker.openbittorrent.com:80/announce',
	                 'udp://tracker.leechers-paradise.org:6969',
	                 'udp://exodus.desync.com:6969',
	                 'udp://tracker.coppersurfer.tk:6969'
);

$info_hash = isset($_REQUEST['info_hash']) ? $_REQUEST['info_hash'] : ''; 
$seeders = 0; $leechers = 0; $conerr = false; $parseerr = false;

$info_hash_sql = rtrim($db->escape(pack('H*', $info_hash)), ' ');

$cache_used = ($info_hash == 'paste-info-hash-to-bypass-cache') ? 0 : $tr_cache->used; // some debugging (no cache for developer)

$info = $cache_used ? $tr_cache->get(SCRAPER_PREFIX . $info_hash) : '';
if (!$info)
{
	foreach ($trackerlist as $tracker)
	{
		$conerr  = false; $parseerr = false;
		
		try {
			if (strpos($tracker, 'http://') !== false)
			{
				$scraper = new httptscraper(2);
				$ret = $scraper->scrape($tracker, array($info_hash));
			}
			elseif (strpos($tracker, 'udp://') !== false)
			{
				$scraper = new udptscraper(2);
				$ret = $scraper->scrape($tracker, array($info_hash));
			}
			else
			{
				$ret = array();
			}

			$seeders  = @$ret[$info_hash]['seeders'];
			$leechers = @$ret[$info_hash]['leechers'];	

		} catch (ScraperException $e) {
			if ($e->isConnectionError())
			{
				// echo ('SCRAPE: connect error: ' . $e->getMessage());
				$conerr = true;
			}
			else
			{
				$parseerr = true;
				// echo ('Scrape error: ' . $e->getMessage());
			}
		}
		// if seeds found dont't try next tracker (assume seedlist is same on all trackers)
		if ($seeders > 0 || $leechers > 0) break; // TODO: rewrite all
	} 

	// try rutracker if not enough seeds found
	if ($seeders < 10)
	{
		require (BB_ROOT . 'includes/functions_torrent.php');
		require (BB_ROOT . 'includes/class.snoopy.php');

		$seeds = $leechs = 0; $url = '';

		$row = $db->fetch_row("SELECT ad.physical_filename 
				FROM " . BT_TORRENTS_TABLE . " bt LEFT JOIN " . ATTACHMENTS_DESC_TABLE . " ad ON (bt.attach_id = ad.attach_id) 
				WHERE bt.info_hash = '$info_hash_sql'");
		
		$physical_filename = $row['physical_filename'];

		if ($tor = bdecode_file(get_attachments_dir() .'/'.$physical_filename))
		{
			$url = $tor['publisher-url'];
            if (!preg_match("/rutracker|nnm-club|nnmclub/is", $url))
            {
			    $url = $tor['comment'];
            }
			
		}
        $url = str_replace("https", "http", $url);
		if (preg_match('~^http://rutracker.org/(.*)$~',$url))
		{
			$snoopy = new Snoopy;
			$snoopy->host = "rutracker.org";
			$snoopy->agent = "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)";
			$snoopy->referer = "http://rutracker.org/";
			$snoopy->rawheaders["Pragma"] = "no-cache";
			//$snoopy->proxy_host = "91.121.66.28";
			//$snoopy->proxy_port = "3128";

			$submit_url = "http://rutracker.org/forum/login.php";
			$snoopy->_submit_method = "POST";
			$submit_vars = array (
				'login_username' => "shaitanamanama",
				'login_password' => "MWcw6",

				'login' => '',
			);
			$snoopy->submit($submit_url, $submit_vars);

			$snoopy->_httpmethod = "GET";
			$snoopy->fetch($url);

			//echo $snoopy->results;

			if (preg_match('~(?:.*):&nbsp; <b>([0-9]+)</b></span>(?:.*)~is', $snoopy->results, $regs))
			{
				$seeds = $regs[1];
			} 
			if (preg_match('~(?:.*):&nbsp; <b>([0-9]+)</b></span>(?:.*)~is', $snoopy->results, $regs))
			{
				$leechs = $regs[1];
			}
			
			bb_log(date("H:i:s")." - ".$url.', S: '.$seeds.', L: '.$leechs.LOG_LF, "scrape_announce");

		}


		elseif (preg_match('~^http://nnm(.*)$~',$url))
		{
			$snoopy = new Snoopy;
			$snoopy->host = "nnmclub.to";
			$snoopy->agent = "Mozilla/5.0 (X11; Linux x86_64; rv:24.0) Gecko/20100101 Firefox/24.0 Iceweasel/24.0";
			$snoopy->referer = "http://nnmclub.to/";
			$snoopy->rawheaders["Pragma"] = "no-cache";
			//$snoopy->proxy_host = "91.197.4.100";
			//$snoopy->proxy_port = "3128";

			$submit_url = "http://nnmclub.to/forum/login.php";
			$snoopy->_submit_method = "POST";
			$submit_vars = array (
				'username' => "kernelpanic01",
				'password' => "boogaga",
				'login' => '',
			);
			$snoopy->submit($submit_url, $submit_vars);
			$snoopy->_httpmethod = "GET";
			$snoopy->fetch($url);

			if (preg_match('~(?:.*)<span class="seed">\[ <b>([0-9]+) &nbsp;(?:.*)~is', $snoopy->results, $regs)) 
			{
				$seeds = $regs[1];
			} 
			if (preg_match('~(?:.*)<span class="leech">\[ <b>([0-9]+) &nbsp;(?:.*)~is', $snoopy->results, $regs))
			{
				$leechs = $regs[1];
			}
			
			bb_log(date("H:i:s")." - ".$url.', S: '.$seeds.', L: '.$leechs.LOG_LF, "scrape_announce");

		}


		if ($seeds > $seeders) $seeders = $seeds;
		if ($leechs > $leechers) $leechers = $leechs;

	}
	
	// found seeders - clear previous trackers error flags
	if ($seeders > 0)
	{
		$conerr = false;
		$parseerr = false;

		// some magic to cheat seeders count
		$seeders = floor($seeders*1.33);
	}
		
	// updata scrape stats for visualization
	$row = $db->fetch_row("SELECT topic_id FROM " . BT_TORRENTS_TABLE . " WHERE info_hash = '$info_hash_sql'");
	$topic_id = intval($row['topic_id']);
	
	if ($topic_id)
	{
		if (!$conerr && !$parseerr)
		{
			$current_timestamp = TIMENOW;   
			
			$db->query("UPDATE bb_bt_scrape 
						SET seeders = $seeders, 
							leechers = $leechers, 
							scrape_time = $current_timestamp 
						WHERE topic_id = $topic_id");
			if ($db->sql_affectedrows() == 0)
			{
				$db->query("INSERT INTO bb_bt_scrape (topic_id, seeders, leechers, scrape_time) 
							VALUES ($topic_id, $seeders, $leechers, $current_timestamp)");
			}
		}
		else  // use old values if can't get new
		{
			if ($row = $db->fetch_row("SELECT seeders, leechers FROM bb_bt_scrape WHERE topic_id = $topic_id"))
			{
				$seeders = $row['seeders'];
				$leechers = $row['leechers'];
			}
		}
	}
	// end of
	
	$info = "<span class='seedmed'>S: $seeders;</span> <span class='leechmed'>L: $leechers</span>";
	
	if ($cache_used) $tr_cache->set(SCRAPER_PREFIX . $info_hash, $info, 1200);
	
}

echo $info;

?>
