<?php

if (!defined('BB_ROOT')) die(basename(__FILE__));

$forums = $datastore->get('cat_forums');
$forbidden_forums = $forums['not_auth_forums']['guest_read'];

// avoid usage of f$#king make_url which is web server dependant
$server_url = 'http://' . $bb_cfg['sitename'] . $bb_cfg['script_path'];
//

$sql = "SELECT	t.forum_id,
				t.topic_id,
				t.topic_title, 
				t.topic_time,
				tor.attach_id,
				tor.size,
				(ts.seeders + ts.seeders_ext) AS seeders,
				(ts.leechers + ts.leechers_ext) AS leechers
		FROM 
			bb_topics t 
			LEFT JOIN bb_bt_torrents tor ON t.topic_id = tor.topic_id
			LEFT JOIN bb_bt_tracker_snap ts ON t.topic_id = ts.topic_id
		WHERE 
			t.topic_dl_type = 1 AND
			tor.tor_status = 2 AND
			
			t.forum_id NOT IN ($forbidden_forums)
		ORDER BY t.topic_time DESC";
		
$rows = $db->fetch_rowset($sql);

$xml =  "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
$xml .= "<torrents>\n";

foreach ($rows as $row)
{
	$forum_id = $row['forum_id'];
	$parent_id = $forums['f'][$forum_id]['forum_parent'];
	$cat_id = $forums['f'][$forum_id]['cat_id'];
	$forum_name = ($parent_id ? $forums['f'][$parent_id]['forum_name'] : '')." > ".$forums['f'][$forum_id]['forum_name'];
		
	$category = htmlspecialchars(iconv(AJAX_CHARSET,'UTF-8', $forums['cat_title_html'][$cat_id]." > ".$forum_name));

	$seeders = isset($row['seeders']) ? $row['seeders'] : 0;
	$leechers = isset($row['leechers']) ? $row['leechers'] : 0;
	
	
	$xml .= "   <torrent>\n";
	$xml .= "      <name>".htmlspecialchars(iconv(AJAX_CHARSET,'UTF-8',$row['topic_title']))."</name>\n";
	$xml .= "      <date_add>".$row['topic_time']."</date_add>\n";
	$xml .= "      <url>".$server_url."download.$phpEx?id=".$row['attach_id']."</url>\n";
	$xml .= "      <info>".$server_url."viewtopic.$phpEx?t=".$row['topic_id']."</info>\n";
	$xml .= "      <size>".$row['size']."</size>\n";
	$xml .= "      <category>".$category."</category>\n";
	$xml .= "      <seeders>".$seeders."</seeders>\n";
	$xml .= "      <leechers>".$leechers."</leechers>\n";
	$xml .= "   </torrent>\n";
}

$xml .= "</torrents>\n";

file_put_contents(BB_ROOT.'releases.xml', $xml);
