<?php

if (!defined('BB_ROOT')) die(basename(__FILE__));

$users_per_cycle = 1000;

require_once(INC_DIR .'functions_admin.'. PHP_EXT);

$excluded_users = join(',', array(
	ANONYMOUS,
	BOT_UID,
));

while (true)
{
	set_time_limit(600);

	$prune_users = $not_activated_users = $not_active_users = array();

	if ($not_activated_days = intval($bb_cfg['user_not_activated_days_keep']))
	{
		$sql = "
			SELECT user_id
			FROM ". USERS_TABLE ."
			WHERE user_active    = 0
			  AND user_lastvisit = 0
			  AND user_regdate   < ". (TIMENOW - 86400*$not_activated_days) ."
			  AND user_id        NOT IN($excluded_users)
			LIMIT $users_per_cycle
		";

        // bb_log(date('H:i:s - ') . getmypid() ." TIMENOW => ".TIMENOW.", not_activated_days => $not_activated_days, sql => $sql". LOG_LF, CRON_LOG_DIR .'cron_bug');

		foreach ($db->fetch_rowset($sql) as $row)
		{
			$not_activated_users[] = $row['user_id'];
		}
	}
	if ($not_active_days = intval($bb_cfg['user_not_active_days_keep']))
	{

		$sql = "
			SELECT u.user_id
			FROM ". USERS_TABLE ." u
			LEFT JOIN ". BT_USERS_TABLE ." b USING (user_id)
			WHERE
			  IFNULL(b.u_up_total,0) = 0 AND IFNULL(b.u_down_total,0) = 0 
			  AND u.user_active    = 1
			  AND u.user_posts     = 0
			  AND IF(u.user_lastvisit = 0, u.user_regdate, u.user_lastvisit) < ". (TIMENOW - 86400*$not_active_days) ."
			  AND u.user_id        NOT IN($excluded_users)
			LIMIT $users_per_cycle
		";

        // bb_log(date('H:i:s - ') . getmypid() ." TIMENOW => ".TIMENOW.", not_active_days => $not_active_days, sql => $sql". LOG_LF, CRON_LOG_DIR .'cron_bug');

		foreach ($db->fetch_rowset($sql) as $row)
		{
			$not_active_users[] = $row['user_id'];
		}
	}

	if ($prune_users = $not_activated_users + $not_active_users)
	{
		user_delete($prune_users);
	}

	if (count($prune_users) < $users_per_cycle)
	{
		break;
	}

	sleep(3);
}

unset($prune_users, $not_activated_users, $not_active_users);
