<?php

if (!defined('BB_ROOT')) die(basename(__FILE__));

global $db, $bb_cfg;

$data = array();

// usercount
$row = $db->fetch_row("SELECT COUNT(*) AS usercount FROM ". USERS_TABLE ." WHERE user_id NOT IN(". EXCLUDED_USERS_CSV .")");
$data['usercount'] = $row['usercount'];

// newestuser
$row = $db->fetch_row("SELECT user_id, username FROM ". USERS_TABLE ." ORDER BY user_id DESC LIMIT 1");
$data['newestuser'] = $row;

// post/topic count
$row = $db->fetch_row("SELECT SUM(forum_topics) AS topiccount, SUM(forum_posts) AS postcount FROM ". FORUMS_TABLE);
$data['postcount'] = $row['postcount'];
$data['topiccount'] = $row['topiccount'];


// tracker stats
$row = $db->fetch_row("select count(*) as peercount, count(DISTINCT user_id) as unipeercount, count(DISTINCT topic_id) as torrentcount, SUM(speed_up) as speedup, SUM(speed_down) as speeddown from " . BT_TRACKER_TABLE);
$data['peercount'] = $row['peercount'];
$data['unipeercount'] = $row['unipeercount'];
$data['torrentcount'] = $row['torrentcount'];
$data['speedup'] = $row['speedup'];
$data['speeddown'] = $row['speeddown'];

$row = $db->fetch_row("select count(*) as peercount from " . BT_TRACKER_TABLE . " WHERE seeder = 1");
$data['seeders'] = $row['peercount'];
$row = $db->fetch_row("select count(*) as peercount from " . BT_TRACKER_TABLE . " WHERE seeder = 0");
$data['leechers'] = $row['peercount'];

// dj_maxx: tracker stats incl. external peers
$row = $db->fetch_row("SELECT SUM(seeders_ext) AS seedcount, SUM(leechers_ext) AS peercount FROM " . BT_TRACKER_SNAP_TABLE);
$data['peercount_ext'] = $row['seedcount'] + $row['peercount'];
$data['unipeercount_ext'] = (int) floor($data['peercount_ext'] / 9);
$data['seeders_ext'] = $row['seedcount'];
$data['leechers_ext'] = $row['peercount'];
// end of

// dj_maxx: add warnings & bans
$sql = "SELECT user_id, username, user_level, user_reputation FROM " . USERS_TABLE . " ORDER BY user_reputation DESC LIMIT " . $bb_cfg['respected_count'];

$i = 0;
$data['respected_users'] = '';

foreach($db->fetch_rowset($sql) as $row)
{
	$name = $row['username'];

	switch ($row['user_level'])
	{
		case ADMIN:
			$name = "$name";
			$class = ' class="colorAdmin bold"';
		break;
		case MOD:
			$name = "$name";
			$class = ' class="colorMod bold"';
		break;
		case GROUP_MEMBER:
			$name = "$name";
			$class = ' class="colorGroup bold"';
		break;
		default:
			$class = '';
	}

	$data['respected_users'] .= ($i == 0 ? '' : ', ') . '<a href="' . PROFILE_URL . $row['user_id'] . "\" $class>" . $name . '</a>';

	$i++;
}

$data['respected_users'] = isset($data['respected_users']) ? $data['respected_users'] : '--';
// end of


$this->store('stats', $data);
