<?php
/**
 *
 * @name Awards Mod's function file
 * @package Awards Mod
 * @author lEx0 <lEx0.kz@gmail.com>, dj_maxx <admin@power-club.info>
 *
 */


function replace_special_chars( $text )
{

	$_aEvilEvents = array(
		//  EVENTO-,  XAKEP-
		'onabort',
		'onactivate',
		'onafterprint',
		'onafterupdate',
		'onbeforeactivate',
		'onbeforecopy',
		'onbeforecut',
		'onbeforedeactivate',
		'onbeforeeditfocus',
		'onbeforepaste',
		'onbeforeprint',
		'onbeforeunload',
		'onbeforeupdate',
		'onblur',
		'onbounce',
		'oncellchange',
		'onchange',
		'onclick',
		'oncontextmenu',
		'oncontrolselect',
		'oncopy',
		'oncut',
		'ondataavailable',
		'ondatasetchanged',
		'ondatasetcomplete',
		'ondblclick',
		'ondeactivate',
		'ondrag',
		'ondragdrop',
		'ondragend',
		'ondragenter',
		'ondragleave',
		'ondragover',
		'ondragstart',
		'ondrop',
		'onerror',
		'onerrorupdate',
		'onfilterchange',
		'onfinish',
		'onfocus',
		'onfocusin',
		'onfocusout',
		'onhashchange',
		'onhelp',
		'onkeydown',
		'onkeypress',
		'onkeyup',
		'onlayoutcomplete',
		'onload',
		'onlosecapture',
		'onmessage',
		'onmousedown',
		'onmouseenter',
		'onmousemove',
		'onmouseout',
		'onmouseover',
		'onmouseup',
		'onmove',
		'onmoveend',
		'onmovestart',
		'onoffline',
		'ononline',
		'onpage',
		'onpaste',
		'onprogress',
		'onpropertychange',
		'onreadystatechange',
		'onreset',
		'onresize',
		'onresizeend',
		'onresizestart',
		'onrowenter',
		'onrowexit',
		'onrowsdelete',
		'onrowsinserted',
		'onscroll',
		'onselect',
		'onselectionchange',
		'onselectstart',
		'onstart',
		'onstop',
		'onstorage',
		'onstoragecommit',
		'onsubmit',
		'ontimeerror',
		'ontimeout',
		'onunload',
		'onend',
		'onMediaComplete',
		'onMediaError',
		'onOutOfSync',
		'onPause',
		'onRepeat',
		'onResume',
		'onReverse',
		'onSeek',
		'onSynchRestored',
		'onTrackChange',
		'onURLFlip',
	);
	$_aEvilCss = array(
		'position',
		'top',
		'left',
		'background',
		'background-image',
		'background-color',
		'width',
		'height',
		'behaviour',
		'b&#92eh&#92a&#92v&#92i&#92o&#92r'
	);

	$text = str_replace( '<', '&lt;', $text );
	$text = str_replace( '>', '&gt;', $text );
	$text = str_replace( '"', '&quot;', $text );
	$text = str_replace( '?', '&acute;', $text );
	$text = str_replace( '', '&middot;', $text );
	$text = str_replace( '', '&rsquo;', $text );
	$text = str_replace( '', '&lsquo;', $text );
	$text = str_replace( '', '&ldquo;', $text );
	$text = str_replace( '', '&rdquo;', $text );
	$text = str_replace( '?', '&Prime;', $text );
	$text = str_replace( '?', '&prime;', $text );
	$text = str_replace( '', '&middot;', $text );
	$text = str_replace( '', '&middot;', $text );
	$text = str_replace( '', '&middot;', $text );
	$text = str_replace( '', '&middot;', $text );
	
	$text = str_replace( 'script', '', $text );
	$text = str_replace( 'behavior', '', $text );
	
	foreach ($_aEvilEvents as $sRemove)
	{
		$text = preg_replace('#'.$sRemove.'=#i', 'title=', $text);
	}

	foreach($_aEvilCss as $sCss)
	{
		$text = preg_replace('/'. $sCss .':(.*?)/i', 'replaced:', $text);
	}

	$text = preg_replace('#javascript:#i', '', $text);
	
	return $text;
}

function award_auth( $user_id, $award_id, &$error_message )
{
	global $db, $bb_cfg, $lang;
	
	$a = $db->fetch_row( "SELECT award_moder FROM " . BB_AWARDS . " WHERE award_id = " . (int) $award_id );
	
	if( $a['award_moder'] == $user_id || IS_ADMIN )
	{
		return true;
	}
	
	return false;
}

//  
function get_awards()
{
	global $db, $bb_cfg, $lang;
	
    $sql = "SELECT a.award_id, ac.award_category_name, a.award_title, a.award_description, a.award_file, a.award_moder, a.award_holders,
            GROUP_CONCAT(CONCAT('<a href=\"profile.php?mode=viewprofile&u=',u.user_id,'\">',u.username,'</a>') SEPARATOR ', ') AS users
            FROM " . BB_AWARDS . " a
            LEFT JOIN " . BB_AWARD_HOLDERS . " h ON (a.award_id = h.award_id)
            LEFT JOIN " . USERS_TABLE . " u ON (h.award_holder = u.user_id)
            LEFT JOIN " . BB_AWARD_CATEGORIES ." ac ON (a.award_category = ac.award_category_id)
            GROUP BY a.award_id, a.award_title, a.award_description, a.award_file, a.award_moder, a.award_holders
            ORDER BY a.award_order";

	return $db->fetch_rowset($sql);
}

// 
function synh_award_count( $award_id )
{
	global $db, $bb_cfg;
	
	$a = $db->fetch_row("
			SELECT
			a.award_holders,
			COUNT(b.award_id) AS award_holders_count
		FROM
			" . BB_AWARDS . " a
			LEFT JOIN " . BB_AWARD_HOLDERS . " b ON( b.award_id = a.award_id )
		WHERE
			a.award_id = " . (int) $award_id . "
		GROUP BY
			a.award_id
		ORDER BY
			a.award_id ASC");
	
	if( $a['award_holders'] != $a['award_holders_count'] )
	{
		$sql = "
		UPDATE
			" . BB_AWARDS . "
		SET
			award_holders = " . (int) $a['award_holders_count'] . "
		WHERE
			award_id = " . (int) $award_id;
		
		if (!$db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, 'Could not synh award holders count', '', __LINE__, __FILE__, $sql);
		}
	}
	
	$aw_us	= get_handed_users( $award_id );
	
	if( count($aw_us) > 0 )
	{
		foreach( $aw_us AS $awh )
		{
			update_user_awards( $awh['award_holder'], $error_message  );
		}
	}
	
}

//   
function get_user_awards( $user_id )
{
	global $db, $bb_cfg, $lang;
	
	return $db->fetch_rowset( "SELECT * FROM " . BB_AWARD_HOLDERS . " WHERE award_holder = " . (int) $user_id );
}

function get_handed_users( $award_id )
{
	global $db, $bb_cfg, $lang;
	
	return $db->fetch_rowset( "SELECT * FROM " . BB_AWARD_HOLDERS . " WHERE award_id = " . (int) $award_id );
}

//  
function set_user_award( $user_id, $award_id, &$error_message, $reason= '' )
{
	global $db, $bb_cfg, $lang;
	
	$reason = (string) $reason;
	$sql = "
		INSERT
		INTO
			" . BB_AWARD_HOLDERS .  " ( award_id, award_holder, award_reason, award_time )
		VALUE
			(
				'" . (int) $award_id . "',
				'" . (int) $user_id . "',
				'" . $db->escape_string( $reason ) .  "',
				'" . time() . "'
			)";
			
	if (!$db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, 'Could not hand award', '', __LINE__, __FILE__, $sql);
	}
	
	update_user_awards( $user_id, $error_message );
	
	$sql = "
		UPDATE
			" . BB_AWARDS . "
		SET
			award_holders = award_holders + 1
		WHERE
			award_id = " . (int) $award_id;
	
	if (!$db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, 'Could not update award holders count', '', __LINE__, __FILE__, $sql);
	}
	return TRUE;
}

//   
function del_user_awards( $award_hid, &$error_message )
{
	global $db, $bb_cfg, $lang;
	
	if( !$a = $db->fetch_row( "SELECT award_holder, award_id FROM " . BB_AWARD_HOLDERS . " WHERE award_hid = " . (int) $award_hid ) )
	{
		$error_message = $lang['AW_AW_NOT_FND'];
		return FALSE;
	}
	
	$sql = "
		DELETE FROM
			" . BB_AWARD_HOLDERS . "
		WHERE
			award_hid = " . (int) $award_hid;
	
	if (!$db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, 'Could not delete user award', '', __LINE__, __FILE__, $sql);
	}
	
	update_user_awards( $a['award_holder'], $error_message );

	$sql = "
		UPDATE
			" . BB_AWARDS . "
		SET
			award_holders = award_holders - 1
		WHERE
			award_id = " . (int) $a['award_id'];
	
	if (!$db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, 'Could not update award holders count', '', __LINE__, __FILE__, $sql);
	}
	
	return TRUE;
}

//  
function update_user_awards ( $user_id, &$error_message )
{
	global $db, $bb_cfg, $lang, $session_cache;
	$data = array();
	
	$awards = $db->fetch_rowset( "SELECT * FROM " . BB_AWARD_HOLDERS . " WHERE award_holder = " . (int) $user_id );
	
	if( count($awards) > 0 )
	{
		foreach ( $awards AS $row )
		{
			$aw = $db->fetch_rowset( "SELECT award_title, award_file FROM " . BB_AWARDS . " WHERE award_id = " . (int) $row['award_id']  );
			if ( count($aw) > 0 )
			{
				$m = array();
				$m['award_id'] 		= $row['award_id'];
				$m['award_hid']		= $row['award_hid'];
				$m['award_title']	= $aw[0]['award_title'];
				$m['award_file']	= $aw[0]['award_file'];
				$m['award_time']	= $row['award_time'];
				$m['award_reason']	= $row['award_reason'];
				
				$data[] =  $m;
			}
		}
	}
	
	// print_r($data);
	
	$sql = "UPDATE
				" . USERS_TABLE . "
			SET
				user_awards = '" . $db->escape_string( serialize($data) ) . "'
			WHERE
				user_id = " . (int) $user_id;
	
	if (!$db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, 'Could not update user awards', '', __LINE__, __FILE__, $sql);
	}

	
	$u 		= $db->fetch_row( "SELECT session_id FROM bb_sessions WHERE session_user_id = " . (int) $user_id );
	if(is_array($u))
	{
		if(key_exists("session_id",$u) && $u["session_id"])
		{

			$session_cache->rm($u["session_id"]);

		}
	}
	return TRUE;
}

//   
function add_award( $award_title, $award_file, &$error_message, $awards_moder = 0 )
{
	global $db, $bb_cfg, $lang;
	
	$c	= $db->fetch_row( "SELECT COUNT(award_title) AS count FROM " . BB_AWARDS . " WHERE award_title = '" . $db->escape_string($award_title) . "'" );
	if( $c['count'] > 0 )
	{
		$error_message	= $lang['AW_AWD_EXITSTS'];
		return FALSE;
	}
	
	$sql = "INSERT
			INTO
				" . BB_AWARDS . " ( award_title, award_file, award_moder, award_holders )
			VALUES
				( '" . $db->escape_string($award_title) . "', '" . $db->escape_string($award_file) . "', '" . (int) $awards_moder . "', 0 )";
	if (!$db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, 'Could not insert award', '', __LINE__, __FILE__, $sql);
	}
	return true;
}

//   
function del_award( $award_id, &$error_message )
{
	global $db, $bb_cfg, $lang;
	
	$c	= $db->fetch_row( "SELECT COUNT(award_title) AS count FROM " . BB_AWARDS . " WHERE award_id = '" . (int) $award_id . "'" );
	if( $c['count'] <= 0 )
	{
		$error_message = '  !';
		return FALSE;
	}
	
	$sql = "DELETE FROM
				" . BB_AWARDS . "
			WHERE
				award_id = " . (int) $award_id;
	
	if (!$db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, 'Could not delete awawrd', '', __LINE__, __FILE__, $sql);
	}
	
	$b = $db->fetch_rowset( "SELECT award_holder FROM " . BB_AWARD_HOLDERS . " WHERE award_id = " . (int) $award_id );

	$sql = "DELETE FROM
				" . BB_AWARD_HOLDERS . "
			WHERE
				award_id = " . (int) $award_id;
	
	if (!$db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, 'Could not delete awards holders', '', __LINE__, __FILE__, $sql);
	}
	
	foreach ( $b as $d )
	{
		update_user_awards( $d['award_holder'], $error_message );
	}
	
	return true;
}


