<?php
/**
*
* @package phpBB3
* @version $Id: functions_sitemap_fx.php,v 1.0.5 9467 2009-08-17 20:46:39Z FladeX Exp $
* @copyright (c) 2005 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* Generate sitemap
*/
function sitemap_fx_forum($forum_id)
{
	global $db, $phpEx, $sitemap_config, $bb_cfg;

	// avoid usage of f$#king make_url which is web server dependant
    $domain = ($bb_cfg['server_name_mirror'] != $bb_cfg['http_host']) ? $bb_cfg['sitename'] : $bb_cfg['server_name_mirror'];
    $url = 'https://' . $domain . $bb_cfg['script_path'];
	// $url = make_url();

	$sitemap_file = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n";
	$sitemap_file .= "<urlset xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\">\n";

	$sql = 'SELECT topic_id, forum_id, topic_last_post_time, topic_type, topic_replies
		FROM ' . TOPICS_TABLE . '
			WHERE forum_id = ' . $forum_id;
	$result = $db->sql_query($sql);
		
	while ($row = $db->sql_fetchrow($result))
	{
		$last_mod = date('Y-m-d\TH:i:s+00:00', $row['topic_last_post_time']);
		$pages = $row['topic_replies'] / $sitemap_config['posts_per_page'];
		$pages = (int) $pages;
		for ($i=0; $i<=$pages; $i++)
		{
			$sitemap_file .= "<url>\n";
			if ($i == 0)
			{
				$sitemap_file .= "<loc>" . $url . "viewtopic." . $phpEx . "?t=" . $row['topic_id'] . "</loc>\n";
			}
			else
			{
				$sitemap_file .= "<loc>" . $url . "viewtopic." . $phpEx . "?t=" . $row['topic_id'] . "&amp;start=" . $i * $sitemap_config['posts_per_page'] . "</loc>\n";
			}
			$sitemap_file .= "<lastmod>" . $last_mod . "</lastmod>\n";
			switch ($row['topic_type'])
			{
				case POST_NORMAL:
					$sitemap_file .= "<changefreq>" . $sitemap_config['sitemap_freq_0'] . "</changefreq>\n";
					$sitemap_file .= "<priority>" . $sitemap_config['sitemap_priority_0'] . "</priority>\n";
					break;
				case POST_STICKY:
					$sitemap_file .= "<changefreq>" . $sitemap_config['sitemap_freq_1'] . "</changefreq>\n";
					$sitemap_file .= "<priority>" . $sitemap_config['sitemap_priority_1'] . "</priority>\n";
					break;
				case POST_ANNOUNCE:
					$sitemap_file .= "<changefreq>" . $sitemap_config['sitemap_freq_2'] . "</changefreq>\n";
					$sitemap_file .= "<priority>" . $sitemap_config['sitemap_priority_2'] . "</priority>\n";
					break;
				default:
					$sitemap_file .= "<changefreq>" . $sitemap_config['sitemap_freq_0'] . "</changefreq>\n";
					$sitemap_file .= "<priority>" . $sitemap_config['sitemap_priority_0'] . "</priority>\n";
			}
			$sitemap_file .= "</url>\n";
		}
	}
	$db->sql_freeresult($result);


	$sitemap_file .= "</urlset>\n";

	$w=fopen("sitemap.$domain/".$forum_id.'.xml','w');
	fwrite($w,$sitemap_file);
	fclose($w);
}

function sitemap_fx_global($forum_id)
{
	global $db, $phpEx, $sitemap_config, $bb_cfg, $forbidden_forums;

	// avoid usage of f$#king make_url which is web server dependant
    $domain = ($bb_cfg['server_name_mirror'] != $bb_cfg['http_host']) ? $bb_cfg['sitename'] : $bb_cfg['server_name_mirror'];
    $url = 'https://' . $domain . $bb_cfg['script_path'];
    
	// $url = make_url();

	$sitemap_file = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n";
	$sitemap_file .= "<urlset xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\">\n";


	$sql = 'SELECT forum_id
			FROM ' . FORUMS_TABLE . ' WHERE forum_id NOT IN (' . $forbidden_forums . ')';
	$result = $db->sql_query($sql);
	if ($db->sql_fetchrow($result))
	{
		while ($row = $db->sql_fetchrow($result))
		{
			$sitemap_file .= "<url>\n";
			$sitemap_file .= "<loc>" . $url . "viewforum." . $phpEx . "?f=" . $row['forum_id'] . "</loc>\n";
			$sitemap_file .= "<lastmod>" . date('Y-m-d\TH:i:s+00:00', time()) . "</lastmod>\n";
			$sitemap_file .= "<changefreq>daily</changefreq>\n";
			$sitemap_file .= "<priority>1</priority>\n";
			$sitemap_file .= "</url>\n";
		}
	}
	$db->sql_freeresult($result);

/*    
	$sql = 'SELECT topic_id, forum_id, topic_title, topic_last_post_time, topic_type, topic_replies
			FROM ' . TOPICS_TABLE . '
			WHERE forum_id NOT IN (' . $forbidden_forums . ') AND topic_type = ' . POST_NORMAL;
	$result = $db->sql_query($sql);

	if ($db->sql_fetchrow($result))
	{
		while ($row = $db->sql_fetchrow($result))
		{
			$last_mod = date('Y-m-d\TH:i:s+00:00', $row['topic_last_post_time']);
			$pages = $row['topic_replies'] / $sitemap_config['posts_per_page'];
			$pages = (int) $pages;
			for ($i=0; $i<=$pages; $i++)
			{
				$sitemap_file .= "<url>\n";
				if ($i == 0)
				{
					$sitemap_file .= "<loc>" . $url . "viewtopic." . $phpEx . "?t=" . $row['topic_id'] . "</loc>\n";
				}
				else
				{
					$sitemap_file .= "<loc>" . $url . "viewtopic." . $phpEx . "?t=" . $row['topic_id'] . "&amp;start=" . $i * $sitemap_config['posts_per_page'] . "</loc>\n";
				}
				$sitemap_file .= "<lastmod>" . $last_mod . "</lastmod>\n";
				$sitemap_file .= "<changefreq>" . $sitemap_config['sitemap_freq_3'] . "</changefreq>\n";
				$sitemap_file .= "<priority>" . $sitemap_config['sitemap_priority_3'] . "</priority>\n";
				$sitemap_file .= "</url>\n";
			}
		}
	}
	$db->sql_freeresult($result);
*/

	$sitemap_file .= "</urlset>\n";

	$w=fopen("sitemap.$domain/0.xml", 'w');
	fwrite($w, $sitemap_file);
	fclose($w);
}

?>