<?php

##### LOG #####
#	bb_log(' ', 'hits/'. date('m-d') .'/'. date('H-') .'bb');
### LOG END ###

if (!defined('IN_PHPBB')) die(basename(__FILE__));
# if (PHP_VERSION < '4.3') die('TorrentPier requires PHP version 4.3+. Your PHP version '. PHP_VERSION);
if (!defined('BB_SCRIPT')) define('BB_SCRIPT', 'undefined');

// Exit if board is disabled via ON/OFF trigger
if (!defined('IN_ADMIN') && !defined('IN_INSTALL') && !defined('IN_AJAX') && !defined('IN_SERVICE'))
{
	if (file_exists(BB_DISABLED))
	{
		cron_release_deadlock();

		require(TEMPLATES_DIR .'board_disabled_exit.'. PHP_EXT);
	}
}


//
// Cron functions
//
function cron_release_deadlock ()
{
	if (file_exists(CRON_RUNNING))
	{
		if (TIMENOW - filemtime(CRON_RUNNING) > 2400)
		{
			cron_enable_board();
			cron_release_file_lock();
		}
	}
}

function cron_release_file_lock ()
{
	$lock_released = @rename(CRON_RUNNING, CRON_ALLOWED);
	cron_touch_lock_file(CRON_ALLOWED);
}

function cron_touch_lock_file ($lock_file)
{
	file_write(make_rand_str(20), $lock_file, 0, true, true);
}

function cron_enable_board ()
{
	@rename(BB_DISABLED, BB_ENABLED);
#	bb_update_config(array('board_disable' => 0));
}

function cron_disable_board ()
{
	@rename(BB_ENABLED, BB_DISABLED);
#	bb_update_config(array('board_disable' => 1));
}

// Define some basic configuration arrays
unset($stopwords, $synonyms_match, $synonyms_replace);
$userdata = $theme = $images = $lang = $nav_links = $bf = $attach_config = array();
// dj_maxx: add hide bbcode (bonuses)
$bt_userdata = array();
// end of
$gen_simple_header = false;
$user = null;

// Obtain and encode user IP
$client_ip = !empty($_SERVER['REMOTE_ADDR']) ? $_SERVER['REMOTE_ADDR'] : '127.0.0.1';
$user_ip = encode_ip($client_ip);
define('CLIENT_IP', $client_ip);
define('USER_IP',   $user_ip);

function send_page ($contents)
{
	return compress_output($contents);
}

define('UA_GZIP_SUPPORTED', (isset($_SERVER['HTTP_ACCEPT_ENCODING']) && strpos($_SERVER['HTTP_ACCEPT_ENCODING'], 'gzip') !== false));

function compress_output ($contents)
{
	global $bb_cfg;

	if ($bb_cfg['gzip_compress'] && GZIP_OUTPUT_ALLOWED && !defined('NO_GZIP'))
	{
		if ((UA_GZIP_SUPPORTED || $bb_cfg['gzip_force']) && strlen($contents) > 2000)
		{
			header('Content-Encoding: gzip');
			$contents = gzencode($contents, 1);
		}
	}

	return $contents;
}

// Start output buffering
if (!defined('IN_INSTALL') && !defined('IN_AJAX'))
{
	ob_start('send_page');
}

if (DEBUG === true)
{
	require(DEV_DIR .'init_debug.'. PHP_EXT);
#	if ($a);
#	trigger_error("error handler test", E_USER_ERROR);
}

// Config options
define('TPL_LIMIT_LOAD_EXIT', TEMPLATES_DIR .'limit_load_exit.'. PHP_EXT);

// Cookie params
$c = $bb_cfg['cookie_prefix'];
define('COOKIE_DATA',  $c .'data');
define('COOKIE_FORUM', $c .'f');
define('COOKIE_LOAD',  $c .'isl');
define('COOKIE_MARK',  $c .'mark_read');
define('COOKIE_TEST',  $c .'test');
define('COOKIE_TOPIC', $c .'t');
unset($c);

define('COOKIE_SESSION', 0);
define('COOKIE_EXPIRED', TIMENOW - 31536000);
define('COOKIE_PERSIST', TIMENOW + 31536000);

define('COOKIE_MAX_TRACKS', 90);

function bb_setcookie ($name, $val, $lifetime = COOKIE_PERSIST, $httponly = false, $domain = '.')
{
	global $bb_cfg;

	if ($domain == '.')
	{
		$domain = $bb_cfg['cookie_domain'];
	}

	return setcookie($name, $val, $lifetime, $bb_cfg['cookie_path'], $domain, $bb_cfg['cookie_secure'], $httponly);
}

// Debug options
if (DBG_USER)
{
	error_reporting(E_ALL);
	ini_set('display_errors', 1);
}

define('DELETED', -1);

// User Levels <- Do not change the values of USER or ADMIN
define('USER',         0);
define('ADMIN',        1);
define('MOD',          2);
define('GROUP_MEMBER', 20);

$excluded_users = array(
	ANONYMOUS,
	BOT_UID,
);
define('EXCLUDED_USERS_CSV', implode(',', $excluded_users));

// User related
define('USER_ACTIVATION_NONE',  0);
define('USER_ACTIVATION_SELF',  1);
define('USER_ACTIVATION_ADMIN', 2);

define('USER_AVATAR_NONE',    0);
define('USER_AVATAR_UPLOAD',  1);
define('USER_AVATAR_REMOTE',  2);
define('USER_AVATAR_GALLERY', 3);

// dj_maxx: add guest torrents
define('GUEST_USERID', 1);		/* guest id for guest torrents */
// end of

// Group settings
define('GROUP_OPEN',   0);
define('GROUP_CLOSED', 1);
define('GROUP_HIDDEN', 2);

// Forum state
define('FORUM_UNLOCKED', 0);
define('FORUM_LOCKED',   1);

// Topic status
define('TOPIC_UNLOCKED',          0);
define('TOPIC_LOCKED',            1);
define('TOPIC_MOVED',             2);

define('TOPIC_WATCH_NOTIFIED',    1);
define('TOPIC_WATCH_UN_NOTIFIED', 0);
// dj_maxx: add forum watching
define('FORUM_WATCH_NOTIFIED',    1);
define('FORUM_WATCH_UN_NOTIFIED', 0);
// end of


// Topic types
define('POST_NORMAL',          0);
define('POST_STICKY',          1);
define('POST_ANNOUNCE',        2);
define('POST_GLOBAL_ANNOUNCE', 3);

// Search types
define('SEARCH_TYPE_POST',     0);
define('SEARCH_TYPE_TRACKER',  1);

// Error codes
define('GENERAL_MESSAGE',      200);
define('GENERAL_ERROR',        202);
define('CRITICAL_MESSAGE',     203);
define('CRITICAL_ERROR',       204);

define('E_AJAX_GENERAL_ERROR', 1000);
define('E_AJAX_NEED_LOGIN',    1001);

// Private messaging
define('PRIVMSGS_READ_MAIL',      0);
define('PRIVMSGS_NEW_MAIL',       1);
define('PRIVMSGS_SENT_MAIL',      2);
define('PRIVMSGS_SAVED_IN_MAIL',  3);
define('PRIVMSGS_SAVED_OUT_MAIL', 4);
define('PRIVMSGS_UNREAD_MAIL',    5);

// URL PARAMETERS (hardcoding allowed)
define('POST_CAT_URL',    'c');
define('POST_FORUM_URL',  'f');
define('POST_GROUPS_URL', 'g');
define('POST_POST_URL',   'p');
define('POST_TOPIC_URL',  't');
define('POST_USERS_URL',  'u');

// Download Modes
define('INLINE_LINK',   1);
define('PHYSICAL_LINK', 2);

// Categories
define('NONE_CAT',   0);
define('IMAGE_CAT',  1);
define('STREAM_CAT', 2);
define('SWF_CAT',    3);

// Misc
define('MEGABYTE',              1024);
define('ADMIN_MAX_ATTACHMENTS', 50);
define('THUMB_DIR',             'thumbs');
define('MODE_THUMBNAIL',        1);

// Forum Extension Group Permissions
define('GPERM_ALL', 0); // ALL FORUMS

// Quota Types
define('QUOTA_UPLOAD_LIMIT', 1);
define('QUOTA_PM_LIMIT',     2);

// Torrents
define('TOR_STATUS_NORMAL', 0);
define('TOR_STATUS_FROZEN', 1);

// Report
// Report status constants
define('REPORT_NEW', 0);
define('REPORT_OPEN', 1);
define('REPORT_IN_PROCESS', 2);
define('REPORT_CLEARED', 3);
define('REPORT_DELETE', 4);
// Report authorisation constants
define('REPORT_AUTH_USER', 0);
define('REPORT_AUTH_MOD', 1);
define('REPORT_AUTH_CONFIRM', 2);
define('REPORT_AUTH_ADMIN', 3);
// Report notification constants
define('REPORT_NOTIFY_NEW', 1);
define('REPORT_NOTIFY_CHANGE', 2);
// Other report constants
define('POST_REPORT_URL', 'r');
define('POST_REPORT_REASON_URL', 'r');
// Report [END]

// Table names
$b = $buffer_prefix;
$t = $table_prefix;

define('BUF_TOPIC_VIEW_TABLE',       $b .'topic_view');
define('BUF_LAST_SEEDER_TABLE',      $b .'last_seeder');

define('ADS_TABLE',                  $t .'ads');
define('ATTACH_CONFIG_TABLE',        $t .'attachments_config');
define('ATTACHMENTS_DESC_TABLE',     $t .'attachments_desc');
define('ATTACHMENTS_TABLE',          $t .'attachments');
define('AUTH_ACCESS_SNAP_TABLE',     $t .'auth_access_snap');
define('AUTH_ACCESS_TABLE',          $t .'auth_access');
define('BANLIST_TABLE',              $t .'banlist');
define('BT_DLSTATUS_MAIN_TABLE',     $t .'bt_dlstatus_main');
define('BT_DLSTATUS_NEW_TABLE',      $t .'bt_dlstatus_new');
define('BT_DLSTATUS_SNAP_TABLE',     $t .'bt_dlstatus_snap');
define('BT_DLSTATUS_TABLE',          $t .'bt_dlstatus_mrg');   // main + new
define('BT_LAST_TORSTAT_TABLE',      $t .'bt_last_torstat');
define('BT_LAST_USERSTAT_TABLE',     $t .'bt_last_userstat');
define('BT_TORHELP_TABLE',           $t .'bt_torhelp');
define('BT_TORSTAT_TABLE',           $t .'bt_torstat');
define('BT_USER_SETTINGS_TABLE',     $t .'bt_user_settings');
define('CATEGORIES_TABLE',           $t .'categories');
define('CONFIG_TABLE',               $t .'config');
define('CONFIRM_TABLE',              $t .'confirm');
define('COUNTRIES_TABLE',            $t .'countries');
define('CRON_TABLE',                 $t .'cron');
define('DATASTORE_TABLE',            $t .'datastore');
define('DISALLOW_TABLE',             $t .'disallow');
define('EXTENSION_GROUPS_TABLE',     $t .'extension_groups');
define('EXTENSIONS_TABLE',           $t .'extensions');
define('FORUMS_TABLE',               $t .'forums');
define('GROUPS_TABLE',               $t .'groups');
define('LOG_TABLE',                  $t .'log');
define('POSTS_SEARCH_TABLE',         $t .'posts_search');
define('POSTS_TABLE',                $t .'posts');
define('POSTS_TEXT_TABLE',           $t .'posts_text');
define('POSTS_HTML_TABLE',           $t .'posts_html');
define('PRIVMSGS_TABLE',             $t .'privmsgs');
define('PRIVMSGS_TEXT_TABLE',        $t .'privmsgs_text');
define('QUOTA_LIMITS_TABLE',         $t .'quota_limits');
define('QUOTA_TABLE',                $t .'attach_quota');
define('RANKS_TABLE',                $t .'ranks');

// dj_maxx: add awards mod
define('BB_AWARDS',			      'bb_awards');	//Awards
define('BB_AWARD_HOLDERS',		  'bb_award_holders');	//Awards
define('BB_AWARD_CATEGORIES',     'bb_awards_categories'); //Awards
// end of

// Report
define('REPORTS_TABLE',              $t .'reports');
define('REPORTS_CHANGES_TABLE',      $t .'reports_changes');
define('REPORTS_MODULES_TABLE',      $t .'reports_modules');
define('REPORTS_REASONS_TABLE',      $t .'reports_reasons');
// Report [END]
define('SEARCH_REBUILD_TABLE',       $t .'search_rebuild');
define('SEARCH_TABLE',               $t .'search_results');
define('SESSIONS_TABLE',             $t .'sessions');
define('SMILIES_TABLE',              $t .'smilies');
define('TOPIC_TPL_TABLE',            $t .'topic_templates');
// dj_maxx: add ratio discount
// define('TOPICS_TABLE',               $t .'topics');
// end of
define('TOPICS_WATCH_TABLE',         $t .'topics_watch');
// dj_maxx: add forum watching
define('FORUMS_WATCH_TABLE',         $t .'forums_watch');
// end of

// Bookmarks
define('TOPICS_BOOKMARK_TABLE',      $t .'topics_bookmark');
// Bookmarks [END]

define('USER_GROUP_TABLE',           $t .'user_group');
// dj_maxx: add custom group properties
// define('USERS_TABLE',                $t .'users');
// end of
define('VOTE_DESC_TABLE',            $t .'vote_desc');
define('VOTE_RESULTS_TABLE',         $t .'vote_results');
define('VOTE_USERS_TABLE',           $t .'vote_voters');
define('WORDS_TABLE',                $t .'words');

// dj_maxx: add warnings & bans
define('REVIEWS_TABLE',              $t .'reviews');
define('REVIEWS_TEXT_TABLE',         $t .'reviews_text');
// end of

// dj_maxx: add release rating
define('BT_RATING_TABLE', 	     $t.'bt_rating');
// end of

// dj_maxx: add bonus points
define('BONUS_TABLE',		     $t.'bonus');
// end of

// dj_maxx: add visual confirmation to login form
define('UNTRUSTED_IPS_TABLE',        $t.'untrusted_ips');
// end of

// dj_maxx: add chat release notification
define('CHAT_MESSAGES_TABLE',        'ajax_chat_messages');
// end of

// dj_maxx: add search log & cloud
define('SEARCH_LOG_TABLE',           $t.'search_log');
// end of


unset($t, $b);

define('TORRENT_EXT', 'torrent');

define('TOPIC_DL_TYPE_NORMAL', 0);
define('TOPIC_DL_TYPE_DL',     1);

define('SHOW_PEERS_COUNT', 1);
define('SHOW_PEERS_NAMES', 2);
define('SHOW_PEERS_FULL',  3);

define('SEARCH_ID_LENGTH', 12);
define('SID_LENGTH',       20);
define('LOGIN_KEY_LENGTH', 12);

define('PAGE_HEADER', INC_DIR .'page_header.'. PHP_EXT);
define('PAGE_FOOTER', INC_DIR .'page_footer.'. PHP_EXT);

define('CAT_URL',      "index.$phpEx?"     .'c=');
define('DOWNLOAD_URL', "download.$phpEx?"  .'id=');
define('FORUM_URL',    "viewforum.$phpEx?" .'f=');
define('GROUP_URL',    "groupcp.$phpEx?"   .'g=');
define('LOGIN_URL',    "login.$phpEx?"     .'redirect=');
define('MODCP_URL',    "modcp.$phpEx?"     .'f=');
define('PM_URL',       "privmsg.$phpEx?"   .'mode=post&amp;u=');
define('POST_URL',     "viewtopic.$phpEx?" .'p=');
define('PROFILE_URL',  "profile.$phpEx?"   .'mode=viewprofile&amp;u=');
define('TOPIC_URL',    "viewtopic.$phpEx?" .'t=');

define('USER_AGENT', @strtolower($_SERVER['HTTP_USER_AGENT']));
define('UA_OPERA',   strpos(USER_AGENT, 'pera'));
define('UA_IE',      strpos(USER_AGENT, 'msie'));

define('HTML_SELECT_MAX_LENGTH', 60);
// define('HTML_WBR_TAG',    (UA_OPERA || strpos(USER_AGENT, 'afari')) ? '<wbr></wbr>&#8203;' : '<wbr />');
define('HTML_WBR_TAG',    (UA_OPERA || strpos(USER_AGENT, 'afari')) ? '' : '<wbr />');  // dj_maxx: remove wbr tag for nasty Opera 10
define('HTML_WBR_LENGTH', 12);

define('HTML_CHECKED',  ' checked="checked" ');
define('HTML_DISABLED', ' disabled="disabled" ');
define('HTML_READONLY', ' readonly="readonly" ');
define('HTML_SELECTED', ' selected="selected" ');

define('HTML_SF_SPACER', '&nbsp;|-&nbsp;');

// $GPC
define('KEY_NAME', 0);   // position in $GPC['xxx']
define('DEF_VAL',  1);
define('GPC_TYPE', 2);

define('GET',     1);
define('POST',    2);
define('COOKIE',  3);
define('REQUEST', 4);
define('CHBOX',   5);
define('SELECT',  6);

if (!empty($banned_user_agents))
{
	foreach ($banned_user_agents as $agent)
	{
		if (strstr(USER_AGENT, $agent))
		{
/*##### LOG #####
$file = 'ban/user_agents_'. date('m-d');
$str = array();
$str[] = date('H:i:s');
$str[] = @$_SERVER['HTTP_USER_AGENT'];
$str[] = @$_SERVER['REMOTE_ADDR'];
$str[] = @$_SERVER['REQUEST_URI'];
$str[] = @$_SERVER['HTTP_REFERER'];
bb_log($str, $file);
### LOG END ###*/

			$filename = 'Skachivajte fajly brauzerom (  )';
			$output = '@';

			header('Content-Type: text/plain');
			header('Content-Disposition: attachment; filename="'. $filename .'"');

			die($output);
		}
	}
}

// Functions
function send_no_cache_headers ()
{
	header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
	header('Last-Modified: '. gmdate('D, d M Y H:i:s'). ' GMT');
	header('Cache-Control: no-store, no-cache, must-revalidate');
	header('Cache-Control: post-check=0, pre-check=0', false);
	header('Pragma: no-cache');
}

function bb_exit ($output = '')
{
	if ($output)
	{
		echo $output;
	}
	exit;
}

// Exit if server overloaded
if (!(defined('IN_PROFILE') || defined('IN_LOGIN') || defined('IN_ADMIN') || defined('IN_AJAX') || defined('IN_SERVICE')) && BB_ROOT == './')
{
	if ($bb_cfg['max_srv_load'] && empty($_POST['message']) && !empty($_COOKIE[COOKIE_LOAD]) && LOADAVG)
	{
		if (LOADAVG > $bb_cfg['max_srv_load'] && (TIMENOW - $_COOKIE[COOKIE_LOAD]) > $bb_cfg['user_session_duration'])
		{
			require(TPL_LIMIT_LOAD_EXIT);
		}
	}
}

function prn_r ($var, $title = '', $print = true)
{
	$r = '<pre>'. (($title) ? "<b>$title</b>\n\n" : '') . htmlspecialchars(print_r($var, true)) .'</pre>';
	if ($print) echo $r;
	return $r;
}

function prn ()
{
	if (!DBG_USER) return;
	foreach (func_get_args() as $var) prn_r($var);
}

function vdump ($var, $title = '')
{
	echo '<pre>'. (($title) ? "<b>$title</b>\n\n" : '');
	var_dump($var);
	echo '</pre>';
}

function htmlCHR ($txt, $replace_space = false)
{
	return ($replace_space) ? str_replace(' ', '&nbsp;', htmlspecialchars($txt, ENT_QUOTES)) : htmlspecialchars($txt, ENT_QUOTES);
}

function make_url ($path)
{
	global $bb_cfg;

	$server_protocol = ($bb_cfg['cookie_secure']) ? 'https://' : 'http://';
	$server_port = ($bb_cfg['server_port'] != 80) ? ':'. $bb_cfg['server_port'] : '';
	$path = preg_replace('#^\/?(.*?)\/?$#', '\1', $path);
    // dj_maxx: redirect to mirror, if came from mirror's subdomain
    $redir_domain = (strpos($bb_cfg['http_host'], $bb_cfg['server_name_mirror']) === false) ? $bb_cfg['server_name'] : $bb_cfg['server_name_mirror'];
    // end of
	return $server_protocol . $redir_domain . $server_port . $bb_cfg['script_path'] . $path;
}


// PHP5 with register_long_arrays off?
if (PHP_VERSION >= 5 && !ini_get('register_long_arrays'))
{
	$HTTP_POST_VARS   = $_POST;
	$HTTP_GET_VARS    = $_GET;
	$HTTP_SERVER_VARS = $_SERVER;
	$HTTP_COOKIE_VARS = $_COOKIE;
	$HTTP_ENV_VARS    = $_ENV;
	$HTTP_POST_FILES  = $_FILES;
}

if (STRIP_SLASHES)
{
	array_deep($_GET,     'stripslashes');
	array_deep($_POST,    'stripslashes');
	array_deep($_COOKIE,  'stripslashes');
	array_deep($_REQUEST, 'stripslashes');
	array_deep($_SERVER,  'stripslashes');
	array_deep($_ENV,     'stripslashes');
	array_deep($_FILES,   'stripslashes');
}
else
{
	array_deep($HTTP_GET_VARS,    'addslashes');
	array_deep($HTTP_POST_VARS,   'addslashes');
	array_deep($HTTP_COOKIE_VARS, 'addslashes');
}

require(INC_DIR .'CIDR.'. PHP_EXT);
require(INC_DIR .'functions.'. PHP_EXT);
require(INC_DIR .'sessions.'.  PHP_EXT);
require(INC_DIR .'template.'.  PHP_EXT);
require(INC_DIR .'db/mysql.'.  PHP_EXT);

if (DBG_USER) require(INC_DIR .'functions_dev.'. PHP_EXT);

// Make the database connection.
$db = new sql_db(array(
	'dbms'        => $dbms,
	'dbhost'      => $dbhost,
	'dbname'      => $dbname,
	'dbuser'      => $dbuser,
	'dbpasswd'    => $dbpasswd,
	'charset'     => $dbcharset,
	'collation'   => $dbcollation,
	'persist'     => $pconnect,
));
unset($dbpasswd);

// Setup forum wide options
$board_config =& $bb_cfg;

if (defined('IN_INSTALL'))
{
	$bb_cfg['cron_enabled'] = false;
}
else
{
	$bb_cfg = array_merge(bb_get_config(CONFIG_TABLE), $bb_cfg);

	$bb_cfg['cookie_name']      = $bb_cfg['cookie_prefix'];
	$bb_cfg['board_dateformat'] = $bb_cfg['default_dateformat'];
	$bb_cfg['board_lang']       = $bb_cfg['default_lang'];

	if (file_exists("install/install.$phpEx"))
	{
		message_die(GENERAL_MESSAGE, 'Please_remove_install_contrib');
	}
}



// dj_maxx: add various ads cloaking globals
if (ip_in_range(CLIENT_IP,'yandex') || preg_match('#\+http:\/\/yandex\.com\/bots#i', $_SERVER['HTTP_USER_AGENT']) || is_latent_gay(CLIENT_IP))
{
    define('YANDEX_IP_DETECTED', true);
}

if (ip_in_range(CLIENT_IP,'google') || preg_match('#google\.com#i', $_SERVER['HTTP_USER_AGENT']))
{
    define('GOOGLE_IP_DETECTED', true);
}

// end of


// dj_maxx: add sitename redirect from other domains
$redirect = "HTTP/1.1 301 Moved Permanently";
if (!defined('FORCE_CRON'))
{
    // dj_maxx: add rkn checker ban
    if (CIDR::match(CLIENT_IP, '194.165.22.0/23'))
    {
        header('HTTP/1.1 404 Not Found');
        die('    !');
    }

    // dj_maxx: temp .xyz hack (rkn go to x@z)
    if (defined('YANDEX_IP_DETECTED') || defined('GOOGLE_IP_DETECTED'))
    {
        $bb_cfg['sitename'] = 'underverse.fun';
        $bb_cfg['server_name'] = 'underverse.fun';
    }

    elseif (preg_match('#underverse.fun#', $bb_cfg['http_host']))
    {
        if (!preg_match('#(yandex|google)#i', $_SERVER['HTTP_REFERER']))
        {
            header('HTTP/1.1 404 Not Found');
            die('    !');
        }

        // to where redirect from yandex (with no cache)
        $bb_cfg['sitename'] = 'v32.underver.se';
        $bb_cfg['server_name'] = 'v32.underver.se';

        header('Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0');
        header('Expires: Sat, 26 Jul 1997 05:00:00 GMT');

        $redirect = "HTTP/1.1 302 Found";

    }
    // end of

    //
    if ($bb_cfg['server_name_redirect'] && (!strstr($bb_cfg['http_host'], $bb_cfg['server_name'])) && (!strstr($bb_cfg['http_host'], $bb_cfg['server_name_mirror'])))
    {
        $ref = $_SERVER['REQUEST_URI'];
        header($redirect);
        header('Location: ' . make_url($ref));
        //	header('Debug: '.$_SERVER["HTTP_HOST"]);
        exit();
    }
}
// end of


$user = new user_common();
$userdata =& $user->data;

$html = new html_common();
$log_action = new log_action();

$ads = new ads_common();

// Initialize Datastore
switch ($bb_cfg['datastore_type'])
{
	case 'sqlite':
		$datastore = new datastore_sqlite($bb_cfg['datastore']['sqlite']);
		break;

	case 'memcached':
		$datastore = new datastore_memcache($bb_cfg['datastore']['memcached']);
		break;

	case 'APC':
		$datastore = new datastore_apc();
		break;
		
	case 'filecache':
		$datastore = new datastore_file(CACHE_DIR . $bb_cfg['datastore']['filecache']['path']);
		break;

	default:
		$datastore = new datastore_mysql();
}

// !!! Temporarily (??) 'cat_forums' always enqueued
$datastore->enqueue(array(
	'cat_forums',
));

// Cron
if ((empty($_POST) && !defined('IN_ADMIN') && !defined('IN_AJAX') && !defined('IN_SERVICE') && !file_exists(CRON_RUNNING) && $bb_cfg['cron_enabled']) || defined('FORCE_CRON') /* && !empty($_GET['cron_test_9gndjk']) */)
{
	if (TIMENOW - $bb_cfg['cron_last_check'] > $bb_cfg['cron_check_interval'])
	{
		// Update cron_last_check
		bb_update_config(array('cron_last_check' => (time() + 10)));

		require(CFG_DIR .'cron_cfg.'. PHP_EXT);

		if (defined('FORCE_CRON'))  // TODO: check session default lang in case of no FORCE_CRON
		{
			require_once(LANG_ROOT_DIR .'lang_'. $bb_cfg['default_lang'] .'/lang_main.'. PHP_EXT);
		}

		bb_log(date('H:i:s - ') . getmypid() .' -x-- DB-LOCK try'. LOG_LF, CRON_LOG_DIR .'cron_check');

		if ($db->get_lock('cron', 1))
		{
			bb_log(date('H:i:s - ') . getmypid() .' --x- DB-LOCK OBTAINED !!!!!!!!!!!!!!!!!'. LOG_LF, CRON_LOG_DIR .'cron_check');

			sleep(2);
			require(CRON_DIR .'cron_init.'. PHP_EXT);

			$db->release_lock('cron');
		}
	}
}

$dl_link_css = array(
	DL_STATUS_RELEASER => 'genmed',
	DL_STATUS_WILL     => 'dlWill',
	DL_STATUS_DOWN     => 'leechmed',
	DL_STATUS_COMPLETE => 'seedmed',
	DL_STATUS_CANCEL   => 'dlCancel',
);

$dl_status_css = array(
	DL_STATUS_RELEASER => 'genmed',
	DL_STATUS_WILL     => 'dlWill',
	DL_STATUS_DOWN     => 'dlDown',
	DL_STATUS_COMPLETE => 'dlComplete',
	DL_STATUS_CANCEL   => 'dlCancel',
);

if (!defined('IN_INSTALL'))
{
	// Show 'Board is disabled' message if needed.
	if ($bb_cfg['board_disable'] && !defined('IN_ADMIN') && !defined('IN_LOGIN'))
	{
		message_die(GENERAL_MESSAGE, 'Board_disable', 'Information');
	}
}

#	if (@$_GET['sdfhjk45689032'] == 1) require(INC_DIR .'cron/jobs/site_backup.php');


// [MOD] Zodiac

//added for birthday zodiac
$zodiacdates = array ('0101', '0120',
			'0121', '0219',
			'0220', '0320',
			'0321', '0420',
			'0421', '0520',
			'0521', '0621',
			'0622', '0722',
			'0723', '0823',
			'0824', '0922',
			'0923', '1022',
			'1023', '1122',
			'1123', '1221',
			'1222', '1231');
$zodiacs = array ('Capricorn','Aquarius', 'Pisces', 'Aries', 'Taurus', 'Gemini', 'Cancer', 'Leo', 'Virgo', 'Libra', 'Scorpio', 'Sagittarius','Capricorn');

// [MOD] Zodiac [END]


// dj_maxx: add SAPE client
/*
if ( (!defined('IN_ADMIN')) && (!defined('IN_CHAT')) && (!defined('IN_SCRAPER')) && (!defined('IN_RECOVER')) && (!defined('FORCE_CRON')) )
{
    if (!defined('_SAPE_USER')){
        define('_SAPE_USER', 'e232a82ea79aac723f02020ccabc0a2f');
    }
    require_once(realpath($_SERVER['DOCUMENT_ROOT'].'/'._SAPE_USER.'/sape.php'));
    $sape = new SAPE_client();
}
*/
// end of

