<?php

define('BB_SCRIPT', 'index');
require('./common.php');


// dj_maxx: AJAX chat integration (BETA)
function getShoutBoxContent() {
	// URL to the chat directory:
	if(!defined('AJAX_CHAT_URL')) {
		define('AJAX_CHAT_URL', './chat/');
	}
	
	// Path to the chat directory:
	if(!defined('AJAX_CHAT_PATH')) {
		define('AJAX_CHAT_PATH', realpath(dirname($_SERVER['SCRIPT_FILENAME']).'/chat').'/');
	}
	
	// Validate the path to the chat:
	if(@is_file(AJAX_CHAT_PATH.'lib/classes.php')) {
		
		// Include Class libraries:
		require_once(AJAX_CHAT_PATH.'lib/classes.php');
		
		// Initialize the shoutbox:
		$ajaxChat = new CustomAJAXChatShoutBox();
		
		// Parse and return the shoutbox template content:
		return $ajaxChat->getShoutBoxContent('shoutbox_opt.html');
	}
	
	return null;
}
// end of



$page_cfg['load_tpl_vars'] = array(
	'post_icons',
);

$show_last_topic    = true;
$last_topic_max_len = 28;
$show_online_users  = true;
$show_subforums     = true;

$datastore->enqueue(array(
	'stats',
// dj_maxx: add counter strike stats
	'cstrike_stats',
// end of
	'moderators',
));
if ($bb_cfg['show_latest_news'])
{
	$datastore->enqueue('latest_news');
}

// dj_maxx: add latest world news
if ($bb_cfg['show_latest_world_news'])
{
	$datastore->enqueue('latest_world_news');
}
// end of

$datastore->enqueue('birthday_today_list');
$datastore->enqueue('birthday_week_list');

// Init userdata
$user->session_start();

// dj_maxx: add latest discussions
if ($bb_cfg['show_latest_discussions'])
{
    if ($userdata['session_logged_in'])
    {
        $datastore->enqueue('latest_discussions');
    }
    else
    {
        $datastore->enqueue('latest_discussions_guest');
    }
}
// end of

// Init main vars
$viewcat = isset($_GET['c']) ? (int) $_GET['c'] : 0;
$lastvisit = (IS_GUEST) ? TIMENOW : $userdata['user_lastvisit'];

// dj_maxx: sitemap MOD
$viewtree = isset($_GET['showmap']) ? $_GET['showmap'] : 0;
// end of

// Caching output
$req_page = 'index_page';
$req_page .= ($viewcat) ? "_c{$viewcat}" : '';

define('REQUESTED_PAGE', $req_page);
caching_output(IS_GUEST, 'send', REQUESTED_PAGE .'_guest');

// Topics read tracks
$tracking_topics = get_tracks('topic');
$tracking_forums = get_tracks('forum');

// Statistics
$stats = $datastore->get('stats');

// dj_maxx: add counter strike stats
$cstrike_stats = $datastore->get('cstrike_stats');
// end of

// Forums data
$forums = $datastore->get('cat_forums');
$cat_title_html = $forums['cat_title_html'];
$forum_name_html = $forums['forum_name_html'];

$anon = ANONYMOUS;
$excluded_forums_csv = $user->get_excluded_forums(AUTH_VIEW);
$only_new = $user->opt_js['only_new'];

// Validate requested category id
if ($viewcat AND !$viewcat =& $forums['c'][$viewcat]['cat_id'])
{
	redirect("index.$phpEx");
}
// Forums
$forums_join_sql = 'f.cat_id = c.cat_id';
$forums_join_sql .= ($viewcat) ? "
	AND f.cat_id = $viewcat
" : '';
$forums_join_sql .= ($excluded_forums_csv) ? "
	AND f.forum_id NOT IN($excluded_forums_csv)
	AND f.forum_parent NOT IN($excluded_forums_csv)
" : '';

// Posts
$posts_join_sql = "p.post_id = f.forum_last_post_id";
$posts_join_sql .= ($only_new == ONLY_NEW_POSTS) ? "
	AND p.post_time > $lastvisit
" : '';
$join_p_type = ($only_new == ONLY_NEW_POSTS) ? 'INNER JOIN' : 'LEFT JOIN';

// Topics
$topics_join_sql = "t.topic_last_post_id = p.post_id";
$topics_join_sql .= ($only_new == ONLY_NEW_TOPICS) ? "
	AND t.topic_time > $lastvisit
" : '';
$join_t_type = ($only_new == ONLY_NEW_TOPICS) ? 'INNER JOIN' : 'LEFT JOIN';

$sql = "
	SELECT  SQL_CACHE
		f.cat_id, f.forum_id, f.forum_status, f.forum_parent, f.show_on_index, f.show_on_index_guest, f.forum_icon, f.forum_icon_new, f.forum_icon_locked,
		p.post_id AS last_post_id, p.post_time AS last_post_time,
		t.topic_id AS last_topic_id, t.topic_title AS last_topic_title,
		u.user_id AS last_post_user_id,
		IF(p.poster_id = $anon, p.post_username, u.username) AS last_post_username
	FROM       ". CATEGORIES_TABLE ." c
	INNER JOIN ". FORUMS_TABLE     ." f ON($forums_join_sql)
$join_p_type ". POSTS_TABLE      ." p ON($posts_join_sql)
$join_t_type ". TOPICS_TABLE     ." t ON($topics_join_sql)
	 LEFT JOIN ". USERS_TABLE      ." u ON(u.user_id = p.poster_id)
	ORDER BY c.cat_order, f.forum_order
";
$cat_forums = array();

$replace_in_parent = array(
	'last_post_id',
	'last_post_time',
	'last_post_user_id',
	'last_post_username',
	'last_topic_title',
	'last_topic_id',
);

foreach ($db->fetch_rowset($sql) as $row)
{
	if (!$cat_id = $row['cat_id'] OR !$forum_id = $row['forum_id'])
	{
		continue;
	}

	if ($parent_id = $row['forum_parent'])
	{
		if (!$parent =& $cat_forums[$cat_id]['f'][$parent_id])
		{
			$parent = $forums['f'][$parent_id];
			$parent['last_post_time'] = 0;
		}
		if ($row['last_post_time'] > $parent['last_post_time'])
		{
			foreach ($replace_in_parent as $key)
			{
				$parent[$key] = $row[$key];
			}
		}
		// dj_maxx: changed (add show on index for guests)
		if ($show_subforums && ( ($row['show_on_index'] && $userdata['session_logged_in']) || ($row['show_on_index_guest'] && !$userdata['session_logged_in']) ) )
		{
			$parent['last_sf_id'] = $forum_id;
		}
		else
		{
			continue;
		}
	}
	else
	{
		$f =& $forums['f'][$forum_id];
		$row['forum_desc']   = $f['forum_desc'];
		$row['forum_posts']  = $f['forum_posts'];
		$row['forum_topics'] = $f['forum_topics'];
	}

	$cat_forums[$cat_id]['f'][$forum_id] = $row;
}
unset($forums);
$datastore->rm('cat_forums');

// Obtain list of moderators
$moderators = array();
$mod = $datastore->get('moderators');

foreach ($mod['mod_users'] as $forum_id => $user_ids)
{
	foreach ($user_ids as $user_id)
	{
		$moderators[$forum_id][] = '<a href="'. (PROFILE_URL . $user_id) .'">'. $mod['name_users'][$user_id] .'</a>';
	}
}
foreach ($mod['mod_groups'] as $forum_id => $group_ids)
{
	foreach ($group_ids as $group_id)
	{
		$moderators[$forum_id][] = '<a href="'. (GROUP_URL . $group_id) .'">'. $mod['name_groups'][$group_id] .'</a>';
	}
}

unset($mod);
$datastore->rm('moderators');

if (!$forums_count = count($cat_forums) AND $viewcat)
{
	redirect("index.$phpEx");
}


// [MOD] Birthday (patched & optimized by dj_maxx)
$birthday_today_list = $datastore->get('birthday_today_list');
$birthday_week_list = $datastore->get('birthday_week_list');



/*
$sql = ($bb_cfg['birthday_check_day']) ? "SELECT user_id, username, user_birthday,user_level FROM " . USERS_TABLE. " WHERE user_birthday!=999999 ORDER BY username" :"";
if($result = $db->sql_query($sql))
{
	if (!empty($result))
	{
		$time_now = time();
		$this_year = create_date('Y', $time_now, $bb_cfg['board_timezone']);
		$date_today = create_date('Ymd', $time_now, $bb_cfg['board_timezone']);
		$date_forward = create_date('Ymd', $time_now+($bb_cfg['birthday_check_day']*86400), $bb_cfg['board_timezone']);
	   
		$birthday_today_list = "";
		$birthday_week_list = "";
	   
	   while ($birthdayrow = $db->sql_fetchrow($result))
		{
		   $user_birthday2 = $this_year.($user_birthday = realdate("md",$birthdayrow['user_birthday'] ));
      	if ( $user_birthday2 < $date_today ) $user_birthday2 += 10000;
			if ( $user_birthday2 > $date_today  && $user_birthday2 <= $date_forward )
			{
				// user are having birthday within the next days
				$user_age = ( $this_year.$user_birthday < $date_today ) ? $this_year - realdate ('Y',$birthdayrow['user_birthday'])+1 : $this_year- realdate ('Y',$birthdayrow['user_birthday']);
				
				switch ($birthdayrow['user_level'])
				{
					case ADMIN :
		      			$birthdayrow['username'] = '<span class="colorAdmin"><b>' . $birthdayrow['username'] . '</b></span>';
		      			$style_color = '';
						break;
					case MOD :
			      		$birthdayrow['username'] = '<span class="colorMod"><b>' . $birthdayrow['username'] . '</b></span>';
			      		$style_color = '';
						break;
					default: $style_color = '';
				}
				$birthday_week_list .= ' <a href="' . append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=" . $birthdayrow['user_id']) . '"' . $style_color .'>' . $birthdayrow['username'] . ' ('.$user_age.')</a>,';
			} else if ( $user_birthday2 == $date_today )
      		{
				//user have birthday today
				$user_age = $this_year - realdate ( 'Y',$birthdayrow['user_birthday'] );
				switch ($birthdayrow['user_level'])
				{
					case ADMIN :
		      			$birthdayrow['username'] = '<span class="colorAdmin"><b>' . $birthdayrow['username'] . '</b></span>';
		      			$style_color = '';
						break;
					case MOD :
			      		$birthdayrow['username'] = '<span class="colorMod"><b>' . $birthdayrow['username'] . '</b></span>';
			      		$style_color = '';
						break;
					default: $style_color = '';
				}

				$birthday_today_list .= ' <a href="' . append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=" . $birthdayrow['user_id']) . '"' . $style_color .'>' . $birthdayrow['username'] . ' ('.$user_age.')</a>,';
		      }
			 
		}
		if ($birthday_today_list) $birthday_today_list[ strlen( $birthday_today_list)-1] = ' ';
		if ($birthday_week_list) $birthday_week_list[ strlen( $birthday_week_list)-1] = ' ';
	}
	$db->sql_freeresult($result);
}
*/
// [MOD] Birthday [END]


$template->assign_vars(array(
	'SHOW_FORUMS'           => $forums_count,
//	'PAGE_TITLE'            => $lang['Index'],
	'NO_FORUMS_MSG'         => ($only_new) ? $lang['NO_NEW_POSTS'] : $lang['NO_FORUMS'],

	'TOTAL_POSTS'           => sprintf($lang['Posted_articles_total'], $stats['postcount']),
	'TOTAL_USERS'           => sprintf($lang['Registered_users_total'], $stats['usercount']),
	'NEWEST_USER'           => sprintf($lang['Newest_user'], '<a href="'. PROFILE_URL . $stats['newestuser']['user_id'] .'">', $stats['newestuser']['username'], '</a>'),

// dj_maxx: add warnings & bans
	'RESPECTED_USERS'	=> $lang['RESPECTED_USERS']. $stats['respected_users'],
// end of

// dj_maxx: add tracker stats
// dj_maxx: tracker stats incl. external peers
	'PEER_COUNT_EXT'		=> sprintf("  ( ): <span class=\"bold\">%s</span>", $stats['peercount']+$stats['peercount_ext']),
	'UNI_PEER_COUNT_EXT'	=> sprintf(",   : <span class=\"bold\">%s</span>", $stats['unipeercount']+$stats['unipeercount_ext']),
	'SEEDERS_EXT'			=> sprintf(": <span class=\"bold\">%s</span>", $stats['seeders_ext']),
	'LEECHERS_EXT'			=> sprintf(": <span class=\"bold\">%s</span>", $stats['leechers_ext']),
// end of
	'PEER_COUNT'            => sprintf(" : <span class=\"bold\">%s</span>", $stats['peercount']),
	'UNI_PEER_COUNT'        => sprintf(",   : <span class=\"bold\">%s</span>", $stats['unipeercount']),
	'TORRENT_COUNT'         => sprintf("  : <span class=\"bold\">%s</span>", $stats['torrentcount']),
	'SPEED_UP'              => sprintf(": <span class=\"bold\">%s</span>", humn_size($stats['speedup']).'/s'),
	'SPEED_DOWN'            => sprintf(": <span class=\"bold\">%s</span>", humn_size($stats['speeddown']).'/s'),
	'SEEDERS'               => sprintf(": <span class=\"bold\">%s</span>", $stats['seeders']),
	'LEECHERS'              => sprintf(": <span class=\"bold\">%s</span>", $stats['leechers']),
// end of


	// [MOD] Birthday
	
	// 'WHOSBIRTHDAY_WEEK'     => ($bb_cfg['birthday_check_day'] > 1) ? sprintf( (($birthday_week_list) ? $lang['Birthday_week'] : $lang['Nobirthday_week']), $bb_cfg['birthday_check_day']).$birthday_week_list : '',
	'WHOSBIRTHDAY_TODAY'    => ($bb_cfg['birthday_check_day']) ? ($birthday_today_list) ? $lang['Birthday_today'].$birthday_today_list : $lang['Nobirthday_today'] : '',
	
	// [MOD] Birthday [END]


	'FORUM_IMG'             => $images['forum'],
	'FORUM_NEW_IMG'         => $images['forum_new'],
	'FORUM_LOCKED_IMG'      => $images['forum_locked'],

	'SHOW_ONLY_NEW_MENU'    => $userdata['session_logged_in'],
	'ONLY_NEW_POSTS_ON'     => ($only_new == ONLY_NEW_POSTS),
	'ONLY_NEW_TOPICS_ON'    => ($only_new == ONLY_NEW_TOPICS),

	'U_SEARCH_NEW'          => "search.$phpEx?new=1",
	'U_SEARCH_SELF_BY_MY'   => "search.$phpEx?uid={$userdata['user_id']}&amp;o=1",
	'U_SEARCH_LATEST'       => "search.$phpEx?search_id=latest",
	'U_SEARCH_UNANSWERED'   => "search.$phpEx?search_id=unanswered",

	'SHOW_LAST_TOPIC'       => $show_last_topic,
));

// dj_maxx: add category toggle
$collapsed_cats = !empty($_COOKIE['collapseprefs']) ? explode(',', $_COOKIE['collapseprefs']) : array();
// end of

// Build index page
foreach ($cat_forums as $cid => $c)
{
// dj_maxx: add category toggle
	$cat_collapsed = in_array($cid, $collapsed_cats);
// end of
	$template->assign_block_vars('c', array(
		'CAT_ID'    => $cid,
		'CAT_TITLE' => $cat_title_html[$cid],
		'U_VIEWCAT' => "index.$phpEx?c=$cid",
// dj_maxx: add category toggle
		'CAT_BTN_CLASS' => $cat_collapsed ? 'folded2' : 'unfolded2',
		'CAT_DISPLAY' => $cat_collapsed ? 'style="display: none"' : '',
// end of
	));

	foreach ($c['f'] as $fid => $f)
	{
		if (!$fname_html =& $forum_name_html[$fid])
		{
			continue;
		}
		$is_sf = $f['forum_parent'];

		$new = is_unread($f['last_post_time'], $f['last_topic_id'], $f['forum_id']) ? '_new' : '';

		$folder_image = ($is_sf) ? $images["icon_minipost{$new}"] : /*$images["forum{$new}"]*/$bb_cfg['tpl_img_path'] . $f["forum_icon{$new}"];

		if ($f['forum_status'] == FORUM_LOCKED)
		{
			$folder_image = ($is_sf) ? $images['icon_minipost'] : /*$images['forum_locked']*/$bb_cfg['tpl_img_path'] . $f["forum_icon_locked"];
		}

		if ($is_sf)
		{

		    // patch by dj_maxx - remove (...) in subforums names
			$bracket_pos = strpos($fname_html, '(');

			$sf_btn_class = ($folder_image == $images["icon_minipost_new"]) ? 'dot-sf-new' : 'dot-sf';
			
 			$template->assign_block_vars('c.f.sf', array(
				'SF_ID'   => $fid,
				'SF_NAME' => rtrim(substr($fname_html, 0, $bracket_pos ? $bracket_pos : 255)),
				'SF_BTN_CLASS'  => $sf_btn_class,
			));
			continue;
		}

		$template->assign_block_vars('c.f',	array(
			'FORUM_FOLDER_IMG' => $folder_image,

			'FORUM_ID'   => $fid,
			'FORUM_NAME' => $fname_html,
			'FORUM_DESC' => $f['forum_desc'],
			'POSTS'      => commify($f['forum_posts']),
			'TOPICS'     => commify($f['forum_topics']),
			'LAST_SF_ID' => isset($f['last_sf_id']) ? $f['last_sf_id'] : null,

			'MODERATORS'  => isset($moderators[$fid]) ? join(', ', $moderators[$fid]) : '',
			'FORUM_FOLDER_ALT' => ($new) ? 'new' : 'old',
		));

		if ($f['last_post_id'])
		{
			$template->assign_block_vars('c.f.last', array(
				'LAST_TOPIC_ID'       => $f['last_topic_id'],
				'LAST_TOPIC_TIP'      => $f['last_topic_title'],
				'LAST_TOPIC_TITLE'    => wbr(str_short($f['last_topic_title'], $last_topic_max_len)),

				'LAST_POST_TIME'      => create_date($bb_cfg['last_post_date_format'], $f['last_post_time']),
				'LAST_POST_USER_ID'   => ($f['last_post_user_id'] != ANONYMOUS) ? $f['last_post_user_id'] : false,
				'LAST_POST_USER_NAME' => ($f['last_post_username']) ? str_short($f['last_post_username'], 15) : $lang['Guest'],
			));
		}
	}
}

// Set tpl vars for bt_userdata
if ($bb_cfg['bt_show_dl_stat_on_index'] && !IS_GUEST)
{
	show_bt_userdata($userdata['user_id']);
}

// Latest news
if ( $bb_cfg['show_latest_news'] && ($viewcat == 0) )
{
	$latest_news = $datastore->get('latest_news');

	$template->assign_vars(array(
		'SHOW_LATEST_NEWS' => true,
	));

	foreach ($latest_news as $news)
	{
		$template->assign_block_vars('news', array(
			'NEWS_TOPIC_ID' => $news['topic_id'],
			'NEWS_TITLE'    => $news['topic_title'],
			'NEWS_TIME'     => create_date('d-M', $news['topic_time']),
			'NEWS_IS_NEW'   => $news['topic_time'] > $lastvisit,
			// dj_maxx: add topic color
			'NEWS_COLOR'    => $news['topic_color'],
			// end of
		));
	}
}
else
{
	$template->assign_vars(array(
		'SHOW_LATEST_NEWS' => false,
	));
}

// dj_maxx: add latest discussions
// Latest discussions
if ($bb_cfg['show_latest_discussions'])
{
	$latest_news = $userdata['session_logged_in'] ? $datastore->get('latest_discussions') : $datastore->get('latest_discussions_guest');
    
	$template->assign_vars(array(
		'SHOW_LATEST_DISCUSSIONS' => true,
	));

	foreach ($latest_news as $news)
	{
		$template->assign_block_vars('discussions', array(
			'DISCUSSIONS_TOPIC_ID' => $news['topic_id'],
			'DISCUSSIONS_TITLE'    => $news['topic_title'],
			'DISCUSSIONS_TIME'     => create_date('H:i:s', $news['topic_time']),
			'DISCUSSIONS_IS_NEW'   => $news['topic_time'] > $lastvisit,
			// dj_maxx: add topic color
			'DISCUSSIONS_COLOR'    => $news['topic_color'],
			// end of

		));
	}
}
// end of

// dj_maxx: add latest world news
// Latest world news
if ($bb_cfg['show_latest_world_news'])
{
	$latest_news = $datastore->get('latest_world_news');

	$template->assign_vars(array(
		'SHOW_LATEST_WORLD_NEWS' => true,
	));

	foreach ($latest_news as $news)
	{
		$template->assign_block_vars('world_news', array(
			'WORLD_NEWS_TOPIC_ID' => $news['topic_id'],
			'WORLD_NEWS_TITLE'    => $news['topic_title'],
			'WORLD_NEWS_TIME'     => create_date('H:i:s', $news['topic_time']),
			'WORLD_NEWS_IS_NEW'   => $news['topic_time'] > $lastvisit,
			// dj_maxx: add topic color
			'WORLD_NEWS_COLOR'    => $news['topic_color'],
			// end of

		));
	}
}
// end of


// Allow cron
if (@file_exists('./triggers/cron_running')) {
	if (@file_exists('./triggers/cron_allowed'))
	{
		unlink ('./triggers/cron_allowed');
	}
	rename("./triggers/cron_running", "./triggers/cron_allowed");
}
// Display page
define('SHOW_ONLINE', $show_online_users);


// dj_maxx: sitemap MOD
if ($viewtree)
{
	$template->assign_vars(array(
		'PAGE_TITLE' => $lang['MAP_TITLE'],
		'SHOW_MAP' => true,
	));
}
// end of

print_page('index.tpl');
