<?php

define('BB_SCRIPT', 'index');
require('./common.php');


$page_cfg['load_tpl_vars'] = array(
	'post_icons',
);

$show_last_topic    = true;
$last_topic_max_len = 28;
$show_online_users  = true;
$show_subforums     = true;

$datastore->enqueue(array(
	'stats',
// dj_maxx: add counter strike stats
	'cstrike_stats',
// end of
	'moderators',
));
if ($bb_cfg['show_latest_news'])
{
	$datastore->enqueue('latest_news');
}

// dj_maxx: add latest world news
if ($bb_cfg['show_latest_world_news'])
{
	$datastore->enqueue('latest_world_news');
}
// end of

$datastore->enqueue('birthday_today_list');
$datastore->enqueue('birthday_week_list');

// Init userdata
$user->session_start();

// dj_maxx: add latest discussions
if ($bb_cfg['show_latest_discussions'])
{
    if ($userdata['session_logged_in'])
    {
        $datastore->enqueue('latest_discussions');
    }
    else
    {
        $datastore->enqueue('latest_discussions_guest');
    }
}
// end of

// Init main vars
$viewcat = isset($_GET['c']) ? (int) $_GET['c'] : 0;
$lastvisit = (IS_GUEST) ? TIMENOW : $userdata['user_lastvisit'];

// Topics read tracks
$tracking_topics = get_tracks('topic');
$tracking_forums = get_tracks('forum');

// Statistics
$stats = $datastore->get('stats');

// dj_maxx: add counter strike stats
$cstrike_stats = $datastore->get('cstrike_stats');
// end of

// Forums data
$forums = $datastore->get('cat_forums');
$cat_title_html = $forums['cat_title_html'];
$forum_name_html = $forums['forum_name_html'];

$anon = ANONYMOUS;
$excluded_forums_csv = $user->get_excluded_forums(AUTH_VIEW);
$only_new = $user->opt_js['only_new'];

// Validate requested category id
if ($viewcat AND !$viewcat =& $forums['c'][$viewcat]['cat_id'])
{
	redirect("index.$phpEx");
}


// search vars handling -------------------------------------------------------
$srch = request_var("srch", '');

print_r($_POST);

// categories 
$kino            = request_var("kino",           0);
 $kinosd         = request_var("kinosd",         0);
 $kinohd         = request_var("kinohd",         0);
$ruskino         = request_var("ruskino",        0);
 $ruskinosd      = request_var("ruskinosd",      0);
 $ruskinohd      = request_var("ruskinohd",      0);
$games           = request_var("games",          0);
 $gamesaction    = request_var("gamesaction",    0);
 $gamesarcade    = request_var("gamesarcade",    0);
 $gamesrpg       = request_var("gamesrpg",       0);
 $gamessimulator = request_var("gamessimulator", 0);
 $gamesother     = request_var("gamesother",     0);
$music           = request_var("music",          0);
 $musicmp3       = request_var("musicmp3",       0);
 $musiclossless  = request_var("musiclossless",  0);
$soft            = request_var("soft",           0);
//-----------------------------------------------------------------------------

$sql = "SELECT	t.forum_id,
t.topic_id,
u.user_id,    
u.username,
t.topic_title,
p.post_html,
t.topic_time,
tor.attach_id,
tor.size,
(ts.seeders + ts.seeders_ext) AS seeders,
(ts.leechers + ts.leechers_ext) AS leechers
FROM
bb_topics t
LEFT JOIN bb_posts_html p ON t.topic_first_post_id = p.post_id
LEFT JOIN bb_bt_torrents tor ON t.topic_id = tor.topic_id
LEFT JOIN bb_bt_tracker_snap ts ON t.topic_id = ts.topic_id
LEFT JOIN bb_users u ON t.topic_poster = u.user_id
WHERE
t.topic_dl_type = 1 AND
tor.tor_status in (2,10) 

ORDER BY tor.reg_time DESC
LIMIT 25";

foreach ($db->fetch_rowset($sql) as $row)
{
	$template->assign_block_vars('c', array(
		'TOPIC_ID'    => $row['topic_id'],
		'TOPIC_TITLE' => $row['topic_title'],
	    'POST_HTML' => rel_short_desc($row['post_html']),
	    'POST_AUTHOR' => $row['username'],
	    'POST_AUTHOR_ID' => $row['user_id'],
	    'SEEDERS' => $row['seeders'],
	    'LEECHERS' => $row['leechers'],
	    'SIZE' => humn_size($row['size']),
	));
}
unset($forums);
$datastore->rm('cat_forums');

// search options
$template->assign_vars(array(
		'SRCH'             => $srch,
    
		'SHOW_KINOHDSD'    => ($kino == 1) ? '' : 'style="display: none;"',
        'KINO'             => ($kino == 1) ? 'checked="checked"' : '',
		'KINOSD'           => ($kinosd == 1) ? 'checked="checked"' : '',
		'KINOHD'           => ($kinohd == 1) ? 'checked="checked"' : '',

		'SHOW_RUSKINOHDSD' => ($ruskino == 1) ? '' : 'style="display: none;"',
        'RUSKINO'          => ($ruskino == 1) ? 'checked="checked"' : '',
		'RUSKINOSD'        => ($ruskinosd == 1) ? 'checked="checked"' : '',
		'RUSKINOHD'        => ($ruskinohd == 1) ? 'checked="checked"' : '',

		'SHOW_GAMESGENRES' => ($games == 1) ? '' : 'style="display: none;"',
        'GAMES'            => ($games == 1) ? 'checked="checked"' : '',
		'GAMESACTION'      => ($gamesaction == 1) ? 'checked="checked"' : '',
		'GAMESARCADE'      => ($gamesarcade == 1) ? 'checked="checked"' : '',
        'GAMESRPG'         => ($gamesrpg == 1) ? 'checked="checked"' : '',
        'GAMESSIMULATOR'   => ($gamessimulator == 1) ? 'checked="checked"' : '',
        'GAMESOTHER'       => ($gamesother == 1) ? 'checked="checked"' : '',
    
        'SHOW_MUSIC'       => ($music == 1) ? '' : 'style="display: none;"',
        'MUSIC'            => ($music == 1) ? 'checked="checked"' : '',
        'MUSICMP3'         => ($musicmp3 == 1) ? 'checked="checked"' : '',
        'MUSICLOSSLESS'    => ($musiclossless == 1) ? 'checked="checked"' : '',
));


// [MOD] Birthday (patched & optimized by dj_maxx)
$birthday_today_list = $datastore->get('birthday_today_list');
$birthday_week_list = $datastore->get('birthday_week_list');
// [MOD] Birthday [END]

$template->assign_vars(array(
	'SHOW_FORUMS'           => 1,
//	'PAGE_TITLE'            => $lang['Index'],
	'NO_FORUMS_MSG'         => ($only_new) ? $lang['NO_NEW_POSTS'] : $lang['NO_FORUMS'],

	'TOTAL_POSTS'           => sprintf($lang['Posted_articles_total'], $stats['postcount']),
	'TOTAL_USERS'           => sprintf($lang['Registered_users_total'], $stats['usercount']),
	'NEWEST_USER'           => sprintf($lang['Newest_user'], '<a href="'. PROFILE_URL . $stats['newestuser']['user_id'] .'">', $stats['newestuser']['username'], '</a>'),

// dj_maxx: add warnings & bans
	'RESPECTED_USERS'	=> $lang['RESPECTED_USERS']. $stats['respected_users'],
// end of

// dj_maxx: add tracker stats
// dj_maxx: tracker stats incl. external peers
	'PEER_COUNT_EXT'		=> sprintf("  ( ): <span class=\"bold\">%s</span>", $stats['peercount']+$stats['peercount_ext']),
	'UNI_PEER_COUNT_EXT'	=> sprintf(",   : <span class=\"bold\">%s</span>", $stats['unipeercount']+$stats['unipeercount_ext']),
	'SEEDERS_EXT'			=> sprintf(": <span class=\"bold\">%s</span>", $stats['seeders_ext']),
	'LEECHERS_EXT'			=> sprintf(": <span class=\"bold\">%s</span>", $stats['leechers_ext']),
// end of
	'PEER_COUNT'            => sprintf(" : <span class=\"bold\">%s</span>", $stats['peercount']),
	'UNI_PEER_COUNT'        => sprintf(",   : <span class=\"bold\">%s</span>", $stats['unipeercount']),
	'TORRENT_COUNT'         => sprintf("  : <span class=\"bold\">%s</span>", $stats['torrentcount']),
	'SPEED_UP'              => sprintf(": <span class=\"bold\">%s</span>", humn_size($stats['speedup']).'/s'),
	'SPEED_DOWN'            => sprintf(": <span class=\"bold\">%s</span>", humn_size($stats['speeddown']).'/s'),
	'SEEDERS'               => sprintf(": <span class=\"bold\">%s</span>", $stats['seeders']),
	'LEECHERS'              => sprintf(": <span class=\"bold\">%s</span>", $stats['leechers']),
// end of


	// [MOD] Birthday
	
	// 'WHOSBIRTHDAY_WEEK'     => ($bb_cfg['birthday_check_day'] > 1) ? sprintf( (($birthday_week_list) ? $lang['Birthday_week'] : $lang['Nobirthday_week']), $bb_cfg['birthday_check_day']).$birthday_week_list : '',
	'WHOSBIRTHDAY_TODAY'    => ($bb_cfg['birthday_check_day']) ? ($birthday_today_list) ? $lang['Birthday_today'].$birthday_today_list : $lang['Nobirthday_today'] : '',
	
	// [MOD] Birthday [END]


	'FORUM_IMG'             => $images['forum'],
	'FORUM_NEW_IMG'         => $images['forum_new'],
	'FORUM_LOCKED_IMG'      => $images['forum_locked'],

	'SHOW_ONLY_NEW_MENU'    => $userdata['session_logged_in'],
	'ONLY_NEW_POSTS_ON'     => ($only_new == ONLY_NEW_POSTS),
	'ONLY_NEW_TOPICS_ON'    => ($only_new == ONLY_NEW_TOPICS),

	'U_SEARCH_NEW'          => "search.$phpEx?new=1",
	'U_SEARCH_SELF_BY_MY'   => "search.$phpEx?uid={$userdata['user_id']}&amp;o=1",
	'U_SEARCH_LATEST'       => "search.$phpEx?search_id=latest",
	'U_SEARCH_UNANSWERED'   => "search.$phpEx?search_id=unanswered",

	'SHOW_LAST_TOPIC'       => $show_last_topic,
));


// Set tpl vars for bt_userdata
if ($bb_cfg['bt_show_dl_stat_on_index'] && !IS_GUEST)
{
	show_bt_userdata($userdata['user_id']);
}

// Latest news
if ( $bb_cfg['show_latest_news'] && ($viewcat == 0) )
{
	$latest_news = $datastore->get('latest_news');

	$template->assign_vars(array(
		'SHOW_LATEST_NEWS' => true,
	));

	foreach ($latest_news as $news)
	{
		$template->assign_block_vars('news', array(
			'NEWS_TOPIC_ID' => $news['topic_id'],
			'NEWS_TITLE'    => $news['topic_title'],
			'NEWS_TIME'     => create_date('d-M', $news['topic_time']),
			'NEWS_IS_NEW'   => $news['topic_time'] > $lastvisit,
			// dj_maxx: add topic color
			'NEWS_COLOR'    => $news['topic_color'],
			// end of
		));
	}
}
else
{
	$template->assign_vars(array(
		'SHOW_LATEST_NEWS' => false,
	));
}

// dj_maxx: add latest discussions
// Latest discussions
if ($bb_cfg['show_latest_discussions'])
{
	$latest_news = $userdata['session_logged_in'] ? $datastore->get('latest_discussions') : $datastore->get('latest_discussions_guest');
    
	$template->assign_vars(array(
		'SHOW_LATEST_DISCUSSIONS' => true,
	));

	foreach ($latest_news as $news)
	{
		$template->assign_block_vars('discussions', array(
			'DISCUSSIONS_TOPIC_ID' => $news['topic_id'],
			'DISCUSSIONS_TITLE'    => $news['topic_title'],
			'DISCUSSIONS_TIME'     => create_date('H:i:s', $news['topic_time']),
			'DISCUSSIONS_IS_NEW'   => $news['topic_time'] > $lastvisit,
			// dj_maxx: add topic color
			'DISCUSSIONS_COLOR'    => $news['topic_color'],
			// end of

		));
	}
}
// end of

// dj_maxx: add latest world news
// Latest world news
if ($bb_cfg['show_latest_world_news'])
{
	$latest_news = $datastore->get('latest_world_news');

	$template->assign_vars(array(
		'SHOW_LATEST_WORLD_NEWS' => true,
	));

	foreach ($latest_news as $news)
	{
		$template->assign_block_vars('world_news', array(
			'WORLD_NEWS_TOPIC_ID' => $news['topic_id'],
			'WORLD_NEWS_TITLE'    => $news['topic_title'],
			'WORLD_NEWS_TIME'     => create_date('H:i:s', $news['topic_time']),
			'WORLD_NEWS_IS_NEW'   => $news['topic_time'] > $lastvisit,
			// dj_maxx: add topic color
			'WORLD_NEWS_COLOR'    => $news['topic_color'],
			// end of

		));
	}
}
// end of


// Allow cron
if (@file_exists('./triggers/cron_running')) {
	if (@file_exists('./triggers/cron_allowed'))
	{
		unlink ('./triggers/cron_allowed');
	}
	rename("./triggers/cron_running", "./triggers/cron_allowed");
}
// Display page
define('SHOW_ONLINE', $show_online_users);


print_page('portal.tpl');
