<?php
#
# Release wizard for PHPBB Bittorent Tracker (TorrentPier)
# Copyright (c) by pservit
# Support forum: http://www.torrents.net.ua/forum/viewtopic.php?t=2341
#

define('IN_PHPBB', TRUE);
define('IN_RW', TRUE);

require('./common.php');

####
# require release-wizard config
$VERSION = '2.0-beta2';
require($phpbb_root_path .'release_cfg.php');
####

// dj_maxx: strip BBCode and normalize spaces functions
function strip_bbcode($text_to_search)
{
	return preg_replace('|[[\/\!]*?[^\[\]]*?]|si', '', $text_to_search);
}

function normalize_spaces($str) // for shapka :)
{

    // replace "\" with "/"
    $str = str_replace("\\", "/", $str);

    // pad "(", "/", "-" and ")" with spaces
    $str = str_replace("(", " (", $str);
    $str = str_replace(")", ") ", $str);
    $str = str_replace("/", " / ", $str);
    $str = str_replace(" -", " - ", $str);
    $str = str_replace("- ", " - ", $str);

    // comma and colons must be with space
    $str = str_replace(",", ", ", $str);
    //$str = str_replace(".", ". ", $str);
    $str = str_replace(";", "; ", $str);
    $str = str_replace(":", ": ", $str);

    // kill extra spaces
    $str = trim(preg_replace("/\s+/", " ", $str));

    // get rid of "unneeded" spaces
    $str = str_replace("( ", "(", $str);
    $str = str_replace(" )", ")", $str);
    $str = str_replace(" ,", ",", $str);
    $str = str_replace(" .", ".", $str);
    $str = str_replace(" ;", ";", $str);


    return $str;
}
// end of

// dj_maxx: add imdb fix
function get_imdb_id($url)
{
	if (preg_match('%http://(www.)?imdb.com/title/([a-z0-9]+)%', $url, $regs)) {
		return $regs[2];
	} else {
		return '';
	}
}
// end of

// dj_maxx: add kinopoisk fix
function get_kinopoisk_id($url)
{
	if (preg_match('%http://(www.)?kinopoisk.ru/film/([a-z0-9]+)%', $url, $regs)) {
		return $regs[2];
	} else {
		return '';
	}
}
// end of


if ( ! function_exists('array_map_recursive') ) {
	function array_map_recursive($function, $data)
	{
		foreach ( $data as $i => $item ) {
		        $data[$i] = is_array($item) ? array_map_recursive($function, $item) : $function($item) ;
		}
	        return $data ;
	}
}

if ( get_magic_quotes_gpc() ) {
	$_GET = array_map_recursive('stripslashes', $_GET) ;
	$_POST = array_map_recursive('stripslashes', $_POST) ;
	$_COOKIE = array_map_recursive('stripslashes', $_COOKIE) ;
	$_REQUEST = array_map_recursive('stripslashes', $_REQUEST) ;
}



// Start session management
$user->session_start();

$user_id = $userdata['user_id'];

$what = isset($_REQUEST['what']) ? $_REQUEST['what'] : '';
$fid = (isset($_REQUEST['fid'])) ? intval($_REQUEST['fid']) : '';
// dj_maxx: add UV-info mode
$uvinfo = (isset($_REQUEST['uvinfo'])) ? intval($_REQUEST['uvinfo']) : 0;
// end of
$step = (isset($_REQUEST['step'])) ? intval($_REQUEST['step']) : 0;

$page_title = " ";

if($user_id > 0)
{
	if($what == '')	{
	require($phpbb_root_path .'includes/page_header.'. $phpEx);
?>

	<table width="100%" border="0" cellspacing="1" cellpadding="3" class="forumline">
	<tr>
		<th class="thHead" height="25"><b>   ?</b></th>
	</tr>
	<tr bgcolor="white">
	<td class="row2">
	    <!-- <br/> -->
	    <ul style="font-size: 14px">
	    <?php
		    foreach($config as $code => $cfg ) {
			    $gid = isset($cfg['only_for_group']) ? intval($cfg['only_for_group']) : 0;
			    if( $gid && !IS_ADMIN && !IS_MOD ) {
				    $gdata = $db->fetch_row("SELECT user_id FROM " . USER_GROUP_TABLE . " WHERE user_id = $user_id AND group_id = $gid AND user_pending = 0");
				    if( !isset($gdata['user_id']) ) continue;
			    }
			    echo('<li><a href="?what='.($code).'">'.($cfg['title']).'</a></li>');
		    }
	    ?>
	    </ul>
	</td>
	</tr>
	</table>
	<br/>
	<small>Release-wizard v.<?php echo($VERSION); ?> by  <a href="http://torrents.net.ua/forum/profile.php?mode=viewprofile&u=121">pservit</a><br/> Slightly patched by <a href="http://powertracker.org/torrent/forum/profile.php?mode=viewprofile&u=399">dj_maxx</a></small>
	<br/>
	<br/>
<?php
	require($phpbb_root_path .'includes/page_footer.'. $phpEx);
	} else {
		$cfg = $config[$what];

		if(!$cfg) {
			require($phpbb_root_path .'includes/page_header.'. $phpEx);
			message_die(GENERAL_ERROR, 'Can\'t get config for this release type', '', __LINE__, __FILE__);
			require($phpbb_root_path .'includes/page_footer.'. $phpEx);
		} else {
			$cfg['db'] = $db;
			$cfg['url'] = $url;
			$cfg['user_id'] = $user_id;

			$allow = 1;

			$gid = isset($cfg['only_for_group']) ? intval($cfg['only_for_group']) : 0;
			if( $gid && !IS_ADMIN && !IS_MOD ) {
				$gdata = $db->fetch_row("SELECT user_id FROM " . USER_GROUP_TABLE . " WHERE user_id = $user_id AND group_id = $gid AND user_pending = 0");
				if( !isset($gdata['user_id']) ) $allow = 0;
			}

			if($allow) {
				if(!$step || !is_form_valid($cfg)) {
					require($phpbb_root_path .'includes/page_header.'. $phpEx);
					echo(get_release_form($cfg, $step));
					require($phpbb_root_path .'includes/page_footer.'. $phpEx);
				} else {
					echo(get_phpbb_code_form($cfg));
				}
			} else {
				echo("Hello, world!");
			}
		}
	}
} else {
	require($phpbb_root_path .'includes/page_header.'. $phpEx);
?>
	<br />
	<table width="100%" border="0" cellspacing="1" cellpadding="3" class="forumline">
	<tr>
		<th class="thHead" height="25"><b></b></th>
	</tr>
	<tr>
		<td class="row1" align="center"><br /><font color="#CC3333">    .</font><br /><br /></td>
	</tr>
	</table>
	<br />
<?php
	require($phpbb_root_path .'includes/page_footer.'. $phpEx);
}


function get_release_form($cfg, $step)
{
	$forum_id = $cfg["forum_id"];

	$title = $cfg["title"];
	$fields = $cfg["fields"];
	$subject_after = $cfg["subject_after"];
	$subject_example = $cfg["subject_example"];
	// Freeman: add kinopoisk search
	$bf_kinopoisk_search = isset($cfg["bf_kinopoisk_search"]) ? $cfg["bf_kinopoisk_search"] : 0;
	// end: add kinopoisk search

	// dj_maxx: add UV-info mode
	$uvinfo_mode = isset($cfg["uvinfo_mode"]) ? $cfg["uvinfo_mode"] : 0;
	// end of

	$no_torrent = isset($cfg["no_torrent"]) ? $cfg["no_torrent"] : 0;
	
	$what = isset($_REQUEST['what']) ? $_REQUEST['what'] : '';

	global $fid /* dj_maxx: add UV-info mode */, $uvinfo /* end of */;

	$subject = isset($_REQUEST['subject']) ? $_REQUEST["subject"] : '';

	// dj_maxx: add normalize spaces to subject
	$subject = str_replace("\"", "\\\"", normalize_spaces($subject)/*$subject*/);
	// end of

	if( $subject == "" ) $subject = $subject_after;

// dj_maxx: add array support in forum_id
	if (is_array($forum_id)) {
		$forum_ids = $forum_id[0];
		foreach ($forum_id as $fi) $forum_ids .= ",".$fi;
		$sql_where = "(forum_id in ($forum_ids))";
	} else {
		$sql_where = "(forum_id=$forum_id OR forum_parent=$forum_id)";
	}

	// $res = $cfg['db']->sql_query("select forum_id, forum_name from " . FORUMS_TABLE . " as u where (forum_id=$forum_id OR forum_parent=$forum_id) AND allow_reg_tracker=1");
	$only_dl_where = $no_torrent ? "" : " AND allow_reg_tracker=1";
	
	$res = $cfg['db']->sql_query("select forum_id, forum_name from " . FORUMS_TABLE . " as u where " . $sql_where . $only_dl_where);
// end of array support
        if (!$res) {
	        message_die(GENERAL_ERROR, 'Could not get forums list', '', __LINE__, __FILE__);
	} else {
		$forums = @$cfg['db']->sql_fetchrowset($res);
	}
?>
	<style type="text/css">
	.rw_drop_btn, .rw_add_btn {
		width: 24px;
		font-weight: bold;
		color: white;
		background-color: #CC3333;
	}

	.rw_add_btn {
		background-color: #33CC33;
	}
	</style>

	<script language="JavaScript" src="release.js?v=6"></script>

    <?php if ($bf_kinopoisk_search == '1'){ ?>
    <!--Freeman:-->
    <script language="JavaScript" src="uv_search/brainforce.js?v=12"></script>
    <!--end:-->
    <?php } ?>

	<form method="post" name="post" enctype="multipart/form-data">
	<input type="hidden" name="step" value="1">
	<input type="hidden" name="what" value="<?php echo($what); ?>">

	<table width="100%" border="0" cellspacing="1" cellpadding="3" class="forums">
	<tr>
		<th class="thHead" colspan="2" height="25"><b><?php echo($title); ?></b></th>
	</tr>

    <?php if ($uvinfo_mode == '1'){ ?>
	<tr bgcolor="white">
		<td class="row1" align="right" width="20%"><b> :</b></td>
		<td class="row2">
			<select name="uvinfo_mode" onchange="toggle_mode(this.selectedIndex, '<?php echo($what); ?>', <?php echo($fid); ?>);">
				<option value="1" <?php echo ($uvinfo == '1' ? '' : 'selected');?> >   </option>
				<option value="2" <?php echo ($uvinfo == '1' ? 'selected' : '');?> >    UV-info</option>
			</select>
			<b>&laquo;-- <a href="viewtopic.php?t=2401" target="_blank">    -wizard'</a></b>
		</td>
	</tr>
    <?php } ?>

	<tr bgcolor="white">
		<td class="row1" align="right" width="20%"><b>:</b></td>
		<td class="row2">

	            <?php
 	            if( count($forums) == 1 ) {
 	                    echo("<input type=\"hidden\" name=\"f\" value=\"".($forums[0]['forum_id'])."\" />");
 	                    echo("<b>".($forums[0]['forum_name'])."</b>");
 	            } else {
 	                echo("<select name=\"f\">\n");
 	                for($i = 0; $i < count($forums); ++$i) {

 	                    $selected = ($forums[$i]['forum_id'] == $fid) ? ' selected' : '';
                	    echo("<option value=\"".($forums[$i]['forum_id'])."\"$selected>".($forums[$i]['forum_name'])."</option>");

 	                }
 	                echo("</select>\n");
 	                echo("<font color=\"#CC3333\"><b>&laquo;--    !!!</b></font>\n");
 	            }
	            ?>

			
		</td>
	</tr>
	<tr bgcolor="white">
		<td class="row1" align="right"><b>:</b></td>
		<td class="row2">
			<input type="text" name="subject" size="60" maxlength="160" value="" />

			<?php if ($bf_kinopoisk_search == '1'){ ?>
			<!--Freeman:   -->
			<input type="button" name="bf_kp_search" onClick="get_url('to=search&query=' + russ_escape(document.forms['post'].elements['subject'].value));" value="    ." />
			<input type="button" name="bf_imdb_search" onClick="if(info['name_orig']) get_url('to=search&core=imdb&query=' + info['name_orig']);" value="    IMDB.com" style="display: none;" />
			<!--end:   -->
			<?php } ?>

			<?php
			//Freeman: ,     .
			if($subject_example != '') {
				echo("<br /><font color=\"gray\"><small>: $subject_example</small></font>");
			}else if ($bf_kinopoisk_search == '1'){
				echo("<br />");
			}
			//end
			?>
			<?php if ($bf_kinopoisk_search == '1'){ ?>
			<!--Freeman:    . -->
			<div id="bf_http_request" style="display: none; padding-left: 20px; width: 600px;"></div>
            <!--end:    . -->
            <?php } ?>

		</td>
	</tr>
<?php

	$in_group = false;
	$multiple_group = false;
	$html = '';
	$js = '';

	for($i = 0; $i < count($fields); ++$i ) {
		$name       = isset($fields[$i]["name"]) ? $fields[$i]["name"] : '';
		$type       = isset($fields[$i]["type"]) ? $fields[$i]["type"] : '';
		$multiple   = isset($fields[$i]["multiple"]) ? $fields[$i]["multiple"] : 0;
		$default    = isset($fields[$i]["default"]) ? $fields[$i]["default"] : '';
		$example    = isset($fields[$i]["example"]) ? $fields[$i]["example"] : '';
		$values     = isset($fields[$i]["values"]) ? $fields[$i]["values"] : '';
		$comment    = isset($fields[$i]["comment"]) ? $fields[$i]["comment"] : '';
		$value      = ( isset($_REQUEST["f$i"]) && $_REQUEST["f$i"] != '') ? $_REQUEST["f$i"] : $default;
 		$group      = isset($fields[$i]["group"]) ? ($fields[$i]["group"] ? 1 : -1) : '';
 		$size       = isset($fields[$i]["size"]) ? $fields[$i]["size"] : 60;
 		$columns    = isset($fields[$i]["columns"]) ? $fields[$i]["columns"] : 4;
//		$validate   = isset($fields[$i]["validate"]) ? $fields[$i]["validate"] : 0;
		// dj_maxx: added visible/displayed part of list items (show preview)
		$imagelist_preview = isset($fields[$i]["imagelist_preview"]) ? $fields[$i]["imagelist_preview"] : 0;
		$imagelist_showtitle = isset($fields[$i]["imagelist_showtitle"]) ? $fields[$i]["imagelist_showtitle"] : 0;
		$imagelist_width = isset($fields[$i]["imagelist_width"]) ? $fields[$i]["imagelist_width"] : 88;
		$imagelist_height = isset($fields[$i]["imagelist_height"]) ? $fields[$i]["imagelist_height"] : 31;
		// end of
		// dj_maxx: add screenshots with preview
		$prompt_preview_mode = isset($fields[$i]["prompt_preview_mode"]) ? $fields[$i]["prompt_preview_mode"] : 0;
		// end of

		// dj_maxx: add UV-info mode
		$uvinfo_only = isset($fields[$i]["uvinfo_only"]) ? $fields[$i]["uvinfo_only"] : 0;
		$not_for_uvinfo = isset($fields[$i]["not_for_uvinfo"]) ? $fields[$i]["not_for_uvinfo"] : 0;
		if (!$uvinfo && $uvinfo_only   ) continue;
		if ($uvinfo  && $not_for_uvinfo) continue;
		// end of

		$field_name = "f$i";

 		if( $group == 1 ) {
 			$html .= ("<tr bgcolor=\"white\">\n");
 			$html .= ("<td class=\"row1\" align=\"right\">");
			$html .= ("<b>$name:</b>&nbsp;");
			if($comment) $html .= ("<br /><small>".$comment."</small>");
			$html .= ("</td><td class=\"row2\" style=\"font-size: 11px;\">");
 			$html .= ("<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\" class=\"wiztable\"><tr>");

			for($j = $i + 1; $i < count($fields) && !isset($fields[$j]["group"]); ++$j ) {
				$html .= ("<td><small>");
				$html .= ($fields[$j]["name"]);
				$html .= ("</small></td>");

			}

			if( $multiple ) {
				$multiple_group = true;
				$html .= ("<td>&nbsp;</td>");
			} else {
				$multiple_group = false;
			}

			$html .= ("</tr><tr>");

 	        	$in_group = true;
 		} else if( $group == -1 ) {
			$key = 'f'.($i - 1);
 			$html .= ("</td>");

			if($multiple_group) {
				$html .= ('<td><input class="rw_add_btn" name="insert_'.$key.'" type="button" onclick="mlAddVal(this);" value="+" />&nbsp;<input class="rw_drop_btn" name="drop_'.$key.'" type="button" onclick="mlDropVal(this);" value="-" />');
				$html .= ("<script>ml_vals['$key'] = new Array(); mlCheckForLast('$key');</script>");
				$html .= "</td>";
			}

			$html .= "</tr></table>";
 			$html .= ("</td></tr>");
 	        	$in_group = false;
 		} else {
		    	if(!$in_group) {
 				$html .= ("<tr bgcolor=\"white\">");
	 			$html .= ("<td class=\"row1\" align=\"right\">");
		 		$html .= ("<b>$name:</b>&nbsp;");
				if($comment) $html .= ("<br /><small>".$comment."</small>");
				$html .= ("</td>\n\t<td class=\"row2\">\n\t\t");
 			} else {
 				$html .= ("<td>");
				$field_name .= '[]';
			}

			if( $type == "text" || $type == "imdb" || $type == "kinopoisk") { // dj_maxx: add imdb & kinopoisk fix
				$value = str_replace("\"", "\\\"", $value);
				$html .= ("<input type=\"text\" name=\"$field_name\" size=\"".($size)."\" value=\"$value\">");
			} if( $type == "variant" ) {
				$value = str_replace("\"", "\\\"", $value);
				$html .= ("<input type=\"text\" name=\"$field_name\" id=\"$field_name\" size=\"60\" value=\"$value\"> <input type=\"button\" onclick=\"showhide('v$field_name')\" value=\"/ \" />");
				if( $values != '' ) {
					$html .= ("<div id=\"v$field_name\" style=\"display: none\"><table class=\"row3\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\">");
					for($j = 0; $j < count($values); ++$j ) {
						$v = $values[$j];
						if($j % $columns == 0) $html .= ("<tr>");
						$html .= ("<td width=\"".intval(100 / $columns)."%\"><input onchange=\"ch_var(this, $i)\" type=\"checkbox\" value=\"$v\" id=\"v$field_name-$j\"><label for=\"v$field_name-$j\">$v<label></td>");
						if($j % $columns == ($columns - 1)) $html .= ("</tr>\n");
					}
					$html .= ("</table></div>");
				}
			} else if( $type == "textarea" ) {
				$html .= ("<textarea rows=\"12\" style=\"width: 95%\" name=\"$field_name\">$value</textarea>");
			} else if( $type == "image" ) {
				// dj_maxx: add screenshots with preview
				if ($prompt_preview_mode) {
					$html .= "<table width=\"100%\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\"><tr><td>";
				}
				// end of
				$html .= ("<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\" class=\"wiztable\">");
		    		$key = $field_name;
				$n = $multiple ? $multiple : 1;
				for($j = 0; $j < $n; ++$j) {
					$html .= ("<tr><td><input type=\"file\" name=\"f".$i."[]\" size=\"70\" />");
					if( $multiple ) {
						$html .= ("</td><td>");
						$html .= ('<input class="rw_add_btn" name="insert_'.$key.'" type="button" onclick="mlAddVal(this);" value="+" />&nbsp;<input class="rw_drop_btn" name="drop_'.$key.'" type="button" onclick="mlDropVal(this);" value="-" />');
						$html .= ("<script>ml_vals['$key'] = new Array( new Array(0, 'input', '') ); mlCheckForLast('$key');</script>");
					}
					$html .= ("</td></tr>");
				}
				$html .= ("</table>");
				// dj_maxx: add screenshots with preview
				if ($prompt_preview_mode) {
					$html .= "</td><td><table border=\"0\"><tr><td><input type=\"radio\" name=\"p_$field_name\" value=\"0\"></td><td><b>   </b></td></tr><tr><td><input type=\"radio\" name=\"p_$field_name\" value=\"1\" checked></td><td><b>  ()</b></td></tr></table> </td></tr></table>";
				}
				// end of


			} else if( $type == "select" ) {
                //
                // dj_maxx - added multiple select, rewritten original code almost fully
                $html .= ("<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\" class=\"wiztable\">");
                $key = $field_name;
                $n = $multiple ? $multiple : 1;
                for($j = 0; $j < $n; ++$j) {

                    $html .= ("<tr><td>");
                    /////////

                    // dj_maxx: added visible/displayed part of list items (show preview)
                    if ($imagelist_preview)
                    {
                        $html .= "<table><tr><td>";
                        //$html .= ("<select name=\"".$field_name."[]\" onChange=\"document.images['imagelist_preview$i$j'].src = this.options[this.selectedIndex].title;\">");
                        $html .= ("<select name=\"".$field_name."[]\" onChange=\"$(this).parent('td').parent('tr').find('img').attr('src', this.options[this.selectedIndex].title);\">");
                        $html .= ("<option value=\"0\" title=\"images/flags/blank.gif\">---  ---</option>");

                    } else
                    {
                        $html .= ("<select name=\"".$field_name."[]\">");
                        $html .= ("<option value=\"0\">---  ---</option>");

                    }
                    // end of

                    for($k = 1; $k <= count($values); ++$k) {
                        $html .= ("<option value=\"$k\"");
                        if($k == $value) { $html .= (" selected=\"selected\""); }

                        // dj_maxx: added visible/displayed part of list items
                        if (strpos($values[$k-1],'|') !== false)
                        {
                            @list($visible_value, $post_value, $title_value) = @split('\|', $values[$k-1]);
                            if ($imagelist_preview)
                            {
                                $html .= (" title=\"".strip_bbcode($post_value)."\">".$visible_value."</option>");
                            }
                            else
                            {
                                $html .= (">".$visible_value."</option>");
                            }
                        }
                        else
                        {
                            $html .= (">".$values[$k-1]."</option>");
                        }

                    }
                    $html .= ("</select>");

                    // dj_maxx: added visible/displayed part of list items (show preview)
                    if ($imagelist_preview)
                    {
                        $html .= "</td><td>&nbsp;";
                        $html .= "<img src=\"images/flags/blank.gif\" width=\"$imagelist_width\" height=\"$imagelist_height\" name=\"imagelist_preview$i$j\" />";
                        $html .= "</td></tr></table>";
                    }
                    // end of
                    ////////////
                    if( $multiple ) {
                        $html .= ("</td><td>");
                        $html .= ('<input class="rw_add_btn" name="insert_'.$key.'" type="button" onclick="mlAddVal(this);" value="+" />&nbsp;<input class="rw_drop_btn" name="drop_'.$key.'" type="button" onclick="mlDropVal(this);" value="-" />');
                        $html .= ("<script>ml_vals['$key'] = new Array( new Array(0, 'input', '') ); mlCheckForLast('$key');</script>");
                    }
                    $html .= ("</td></tr>");
                }
                $html .= ("</table>");


			}

			if($example && !$in_group) {
				$html .= ("<br /><font color=\"gray\"><small>, \"$example\"</small></font>");
			}

			if(!$in_group) {
				$html .= ("\n\t</td>\n");
				$html .= ("</tr>\n");
			} else {
	     			$html .= ("</td>");
	     		}
		}
	}

	echo($html);
	
	if (!$no_torrent)
	{
?>
	<tr bgcolor="white">
	<td class="row1" colspan="2" style="height: 20px;"></td>
	</tr>
	<tr bgcolor="white">
		<td class="row1 leechmed tf_container" align="right"><b>- (!):</b></td>
		<td class="row2 tf_container"><input type="file" maxlength="2097152" size="70" name="tf"></td>
	</tr>
	<tr bgcolor="white">
	<td class="row1" colspan="2" style="height: 20px;"></td>
	</tr>
	<tr><td class="row2" colspan="2" align="center"><input type="submit" class="mainoption" value=""></td></tr>
	</table>
	</form>
	<br />

	<script type="text/javascript">
		$("form").submit(function() {

			var file = $('input[name="tf"]').val();
			var exts = ['torrent'];
			if ( file ) {
				var get_ext = file.split('.');
				get_ext = get_ext.reverse();
        
				if ( $.inArray ( get_ext[0].toLowerCase(), exts ) > -1 ){
					return true;
				} else {
					$('.tf_container').css('background-color','#ffbbaa');
					alert(',        .torrent !');
					return false;
				}
			} else {
				$('.tf_container').css('background-color','#ffbbaa');
				alert('  -!    !');
				return false;
			}
		
		});
	</script>
	
<?php
	}
	else
	{
?>
	<tr bgcolor="white">
	<td class="row1" colspan="2" style="height: 20px;"></td>
	</tr>
	<tr><td class="row2" colspan="2" align="center"><input type="submit" class="mainoption" value=""></td></tr>
	</table>
	</form>
	<br />

<?php
	}
}

function get_phpbb_code_field($config, $field_name, $value, $in_group, $number)
{
		global $bb_cfg, $cfg, $db /* dj_maxx: add imdb & kinopoisk fix */, $imdb_mod_url, $kinopoisk_mod_url /* end of */;

		$name         = isset($config["name"]) ? $config["name"] : '';
		$type         = isset($config["type"]) ? $config["type"] : '';
		$multiple     = isset($config["multiple"]) ? $config["multiple"] : '';
		$example      = isset($config["example"]) ? $config["example"] : '';
		$values       = isset($config["values"]) ? $config["values"] : '';
		$comment      = isset($config["comment"]) ? $config["comment"] : '';
 		$group        = isset($config["group"]) ? ($config["group"] ? 1 : -1) : '';
		$max_w        = isset($config["max_w"]) ? $config["max_w"] : '';
		$max_h        = isset($config["max_h"]) ? $config["max_h"] : '';
		$preview_max_w = isset($config["preview_max_w"]) ? $config["preview_max_w"] : '';
		$preview_max_h = isset($config["preview_max_w"]) ? $config["preview_max_w"] : '';

		// dj_maxx: added visible/displayed part of list items (show preview)
		$imagelist_showtitle = isset($config["imagelist_showtitle"]) ? $config["imagelist_showtitle"] : 0;
		// end of

		// dj_maxx: add search tag
		$enclose_in_tags = isset($config["search_tag"]) ? $config["search_tag"] : 0;
		// end of

		// dj_maxx: add screenshots with preview
		$prompt_preview_mode = isset($config["prompt_preview_mode"]) ? $config["prompt_preview_mode"] : 0;
		if ($prompt_preview_mode)
		{
			// ,    -    
			$prompt_preview_mode = isset($_REQUEST['p_'.$field_name]) ? intval($_REQUEST['p_'.$field_name]) : 0;

		}
	
		if ($prompt_preview_mode)
		{
			$hide_name    = isset($config["preview_hide_name"]) ? $config["preview_hide_name"] : 0;
			$before_name  = isset($config["preview_before_name"]) ? $config["preview_before_name"] : 0;
			$after_name   = isset($config["preview_after_name"]) ? $config["preview_after_name"] : 0;
			$before_value = isset($config["preview_before_value"]) ? $config["preview_before_value"] : "";
			$after_value  = isset($config["preview_after_value"]) ? $config["preview_after_value"] : ($in_group ? ($group == -1 ? "\n" : "") : "\n");
		}
		else
		{
			$hide_name    = isset($config["hide_name"]) ? $config["hide_name"] : 0;
			$before_name  = isset($config["before_name"]) ? $config["before_name"] : 0;
			$after_name   = isset($config["after_name"]) ? $config["after_name"] : 0;
			$before_value = isset($config["before_value"]) ? $config["before_value"] : "";
			$after_value  = isset($config["after_value"]) ? $config["after_value"] : ($in_group ? ($group == -1 ? "\n" : "") : "\n");
		}
		// end of

		if( !$before_name ) {
			if($in_group == 1 && $group != 1) {
				if( isset($config["group_before_name"]) ) $before_name = $config["group_before_name"]; else $before_name = "";
			} else {
				$before_name = "[b]";
			}
		}

		if( !$after_name ) {
			if($in_group == 1 && $group != 1) {
				if( isset($config["group_after_name"]) ) $after_name = $config["group_after_name"]; else $after_name = ": ";
			} else {
				$after_name = ": [/b]";
			}
		}

		
		$right        = isset($config["right"]) ? $config["right"] : 0;
		$as_url       = isset($config["as_url"]) ? $config["as_url"] : 0;
		
		$bbcode = '';

		if( $group == 1 ) {
			if(!$hide_name) $bbcode .= ($before_name.($name).($number ? ' #'.$number : '').$after_name);
			$bbcode .= ($before_value);
		} else if( $group == -1 ) {
			$bbcode .= ($after_value);
		} else {
			if( ($type == "text" || $type == 'variant') && $value != '' ) {
				if(!$hide_name) $bbcode .= ($before_name.($name).$after_name);

				// dj_maxx: add search tag
				if ($enclose_in_tags)
				{
					$pieces = explode(",", $value);
					foreach ( $pieces as $i => $item ) {
					        $pieces[$i] = '[tag]'.trim($item).'[/tag]';
					}
					$value = implode(", ", $pieces);
			
				}
				// end of

				$bbcode .= ($before_value.$value.$after_value);
			}
			// dj_maxx: add imdb fix
			else if ($type == "imdb" && ($val = get_imdb_id($value)) != '') {
				if(!$hide_name) $bbcode .= ($before_name.($name).$after_name);
				$val = '[url='.$value.'][img]'.$imdb_mod_url.'imdb_'.$val.'.gif[/img][/url]';
				$bbcode .= ($before_value.$val.$after_value);
			}
			// end of
			// dj_maxx: add kinopoisk fix
			else if ($type == "kinopoisk" && ($val = get_kinopoisk_id($value)) != '') {
				if(!$hide_name) $bbcode .= ($before_name.($name).$after_name);
				$val = '[url='.$value.'][img]'.$kinopoisk_mod_url.'kp_2_'.$val.'.jpg[/img][/url]';
				$bbcode .= ($before_value.$val.$after_value);
			}
			// end of
			else if( $type == "textarea" && $value != '' ) {
				if(!$hide_name) $bbcode .= ($before_name.($name).$after_name);
				$bbcode .= ($before_value.$value.$after_value);
			} else if( $type == "select" ) {
                //
                // dj_maxx - added multiple select, rewritten original code almost fully
				if (!$hide_name) $bbcode .= ($before_name.($name).$after_name);

                $cnt = count($_REQUEST[$field_name]);

                if(!$multiple && $cnt > 1) $cnt = 1;

                $bbcode .= $before_value;
                $text = '';
                for($j = 0; $j < $cnt; ++$j)
                {

				    // dj_maxx: added visible/displayed part of list items
				    if ($value[$j] > 0)
				    {
				    	if (strpos($values[$value[$j] - 1],'|'))
				    	{
						    @list($visible_value, $post_value, $title_value) = @split('\|', $values[$value[$j] - 1]);
						    if ($imagelist_showtitle)
						    {
                        				$post_value = $visible_value. ' ' .$post_value;
						    }
						    $text .= $post_value;
				    	} else
				    	{
						    $text .= $values[$value[$j] - 1];
				    	}
				    }
                    		    if ($j < $cnt-1) $text .= ", ";
				    // $bbcode .= $before_value.$values[$value - 1].$after_value;
				    // end of
                    /////
                }
                if ($text != '')
                {
			// dj_maxx: add search tag
			if ($enclose_in_tags)
			{
				$pieces = explode(",", $text);
				foreach ( $pieces as $i => $item ) {
				        $pieces[$i] = '[tag]'.trim($item).'[/tag]';
				}
				$text = implode(", ", $pieces);
		
			}
			// end of


			$bbcode .= $text;
			$bbcode .= $after_value;
                }
                else
                {
                    $bbcode = '';
                }
                //
                // end of
			} else if ($type == "image" ) {
				$img_bbcode = "";
				
				if(!$hide_name) $img_bbcode .= $before_name.($name).$after_name;

				$img_bbcode .= $before_value;
				
				$cnt = count($_FILES[$field_name]['name']);
				if(!$multiple && $cnt > 1) $cnt = 1;

				$has_images = 0;

				for($j = 0; $j < $cnt; ++$j) {
					if(is_uploaded_file($_FILES[$field_name]['tmp_name'][$j])) {
				    		
                        $im_type = $_FILES[$field_name]['type'][$j];

						if($im_type == "image/gif") {
							$ext = "gif";
						} else if($im_type == "image/jpg" || $im_type == "image/jpeg" || $im_type == "image/pjpeg") {
							$ext = "jpg";
						} else if($im_type == "image/png" || $im_type == "image/x-png") {
							$ext = "png";
						}

						if ($ext != "") {
				    		$imageInfo = getimagesize($_FILES[$field_name]['tmp_name'][$j]);
						    $w = $imageInfo[0];
							$h = $imageInfo[1];

							$userdir = $bb_cfg['pictures_upload_path'] . "/" . $cfg["user_id"];

							if (!file_exists($userdir))
							{
								mkdir($userdir, 0755);
							}

							$picname = strftime("%y%m%d%H%M%S").$cfg["user_id"].'_'.$field_name.'_'.$j.".$ext";
							$url = $cfg["user_id"] . "/" . $picname;
							$url_thumb = $cfg["user_id"] . "/thumbs/" . $picname;
							$fname = $userdir . "/" . $picname;
							$fname_thumb = $userdir . "/thumbs/" . $picname;
							
							$new_pic = 1;  // will be set to 0 if picture exists
							
							// dj_maxx: add screenshots with preview (easily portable code)
							if (is_callable('imagegd2') && $preview_max_w && $preview_max_h && $prompt_preview_mode) {

                                $md5sum = md5(file_get_contents($_FILES[$field_name]['tmp_name'][$j]));
                                $md5sum = md5($md5sum.'2');

                                if ($row = $db->fetch_row("SELECT * FROM bb_photos WHERE photo_hash = '$md5sum'"))
                                {
                                    $new_pic = 0;
                                    $picname = $row['photo_path'];
                                    $url = $row['poster_id'] . "/" . $picname;
                                    $url_thumb = $row['poster_id'] . "/thumbs/" . $picname;
                                }
                                else
                                {
                                
    								//      
								    if ($ext == "jpg") $source = imagecreatefromjpeg($_FILES[$field_name]['tmp_name'][$j]);
								    if ($ext == "gif") $source = imagecreatefromgif($_FILES[$field_name]['tmp_name'][$j]);
								    if ($ext == "png") $source = imagecreatefrompng($_FILES[$field_name]['tmp_name'][$j]);


								    if ($w >= $h)
								    {
								    	$nw = $config['preview_max_w'];
									    $nh = $h * ($config['preview_max_w'] / $w);

									    if ($nh > $config['preview_max_h'])
									    {
										    $nw = $config['preview_max_w'] * ($config['preview_max_h'] / $nh);
										    $nh = $config['preview_max_h'];
									    }
								    }

								    if ($w < $h)
								    {
									    $nw = $w * ($config['preview_max_h'] / $h);
									    $nh = $config['preview_max_h'];

									    if ($nw > $config['preview_max_w'])
									    {
										    $nh = $config['preview_max_h'] * ($config['preview_max_w'] / $nw);
										    $nw = $config['preview_max_w'];
									    }
                                    }

							    	//   
								    $target = imagecreatetruecolor($nw, $nh);
								
								    //  
								    if ($ext == "png" || $ext == "gif")
								    {
									    imagealphablending($target, false);
									    imagesavealpha($target, true);
									    $transparent = imagecolorallocatealpha($target, 255, 255, 255, 127);
									    imagefilledrectangle($target, 0, 0, $nw, $nh, $transparent);
								    }
									
								    //        :
								    imagecopyresampled(
								        $target,
								        $source,
								        0,0,
								        0,0,
								        $nw,
								        $nh,
								        $w,
								        $h
								    );

								
								    //    ,   
								    move_uploaded_file($_FILES[$field_name]['tmp_name'][$j], $fname);
									
								    //    
                                    $thumbdir = $userdir.'/thumbs';
								    if (!file_exists($thumbdir))
								    {
									    mkdir($thumbdir, 0755);
								    }

                                    imagejpeg($target, $fname_thumb, 96); //     jpg

								    imagedestroy($source);
								    imagedestroy($target);
                                
                                } // not exists md5
								
                                $img_bbcode .= '[fancybox='.($cfg['url'].$url).']'.($cfg['url'].$url_thumb).'[/fancybox]';
							}
							// end of
							elseif (is_callable('imagegd2') && $max_w && $max_h) {

								if($w > $max_w || $h > $max_h) { //   

                                    $md5sum = md5(file_get_contents($_FILES[$field_name]['tmp_name'][$j]));
                                    $md5sum = md5($md5sum.'1'.$max_w.$max_h);

                                    if ($row = $db->fetch_row("SELECT * FROM bb_photos WHERE photo_hash = '$md5sum'"))
                                    {
                                        $new_pic = 0;
                                        $picname = $row['photo_path'];
                                        $url = $row['poster_id'] . "/" . $picname;
                                    }
                                    else
                                    {
                                    
									    //      
									    if ($ext == "jpg") $source = imagecreatefromjpeg($_FILES[$field_name]['tmp_name'][$j]);
									    if ($ext == "gif") $source = imagecreatefromgif($_FILES[$field_name]['tmp_name'][$j]);
									    if ($ext == "png") $source = imagecreatefrompng($_FILES[$field_name]['tmp_name'][$j]);

									    if ($w >= $h)
									    {
										    $nw = $max_w;
										    $nh = $h * ($max_w / $w);

										    if ($nh > $max_h)
										    {
											    $nw = $max_w * ($max_h / $nh);
											    $nh = $max_h;
										    }
									    }

									    if ($w < $h)
									    {
										    $nw = $w * ($max_h / $h);
										    $nh = $max_h;

										    if ($nw > $max_w)
										    {
											    $nh = $max_h * ($max_w / $nw);
											    $nw = $max_w;
										    }

									    }

									    //   
									    $target = imagecreatetruecolor($nw, $nh);

									    //  
									    if ($ext == "png" || $ext == "gif")
									    {
										    imagealphablending($target, false);
										    imagesavealpha($target, true);
										    $transparent = imagecolorallocatealpha($target, 255, 255, 255, 127);
										    imagefilledrectangle($target, 0, 0, $nw, $nh, $transparent);
									    }
												
									    //        :
									    imagecopyresampled(
									        $target,
									        $source,
									        0,0,
									        0,0,
									        $nw,
									        $nh,
									        $w,
									        $h
									    );

									    if ($ext == "jpg") imagejpeg($target, $fname, 70);
									    if ($ext == "gif") imagegif($target, $fname);
									    if ($ext == "png") imagepng($target, $fname, 0);

									    imagedestroy($source);
									    imagedestroy($target);
									
								    } // not existd md5
								    
									$img_bbcode .= ($as_url?'[url=':'[img'.($right ? '=right' : '').']').($cfg['url'].$url).($as_url ? "]".$name."[/url]\n":"[/img]\n\n");

								} else {  //   
                                    $md5sum = md5(file_get_contents($_FILES[$field_name]['tmp_name'][$j]));
                                    $md5sum = md5($md5sum.'2');

                                    if ($row = $db->fetch_row("SELECT * FROM bb_photos WHERE photo_hash = '$md5sum'"))
                                    {
                                        $new_pic = 0;
                                        $picname = $row['photo_path'];
                                        $url = $row['poster_id'] . "/" . $picname;
                                    }
                                    else
                                    {
                                        move_uploaded_file($_FILES[$field_name]['tmp_name'][$j], $fname);
                                    }
 									$img_bbcode .= ($as_url?'[url=':'[img'.($right ? '=right' : '').']').($cfg['url'].$url).($as_url ? "]".$name."[/url]\n":"[/img]\n\n");

								}
							}
							// end of dj_maxx's resize
							else { //        
                                $md5sum = md5(file_get_contents($_FILES[$field_name]['tmp_name'][$j]));
                                $md5sum = md5($md5sum.'2');
                                
                                if ($row = $db->fetch_row("SELECT * FROM bb_photos WHERE photo_hash = '$md5sum'"))
                                {
                                    $new_pic = 0;
                                    $picname = $row['photo_path'];
                                    $url = $row['poster_id'] . "/" . $picname;
                                }
                                else
                                {
								    move_uploaded_file($_FILES[$field_name]['tmp_name'][$j], $fname);
                                }
								$img_bbcode .= ($as_url?'[url=':'[img'.($right ? '=right' : '').']').($cfg['url'].$url).($as_url ? "]".$name."[/url]\n":"[/img]\n\n");
							}
							
							// dj_maxx: write pic information to database
							if ($new_pic)
							{
							    $sql = "INSERT INTO bb_photos (poster_id, photo_date, photo_path, photo_hash, photo_desc)
						                    VALUES (" . $cfg['user_id'] . ", ".time().", '$picname', '$md5sum', '')";
							    if (!$db->sql_query($sql))
							    {
							        message_die(GENERAL_ERROR, 'Could not insert photo information', '', __LINE__, __FILE__, $sql);
							    }
							}
							//

							$has_images = 1;
						}
					}
				}
				$img_bbcode .= $after_value;
				if($has_images) $bbcode .= ($img_bbcode);
			}
		}

	return $bbcode;
}

function get_phpbb_code_form($cfg)
{
	global $bb_cfg, $phpbb_root_path, $phpEx;
	// dj_maxx: add UV-info mode
	global $uvinfo;
	// end of

	$forum_id = $cfg["forum_id"];
	$title = $cfg["title"];
	$fields = $cfg["fields"];

	$subject = isset($_REQUEST['subject']) ? $_REQUEST["subject"] : '';

	// dj_maxx: add normalize spaces to subject
	$subject = str_replace("\"", "&quot;", normalize_spaces($subject)/*$subject*/);
	// end of

	// dj_maxx: title autoformat
	if (isset($cfg["title_autoformat"]))
	{
		$do_autoformat = 1;
		$subject_new = str_replace("{}", $subject, $cfg["title_autoformat"]);
	
	} else
	{
		$subject_new = $subject;
	}
	// end of

	$f = isset($_REQUEST['f']) ? intval($_REQUEST["f"]) : 0;

	$before_value = isset($cfg["before_value"]) ? $cfg["before_value"] : "[font=\"Tahoma\"][size=20][b]";
	$after_value  = isset($cfg["after_value"])  ? $cfg["after_value"] : "[/b][/size][/font]\n\n";

	$in_group = false;
	$multiple_group = false;
	$bbcode = "";

	for($i = 0; $i < count($fields); ++$i) {
		$field_name = "f$i";
		$config = $fields[$i];

 		$group    = isset($config["group"]) ? ($config["group"] ? 1 : -1) : '';
		$name     = isset($config["name"]) ? $config["name"] : '';
		$multiple = isset($config["multiple"]) ? $config["multiple"] : '';
		$default  = isset($config["default"]) ? $config["default"] : '';
		$fields_separator  = isset($config["fields_separator"]) ? $config["fields_separator"] : ', ';

		// dj_maxx: add UV-info mode
		$uvinfo_only = isset($config["uvinfo_only"]) ? $config["uvinfo_only"] : 0;
		$not_for_uvinfo = isset($config["not_for_uvinfo"]) ? $config["not_for_uvinfo"] : 0;
		if (!$uvinfo && $uvinfo_only   ) continue;
		if ($uvinfo  && $not_for_uvinfo) continue;
		// end of

 		if( $group == 1 ) {
			$cnt = 1;

			if( $multiple ) {
				$multiple_group = true;
				$cnt = count( $_REQUEST[ 'f'.($i + 1) ] );
			} else {
				$multiple_group = false;
			}

			// dj_maxx: title autoformat
			$multifield_value = '';   //       multiple-
			// end of
			
			for ($k = 0; $k < $cnt; ++$k) {
				$config     = $fields[$i];
	
				$bbcode_string = ''; //  

				$bbcode_val = get_phpbb_code_field($config, $field_name, $value, 1, ($cnt > 1 ? ($k + 1) : 0));
				$bbcode_string .= $bbcode_val;
				$group_title = $bbcode_val;

				for ($j = $i + 1; $j < count($fields) && !isset($fields[$j]['group']); ++$j) {
					if( ($j != $i + 1) && (trim($bbcode_val)) ) $bbcode_string .= $fields_separator;
					$config     = $fields[$j];
			    	$field_name = "f$j";
					$value      = ( isset($_REQUEST[$field_name][$k]) && $_REQUEST[$field_name][$k] != '') ? $_REQUEST[$field_name][$k] : '';
					
					// dj_maxx: title autoformat
					if ($do_autoformat)
					{
				
						$value_text = is_array($value) ? $config['values'][$value[0] - 1] : $value;
						if (strpos($value_text,'|') !== false)
						{
							@list($visible_value, $post_value, $title_value) = @split('\|', $value_text);
							if ($title_value) { $value_text = $title_value; }
							elseif ($post_value) $value_text = $post_value;
						}
						
						//     multiple-,    
						if (preg_match("/{".$config['name']."}/", $subject_new))
						{
							if ($k == 0)
							{
								$multifield_value = $value_text;
							}
							else
							{
								$multifield_value .= ' + ' . $value_text;
							}
						}

						if ($k == $cnt-1)
						{
							$subject_new = str_replace("{".$config['name']."}", $multifield_value, $subject_new);
						}
					}
					// end of
					
					$bbcode_val = get_phpbb_code_field($config, $field_name, $value, 1, 0);
					$bbcode_string .= $bbcode_val;
				}
				if($k != $cnt - 1) $bbcode_string .= "\n";

				if ($bbcode_string != $group_title) $bbcode .= $bbcode_string;

			}
			$i = $j-1;
 	        $in_group = true;
 		} else if( $group == -1 ) {
			$bbcode .= get_phpbb_code_field($config, $field_name, $value, 1, 0);
 	        $in_group = false;
 		} else {
			$value   = ( isset($_REQUEST[$field_name]) && $_REQUEST[$field_name] != '') ? $_REQUEST[$field_name] : $default;
			// dj_maxx: title autoformat
			if ($do_autoformat)
			{
				if (is_array($value))
				{
					$value_text = ($value[0] > 0) ? $config['values'][$value[0] - 1] : '';
				}
				else
				{
					$value_text = $value;
				}
				

                if (strpos($value_text,'|') !== false)
	            {
                    @list($visible_value, $post_value, $title_value) = @split('\|', $value_text);
					if ($title_value) { $value_text = $title_value; }
					elseif ($post_value) $value_text = $post_value;
				}

				$subject_new = str_replace("{".$config['name']."}", $value_text, $subject_new);
			}
			// end of
			$bbcode .= get_phpbb_code_field($config, $field_name, $value, 0, 0);;
		}
	}
	// dj_maxx: add translation to title
	if (preg_match('/{}/', $subject_new))  //         (  uv_info)
	{
		$translation = ''; $add_plus = 0;
		
		if (preg_match('/(|(|)(|))/i', $bbcode))
		{
			$translation .= 'Dub';
			$add_plus = 1;
		}
		if (preg_match('/(|)/i', $bbcode))
		{
			$translation .= ($add_plus ? ' + ' : '') . 'MVO';
			$add_plus = 1;
		}
		if (preg_match('/(|)/i', $bbcode))
		{
			$translation .= ($add_plus ? ' + ' : '') . 'DVO';
			$add_plus = 1;
		}
		if (preg_match('/(|)/i', $bbcode))
		{
			$translation .= ($add_plus ? ' + ' : '') . 'VO';
			$add_plus = 1;
		}
		
		$subject_new = str_replace('{}', $translation, $subject_new);
	}
	// end of
	
	// dj_maxx: add torrent file field in wizard
	$torrent_uploaded = 0; $wizard_error_msg = '';
	$tmp_name = isset($_FILES['tf']['tmp_name']) ? $_FILES['tf']['tmp_name'] : '';
	if (is_uploaded_file($tmp_name))
	{
		require($phpbb_root_path .'attach_mod/posting_attachments.'. $phpEx);
		require($phpbb_root_path .'includes/functions_torrent.'. $phpEx);

		$mime_type = $_FILES['tf']['type'];
		//   
		if (pathinfo($_FILES['tf']['name'], PATHINFO_EXTENSION) == 'torrent')
		{
			$tor = bdecode_file($tmp_name);
			if (!empty($tor['info']))
			{
				$torrent_name = transliterate($_FILES['tf']['name']);

				$fn_prefix = make_rand_str(FILENAME_PREFIX_LENGTH) .'_';
				$file_name = 'files/' . $fn_prefix . $torrent_name;

				move_uploaded_file($tmp_name, $file_name);
		
				$attach_file_size = filesize($file_name);
				$attach_timestamp = TIMENOW;
		
				$torrent_uploaded = 1;
			}
			else
			{
				$wizard_error_msg = ",    ,   ,  -!";
				//die($wizard_error_msg);
			}
		}
		else
		{
			$wizard_error_msg = "      .torrent";
			//die($wizard_error_msg);
		}
	}
	// end of

?>
	<div style="height: 1px; overflow: hidden;">
	<form action="posting.php" method="post" name="post">
	<input type="hidden" name="mode" value="newtopic" />
	<input type="hidden" name="f" value="<?php echo($f); ?>" />
	<input type="hidden" name="preview" value=". " />
	<input type="hidden" name="wizard_error_msg" value="<?php echo($wizard_error_msg) ?>" />
<?php
	if ($torrent_uploaded)
	{
?>
	<input type="hidden" name="add_attachment_body" value="0" />
	<input type="hidden" name="posted_attachments_body" value="0" />
	<input type="hidden" name="attachment_list[]" value="<?php echo($file_name) ?>" />
	<input type="hidden" name="filename_list[]" value="<?php echo($torrent_name) ?>" />
	<input type="hidden" name="extension_list[]" value="torrent" />
	<input type="hidden" name="mimetype_list[]" value="application/x-bittorrent" />
	<input type="hidden" name="filesize_list[]" value="<?php echo($attach_file_size) ?>" />
	<input type="hidden" name="filetime_list[]" value="<?php echo($attach_timestamp) ?>" />
	<input type="hidden" name="attach_id_list[]" value="" />
	<input type="hidden" name="attach_thumbnailsnail_list[]" value="0" />
<?php
	}
?>
	
	<table width="100%" border="0" cellspacing="1" cellpadding="3" class="forumline">
	<tr>
		<th class="thHead" colspan="2" height="25"><b><?php echo($title); ?></b></th>
	</tr>
	<tr bgcolor="white">
		<td class="row1" align="right">:</td>
		<td class="row2"><input type="text" name="subject" size="60" maxlength="160" value="<?php echo($subject_new); ?>" /></td>
	</tr>
	<tr bgcolor="white">
	<td class="row1" align="right">:</td><td class="row2"><textarea name="message" cols="80" rows="15">
	<?php echo($before_value.$subject.$after_value); ?>
<?php

	echo($bbcode);

?>
	</textarea>
	</td></tr>
	<tr><td class="row2" colspan="2" align="center">
	</td></tr>
	</table>
	</td></tr></table>
	</form>
	</div>
	<script>
	document.forms['post'].submit();
	</script>
	<br />

<?php
}

function is_form_valid($cfg)
{
	return 1;
}



?>
