<?php
/**
*
* @package sitemap_fx 1.0.5
* @version $Id: sitemap.php 9048 2009-08-17 20:46:42Z FladeX $
* @copyright (c) 2005 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/

define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/functions_sitemap_fx.' . $phpEx);

$sitemap_config['sitemap_enable'] = true;
$sitemap_config['sitemap_cache_time'] = 96;
$sitemap_config['sitemap_priority_0'] = '0.5';
$sitemap_config['sitemap_priority_1'] = '0.5';
$sitemap_config['sitemap_priority_2'] = '0.5';
$sitemap_config['sitemap_priority_3'] = '0.5';
$sitemap_config['sitemap_freq_0'] = 'daily';
$sitemap_config['sitemap_freq_1'] = 'daily';
$sitemap_config['sitemap_freq_2'] = 'daily';
$sitemap_config['sitemap_freq_3'] = 'daily';

$sitemap_config['posts_per_page'] = $bb_cfg['posts_per_page'];

if (!$sitemap_config['sitemap_enable'])
{
	exit;
}

// avoid usage of f$#king make_url which is web server dependant
$domain = ($bb_cfg['server_name_mirror'] != $bb_cfg['http_host']) ? $bb_cfg['sitename'] : $bb_cfg['server_name_mirror'];
$url = 'https://' . $domain . $bb_cfg['script_path'];

$last_forum_id = 0;

// Start session management
$user->session_start();

header("Content-Type: text/xml");

// dj_maxx: add guest forbidden forums filter
$forums = $datastore->get('cat_forums');
$forbidden_forums = $forums['not_auth_forums']['guest_read'];
// end of

//if (!$sitemap_index_file = $bb_cache->get($domain."_sitemap_fx_index"))
//{
	$sitemap_index_file = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
	$sitemap_index_file .= "<sitemapindex xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\">\n";

	sitemap_fx_global((int) $last_forum_id);
	$sitemap_index_file .= "<sitemap>\n";
	$sitemap_index_file .= "<loc>" . $url . "sitemap/0.xml</loc>\n";
	$sitemap_index_file .= "<lastmod>" . date('Y-m-d\TH:i:s+00:00', time()) . "</lastmod>\n";
	$sitemap_index_file .= "</sitemap>\n";
	
	$sql = 'SELECT forum_id, forum_topics'.//, auth_view
		'	FROM ' . FORUMS_TABLE . ' WHERE forum_id NOT IN ('.$forbidden_forums.')';
	$result = $db->sql_query($sql);

	while ($row = $db->sql_fetchrow($result))
	{
		if ($row['forum_id'] && /*($row['auth_view'] == 1) &&*/ ($row['forum_topics'] > 0))
		{
			sitemap_fx_forum((int) $row['forum_id']);

			$sitemap_index_file .= "<sitemap>\n";
			$sitemap_index_file .= "<loc>" . $url . "sitemap/" . $row['forum_id'] . ".xml</loc>\n";
			$sitemap_index_file .= "<lastmod>" . date('Y-m-d\TH:i:s+00:00', time()) . "</lastmod>\n";
			$sitemap_index_file .= "</sitemap>\n";

			$last_forum_id = $row['forum_id'];
		}
	}
	$db->sql_freeresult($result);

	$sitemap_index_file .= "</sitemapindex>\n";
//	$bb_cache->set($domain."_sitemap_fx_index", $sitemap_index_file, (3600 * $sitemap_config['sitemap_cache_time']));
//}

print $sitemap_index_file;

?>