<?php

define('BB_ROOT', './');
$phpEx = substr(strrchr(__FILE__, '.'), 1);
require('./common.'.$phpEx);
require_once(INC_DIR .'functions_torrent.'. $phpEx);
require_once(BB_ROOT .'attach_mod/attachment_mod.'. $phpEx);

if (!$attach_id = (int) @$_POST['a'])
{
	die('  ');
}

$user->session_start();
$torrent = get_torrent_info($attach_id);
$file_path = $phpbb_root_path . $attach_config['upload_dir'] .'/'. $torrent['physical_filename'];

if (($file_contents = @file_get_contents($file_path)) === false)
{
	die('   : '. htmlCHR($file_path));
}

$tor_filelist = build_tor_filelist($file_contents);
die(utf8_to_win($tor_filelist));


function build_tor_filelist ($file_contents)
{
	if (!$tor = bdecode($file_contents))
	{
		return ' torrent ';
	}

	$torrent = new torrent($tor);

	return $torrent->get_filelist();
}

class torrent
{
	var $tor_decoded = array();
	var $files_ary   = array('/' => '');
	var $multiple    = null;
	var $root_dir    = '';
	var $files_html  = '';

	function torrent ($decoded_file_contents)
	{
		$this->tor_decoded = $decoded_file_contents;
	}

	function get_filelist ()
	{
		$this->build_filelist_array();

		if ($this->multiple)
		{
			if ($this->files_ary['/'] !== '')
			{
				$this->files_ary = array_merge($this->files_ary, $this->files_ary['/']);
				unset($this->files_ary['/']);
			}
			$filelist = $this->build_filelist_html();
			return "<div class=\"tor-root-dir\">{$this->root_dir}</div>$filelist";
		}
		else
		{
			return join('', $this->files_ary['/']);
		}
	}

	function build_filelist_array ()
	{
		$info = $this->tor_decoded['info'];

		if (isset($info['name.utf-8']))
		{
			$info['name'] =& $info['name.utf-8'];
		}

		if (isset($info['files']) && is_array($info['files']))
		{
			$this->root_dir = isset($info['name']) ? '../'. clean_tor_dirname($info['name']) : '...';
			$this->multiple = true;

			foreach ($info['files'] as $f)
			{
				if (isset($f['path.utf-8']))
				{
					$f['path'] =& $f['path.utf-8'];
				}
				if (!isset($f['path']) || !is_array($f['path']))
				{
					continue;
				}

				array_deep($f['path'], 'clean_tor_dirname');

				$length = isset($f['length']) ? $f['length'] : 0;
				$subdir_count = count($f['path']) - 1;

				if ($subdir_count > 0)
				{
					$name = array_pop($f['path']);
					$cur_files_ary =& $this->files_ary;

					for ($i = 0, $j = 1; $i < $subdir_count; $i++, $j++)
					{
						$subdir = $f['path'][$i];

						if (!isset($cur_files_ary[$subdir]))
						{
							$cur_files_ary[$subdir] = array();
						}
						$cur_files_ary =& $cur_files_ary[$subdir];

						if ($j == $subdir_count)
						{
							if (is_string($cur_files_ary))
							{
								die('Error: cannot build filelist [string]');
							}
							$cur_files_ary[] = $this->build_file_item($name, $length);
						}
					}
				}
				else
				{
					$name = $f['path'][0];
					$this->files_ary['/'][] = $this->build_file_item($name, $length);
				}
			}
		}
		else
		{
			$this->multiple = false;
			$name = isset($info['name']) ? clean_tor_dirname($info['name']) : '';
			$length = isset($info['length']) ? $info['length'] : 0;

			$this->files_ary['/'][] = $this->build_file_item($name, $length);
		}
	}


	function build_file_item ($name, $length)
	{
		return "$name <i>($length)</i>";
	}


	function build_filelist_html ()
	{
		global $html;
		return $html->array2html($this->files_ary);
	}
}

function clean_tor_dirname ($dirname)
{
	return str_replace(array('[', ']', '<', '>', "'"), array('&#91;', '&#93;', '&lt;', '&gt;', '&#039;'), $dirname);
}

function utf8_to_win($string)
{
	for ($c = 0; $c < strlen($string); $c++)
	{
		$i = ord($string[$c]);
		if ($i <= 127) @$out .= $string[$c];
		if (@$byte2)
		{
			$new_c2 = ($c1 & 3)*64+($i & 63);
			$new_c1 = ($c1 >> 2) & 5;
			$new_i = $new_c1*256 + $new_c2;

			if ($new_i == 1025)
			{
				$out_i = 168;
			} 
			else
			{
				if ($new_i==1105)
				{
					$out_i = 184;
				} 
				else 
				{
					$out_i = $new_i - 848;
				}
			}

			@$out .= chr($out_i);
			$byte2 = false;
		}

		if (($i >> 5) == 6)
		{
			$c1 = $i;
			$byte2 = true;
		}
	}

	return $out;
}