<?php

define('BB_SCRIPT', 'topic');
require('./common.php');
require(INC_DIR .'bbcode.'. PHP_EXT);

$datastore->enqueue(array(
	'ranks',
));

$page_cfg['load_tpl_vars'] = array(
	'post_buttons',
	'post_icons',
	'topic_icons',
);

$newest = $next_topic_id = 0;
$start  = isset($_GET['start']) ? abs(intval($_GET['start'])) : 0;
$topic_id = isset($_GET[POST_TOPIC_URL]) ? (int) $_GET[POST_TOPIC_URL] : 0;
$post_id  = (!$topic_id && isset($_GET[POST_POST_URL])) ? (int) $_GET[POST_POST_URL] : 0;
$porno_forums = array_flip(explode(',', $bb_cfg['porno_forums']));

// dj_maxx: remove unnecessary links in topic view
$clickable_topic_title = $topic_id ? 0 : 1;
// end of

// Start session
$user->session_start();

// Posts per page
$posts_per_page = $bb_cfg['posts_per_page'];
$select_ppp = '';

if ($userdata['session_admin'])
{
	if ($req_ppp = abs(intval(@$_REQUEST['ppp'])) AND in_array($req_ppp, $bb_cfg['allowed_posts_per_page']))
	{
		$posts_per_page = $req_ppp;
	}

	$select_ppp = array();
	foreach ($bb_cfg['allowed_posts_per_page'] as $ppp)
	{
		$select_ppp[$ppp] = $ppp;
	}
}

if (isset($_REQUEST['single']))
{
	$posts_per_page = 1;
}
else
{
	$start = floor($start/$posts_per_page) * $posts_per_page;
}

if (!$topic_id && !$post_id)
{
	header('HTTP/1.x 404 Not Found');
	bb_die($lang['Topic_post_not_exist']);
}

$tracking_topics = get_tracks('topic');
$tracking_forums = get_tracks('forum');

// Find topic id if user requested a newer or older topic
if ($topic_id && isset($_GET['view']) && ($_GET['view'] == 'next' || $_GET['view'] == 'previous'))
{
	$sql_condition = ($_GET['view'] == 'next') ? '>' : '<';
	$sql_ordering = ($_GET['view'] == 'next') ? 'ASC' : 'DESC';

	$sql = "SELECT t.topic_id
		FROM ". TOPICS_TABLE ." t, ". TOPICS_TABLE ." t2
		WHERE t2.topic_id = $topic_id
			AND t.forum_id = t2.forum_id
			AND t.topic_moved_id = 0
			AND t.topic_last_post_id $sql_condition t2.topic_last_post_id
		ORDER BY t.topic_last_post_id $sql_ordering
		LIMIT 1";

	if ($row = $db->fetch_row($sql))
	{
		$next_topic_id = $topic_id = $row['topic_id'];
	}
	else
	{
		$message = ($_GET['view'] == 'next') ? $lang['No_newer_topics'] : $lang['No_older_topics'];
		bb_die($message);
	}
}

// Get forum/topic data
if ($topic_id)
{
	$sql = "SELECT t.*, f.*
		FROM ". TOPICS_TABLE ." t, ". FORUMS_TABLE ." f
		WHERE t.topic_id = $topic_id
			AND f.forum_id = t.forum_id
		LIMIT 1";
}
else if ($post_id)
{
	$sql = "SELECT t.*, f.*, p.post_time
		FROM ". TOPICS_TABLE ." t, ". FORUMS_TABLE ." f, ". POSTS_TABLE ." p
		WHERE p.post_id = $post_id
			AND t.topic_id = p.topic_id
			AND f.forum_id = t.forum_id
		LIMIT 1";
}
else
{
	header('HTTP/1.x 404 Not Found');
	bb_die($lang['Topic_post_not_exist']);
}

if (!$t_data = $db->fetch_row($sql))
{
	header('HTTP/1.x 404 Not Found');
	bb_die($lang['Topic_post_not_exist']);
}

$forum_topic_data =& $t_data;
$topic_id = $t_data['topic_id'];
$forum_id = $t_data['forum_id'];

if ($userdata['session_admin'] && !empty($_REQUEST['mod']))
{
	if (IS_ADMIN)
	{
		$datastore->enqueue(array('viewtopic_forum_select'));
	}
}
if ($t_data['topic_attachment'])
{
	$datastore->enqueue(array(
		'attach_extensions',
	));
}

// Find newest post
if (($next_topic_id || @$_GET['view'] === 'newest') && !IS_GUEST && $topic_id)
{
	$post_time = 'post_time >= '. get_last_read($topic_id, $forum_id);
	$post_id_altern = ($next_topic_id) ? '' : ' OR post_id = '. $t_data['topic_last_post_id'];

	$sql = "SELECT post_id, post_time
		FROM ". POSTS_TABLE ."
		WHERE topic_id = $topic_id
			AND ($post_time $post_id_altern)
		ORDER BY post_time ASC
		LIMIT 1";

	if ($row = $db->fetch_row($sql))
	{
		$post_id = $newest = $row['post_id'];
		$t_data['post_time'] = $row['post_time'];
	}
}

if ($post_id && !empty($t_data['post_time']) && ($t_data['topic_replies'] + 1) > $posts_per_page)
{
	$sql = "SELECT COUNT(post_id) AS prev_posts
		FROM ". POSTS_TABLE ."
		WHERE topic_id = $topic_id
			AND post_time <= {$t_data['post_time']}";

	if ($row = $db->fetch_row($sql))
	{
		$t_data['prev_posts'] = $row['prev_posts'];
	}
}

// Auth check
$is_auth = auth(AUTH_ALL, $forum_id, $userdata, $t_data);

// dj_maxx: add motherfucking 1C avoid
//if ($bb_cfg['http_host'] == $bb_cfg['sitename']) { // if came from ME
//
//	if (in_array($forum_id, array(1105, 1106, 1107, 1108, 1109)))
//	{
//		bb_die(",       !    underverse.<b>SU</b>  underverse.<b>ME</b>");
//	}
//}
// end of

if (!$is_auth['auth_read'])
{
	if (IS_GUEST)
	{
		$redirect = ($post_id) ? POST_POST_URL . "=$post_id" : POST_TOPIC_URL . "=$topic_id";
		$redirect .= ($start) ? "&start=$start" : '';
		redirect("login.$phpEx?redirect=viewtopic.$phpEx&$redirect");
	}
	header('HTTP/1.x 404 Not Found');
	bb_die($lang['Topic_post_not_exist']);
}


$forums = $datastore->get('cat_forums');

$forum_name  = $t_data['forum_name'];
$topic_title = $t_data['topic_title'];
$topic_id    = $t_data['topic_id'];
$topic_time  = $t_data['topic_time'];
// dj_maxx: add topic color
$topic_color = $t_data['topic_color'];
// end of

$moderation = (!empty($_REQUEST['mod']) && $is_auth['auth_mod']);

// Redirect to login page if not admin session
$mod_redirect_url = '';

if ($is_auth['auth_mod'])
{
	$redirect = isset($_POST['redirect']) ? $_POST['redirect'] : $_SERVER['REQUEST_URI'];
	$redirect = url_arg($redirect, 'mod', 1, '&');
	$mod_redirect_url = "login.$phpEx?redirect=$redirect&admin=1";

	if ($moderation && !$userdata['session_admin'])
	{
		redirect($mod_redirect_url);
	}
}

if ($moderation)
{
	if (IS_ADMIN)
	{
		$forum_select = $datastore->get('viewtopic_forum_select');
		$forum_select_html = $forum_select['viewtopic_forum_select'];
	}
	else
	{
		$not_auth_forums_csv = $user->get_not_auth_forums(AUTH_VIEW);
		$forum_select_html = get_forum_select(explode(',', $not_auth_forums_csv), 'new_forum_id');
	}
	$template->assign_vars(array(
		'S_FORUM_SELECT' => $forum_select_html,
	));
}

if ($parent_id = $t_data['forum_parent'])
{
	$template->assign_vars(array(
		'HAS_PARENT_FORUM'  => true,
		'PARENT_FORUM_HREF'	=> FORUM_URL . $parent_id,
// dj_maxx: workaround for supporting html tags in forum name and description
		//'PARENT_FORUM_NAME' => htmlCHR($forums['f'][$parent_id]['forum_name']),
		'PARENT_FORUM_NAME' => strip_tags($forums['f'][$parent_id]['forum_name']),
// end of
	));
}


if ($post_id && !empty($t_data['prev_posts']))
{
	$start = floor(($t_data['prev_posts'] - 1) / $posts_per_page) * $posts_per_page;
}

//
// Is user watching this thread?
//

$url_topic = "viewtopic.$phpEx?t=$topic_id&amp;start=$start";
$can_watch_topic = $is_watching_topic = false;
if ($bb_cfg['topic_notify_enabled'])
{
	if( $userdata['session_logged_in'] )
	{
		$can_watch_topic = true;

		$sql = "SELECT SQL_CACHE notify_status
			FROM ". TOPICS_WATCH_TABLE ."
			WHERE topic_id = $topic_id
				AND user_id = " . $userdata['user_id'];

		if ($row = $db->fetch_row($sql))
		{
			if ( isset($HTTP_GET_VARS['unwatch']) )
			{
				if ( $HTTP_GET_VARS['unwatch'] == 'topic' )
				{
					$is_watching_topic = 0;

					$sql = "DELETE FROM " . TOPICS_WATCH_TABLE . "
						WHERE topic_id = $topic_id
							AND user_id = " . $userdata['user_id'];
					if ( !($result = $db->sql_query($sql)) )
					{
						message_die(GENERAL_ERROR, "Could not delete topic watch information", '', __LINE__, __FILE__, $sql);
					}
				}

                		meta_refresh($url_topic);
				$message = $lang['No_longer_watching'] . '<br /><br />' . sprintf($lang['Click_return_topic'], '<a href="'. $url_topic .'">', '</a>');
				bb_die($message);
			}
			else
			{
				$is_watching_topic = TRUE;

				if ( $row['notify_status'] )
				{
					$sql = "UPDATE " . TOPICS_WATCH_TABLE . "
						SET notify_status = 0
						WHERE topic_id = $topic_id
							AND user_id = " . $userdata['user_id'];
					if ( !($result = $db->sql_query($sql)) )
					{
						message_die(GENERAL_ERROR, "Could not update topic watch information", '', __LINE__, __FILE__, $sql);
					}
				}
			}
		}
		else
		{
			if ( isset($HTTP_GET_VARS['watch']) )
			{
				if ( $HTTP_GET_VARS['watch'] == 'topic' )
				{
					$is_watching_topic = TRUE;

					$sql = "INSERT INTO " . TOPICS_WATCH_TABLE . " (user_id, topic_id, notify_status)
						VALUES (" . $userdata['user_id'] . ", $topic_id, 0)";
					if ( !($result = $db->sql_query($sql)) )
					{
						message_die(GENERAL_ERROR, "Could not insert topic watch information", '', __LINE__, __FILE__, $sql);
					}
				}

                		meta_refresh($url_topic);
				$message = $lang['You_are_watching'] . '<br /><br />' . sprintf($lang['Click_return_topic'], '<a href="'. $url_topic .'">', '</a>');
				bb_die($message);
			}
			else
			{
				$is_watching_topic = 0;
			}
		}
	}
	else
	{
		if ( isset($HTTP_GET_VARS['unwatch']) )
		{
			if ( $HTTP_GET_VARS['unwatch'] == 'topic' )
			{
				redirect("login.$phpEx?redirect=viewtopic.$phpEx&t=$topic_id&unwatch=topic");
			}
		}
	}
}

$can_bookmark_topic = $is_bookmark_topic = false;
if ($bb_cfg['topic_bookmark_enabled'])
{
	if( $userdata['session_logged_in'] )
	{
		$can_bookmark_topic = true;

		$sql = "SELECT SQL_CACHE bookmark_status
			FROM ". TOPICS_BOOKMARK_TABLE ."
			WHERE topic_id = $topic_id
				AND user_id = ". $userdata['user_id'];

		if ($row = $db->fetch_row($sql))
		{
			if ( isset($HTTP_GET_VARS['unbookmark']) )
			{
				if ( $HTTP_GET_VARS['unbookmark'] == 'topic' )
				{
					$is_bookmark_topic = 0;

					$sql = "DELETE FROM ". TOPICS_BOOKMARK_TABLE ."
						WHERE topic_id = $topic_id
							AND user_id = ". $userdata['user_id'];
					if ( !($result = $db->sql_query($sql)) )
					{
						message_die(GENERAL_ERROR, "Could not delete topic watch information", '', __LINE__, __FILE__, $sql);
					}
				}

                		meta_refresh($url_topic);
				$message = $lang['Bookmark_removed'] . '<br /><br />' . sprintf($lang['Click_return_topic'], '<a href="'. $url_topic .'">', '</a>');
				bb_die($message);
			}
			else
			{
				$is_bookmark_topic = true;

				if ( $row['bookmark_status'] )
				{
					$sql = "UPDATE ". TOPICS_BOOKMARK_TABLE ."
						SET bookmark_status = 0
						WHERE topic_id = $topic_id
							AND user_id = " . $userdata['user_id'];
					if ( !($result = $db->sql_query($sql)) )
					{
						message_die(GENERAL_ERROR, "Could not update topic bookmark information", '', __LINE__, __FILE__, $sql);
					}
				}
			}
		}
		else
		{
			if ( isset($HTTP_GET_VARS['bookmark']) )
			{
				if ( $HTTP_GET_VARS['bookmark'] == 'topic' )
				{
					$is_bookmark_topic = true;

					$sql = "INSERT INTO ". TOPICS_BOOKMARK_TABLE ." (user_id, topic_id, bookmark_status)
						VALUES (" . $userdata['user_id'] . ", $topic_id, 0)";
					if ( !($result = $db->sql_query($sql)) )
					{
						message_die(GENERAL_ERROR, "Could not insert topic bookmark information", '', __LINE__, __FILE__, $sql);
					}
				}

                		meta_refresh($url_topic);
				$message = $lang['Bookmark_added'] . '<br /><br />' . sprintf($lang['Click_return_topic'], '<a href="'. $url_topic .'">', '</a>');
				bb_die($message);
			}
			else
			{
				$is_bookmark_topic = 0;
			}
		}
	}
	else
	{
		if ( isset($HTTP_GET_VARS['unbookmark']) )
		{
			if ( $HTTP_GET_VARS['unbookmark'] == 'topic' )
			{
				redirect("login.$phpEx?redirect=viewtopic.$phpEx&t=$topic_id&unbookmark=topic");
			}
		}
	}
}



// Generate a 'Show posts in previous x days' select box. If the postdays var is POSTed
// then get it's value, find the number of topics with dates newer than it (to properly
// handle pagination) and alter the main query
$post_days = 0;
$limit_posts_time = '';
$total_replies = $t_data['topic_replies'] + 1;

if (!empty($_REQUEST['postdays']))
{
	if ($post_days = abs(intval($_REQUEST['postdays'])))
	{
		if (!empty($_POST['postdays']))
		{
			$start = 0;
		}
		$min_post_time = TIMENOW - ($post_days*86400);

		$sql = "SELECT COUNT(p.post_id) AS num_posts
			FROM " . TOPICS_TABLE . " t, " . POSTS_TABLE . " p
			WHERE t.topic_id = $topic_id
				AND p.topic_id = t.topic_id
				AND p.post_time > $min_post_time";

		$total_replies = ($row = $db->fetch_row($sql)) ? $row['num_posts'] : 0;
		$limit_posts_time = "AND p.post_time >= $min_post_time ";
	}
}

// Decide how to order the post display
$post_order = (isset($_POST['postorder']) && $_POST['postorder'] !== 'asc') ? 'desc' : 'asc';

//
// Go ahead and pull all data for this topic (dj_maxx: added some fields, e.g. user_awards, user_rank_2)
//
$sql = "
	SELECT
	  u.username, u.user_id, u.user_session_time, u.user_allow_viewonline, u.user_posts, u.user_from, u.user_from_flag, u.user_level,
	  u.user_regdate, u.user_rank, u.user_rank_2, u.user_sig, u.user_sig_bbcode_uid,
	  u.user_avatar, u.user_avatar_type, u.user_allowavatar, u.user_gender, u.user_awards,
	  u.user_birthday, u.user_next_birthday_greeting, u.user_vip, u.user_releaser, u.user_half_dl, u.user_reputation, u.user_warnings, u.user_bans, u.user_coolness, p.*,
	  h.post_html, IF(h.post_html IS NULL, pt.post_text, NULL) AS post_text,
	  pt.post_subject, pt.bbcode_uid, bt.u_up_total, bt.u_down_total, bt.u_up_release, bt.u_up_bonus, bt.user_bonus
	FROM      ". POSTS_TABLE      ." p
	LEFT JOIN ". USERS_TABLE      ." u  ON(u.user_id = p.poster_id)
	LEFT JOIN ". POSTS_TEXT_TABLE ." pt ON(pt.post_id = p.post_id)
	LEFT JOIN ". POSTS_HTML_TABLE ." h  ON(h.post_id = p.post_id)
	LEFT JOIN ". BT_USERS_TABLE   ." bt ON(p.poster_id = bt.user_id)
	WHERE
	    p.topic_id = $topic_id
	  $limit_posts_time
	GROUP BY
	  p.post_id
	ORDER BY
	  p.post_time
	  $post_order
	LIMIT
	  $start, $posts_per_page
";

if ($postrow = $db->fetch_rowset($sql))
{
	$total_posts = count($postrow);
}
else
{
   bb_die($lang['No_posts_topic']);
}

$ranks = $datastore->get('ranks');

//
// Define censored word matches
//
$orig_word = array();
$replacement_word = array();
obtain_word_list($orig_word, $replacement_word);

//
// Censor topic title
//
if ( count($orig_word) )
{
	$topic_title = preg_replace($orig_word, $replacement_word, $topic_title);
}

//
// Post, reply and other URL generation for
// templating vars
//
$new_topic_url = "posting.$phpEx?mode=newtopic&amp;f=$forum_id";
$new_topic_url .= ($t_data['topic_tpl_id']) ? '&tpl=1' : '';
$reply_topic_url = "posting.$phpEx?mode=reply&amp;t=$topic_id";
$view_forum_url = "viewforum.$phpEx?f=$forum_id";
$view_prev_topic_url = "viewtopic.$phpEx?t=$topic_id&amp;view=previous#newest";
$view_next_topic_url = "viewtopic.$phpEx?t=$topic_id&amp;view=next#newest";

$reply_img = ( $t_data['forum_status'] == FORUM_LOCKED || $t_data['topic_status'] == TOPIC_LOCKED ) ? $images['reply_locked'] : $images['reply_new'];
$reply_alt = ( $t_data['forum_status'] == FORUM_LOCKED || $t_data['topic_status'] == TOPIC_LOCKED ) ? $lang['Topic_locked_short'] : $lang['Reply_to_topic'];

// Set 'body' template for attach_mod
$template->set_filenames(array('body' => 'viewtopic.tpl'));

//
// User authorisation levels output
//
$s_auth_can = ( ( $is_auth['auth_post'] ) ? $lang['Rules_post_can'] : $lang['Rules_post_cannot'] ) . '<br />';
$s_auth_can .= ( ( $is_auth['auth_reply'] ) ? $lang['Rules_reply_can'] : $lang['Rules_reply_cannot'] ) . '<br />';
$s_auth_can .= ( ( $is_auth['auth_edit'] ) ? $lang['Rules_edit_can'] : $lang['Rules_edit_cannot'] ) . '<br />';
$s_auth_can .= ( ( $is_auth['auth_delete'] ) ? $lang['Rules_delete_can'] : $lang['Rules_delete_cannot'] ) . '<br />';
$s_auth_can .= ( ( $is_auth['auth_vote'] ) ? $lang['Rules_vote_can'] : $lang['Rules_vote_cannot'] ) . '<br />';
$s_auth_can .= ( ($is_auth['auth_attachments'] ) ? $lang['Rules_attach_can'] : $lang['Rules_attach_cannot'] ) . '<br />';
$s_auth_can .= ( ($is_auth['auth_download'] ) ? $lang['Rules_download_can'] : $lang['Rules_download_cannot'] ) . '<br />';

$topic_mod = '';

if ( $is_auth['auth_mod'] )
{
	$s_auth_can .= $lang['Rules_moderate'];

	$topic_mod .= "<a href=\"modcp.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;mode=delete&amp;sid=" . $userdata['session_id'] . '"><img src="' . $images['topic_mod_delete'] . '" alt="' . $lang['DELETE_TOPIC'] . '" title="' . $lang['DELETE_TOPIC'] . '" border="0" /></a>&nbsp;';

	$topic_mod .= "<a href=\"modcp.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;mode=move&amp;sid=" . $userdata['session_id'] . '"><img src="' . $images['topic_mod_move'] . '" alt="' . $lang['MOVE_TOPIC'] . '" title="' . $lang['MOVE_TOPIC'] . '" border="0" /></a>&nbsp;';

	$topic_mod .= ( $t_data['topic_status'] == TOPIC_UNLOCKED ) ? "<a href=\"modcp.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;mode=lock&amp;sid=" . $userdata['session_id'] . '"><img src="' . $images['topic_mod_lock'] . '" alt="' . $lang['LOCK_TOPIC'] . '" title="' . $lang['LOCK_TOPIC'] . '" border="0" /></a>&nbsp;' : "<a href=\"modcp.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;mode=unlock&amp;sid=" . $userdata['session_id'] . '"><img src="' . $images['topic_mod_unlock'] . '" alt="' . $lang['UNLOCK_TOPIC'] . '" title="' . $lang['UNLOCK_TOPIC'] . '" border="0" /></a>&nbsp;';

	$topic_mod .= "<a href=\"modcp.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;mode=split&amp;sid=" . $userdata['session_id'] . '"><img src="' . $images['topic_mod_split'] . '" alt="' . $lang['SPLIT_TOPIC'] . '" title="' . $lang['SPLIT_TOPIC'] . '" border="0" /></a>&nbsp;';
	//bt
	if ($t_data['allow_dl_topic'] || $t_data['topic_dl_type'] == TOPIC_DL_TYPE_DL || IS_ADMIN)
	{
		if ($t_data['topic_dl_type'] == TOPIC_DL_TYPE_DL)
		{
			$topic_mod .= "<a href=\"modcp.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;mode=unset_download&amp;sid=" . $userdata['session_id'] . '"><img src="' . $images['topic_normal'] . '" alt="' . $lang['Unset_DL_Status'] . '" title="' . $lang['Unset_DL_Status'] . '" border="0" /></a>';
		}
		else
		{
			$topic_mod .= "<a href=\"modcp.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;mode=set_download&amp;sid=" . $userdata['session_id'] . '"><img src="' . $images['topic_dl'] . '" alt="' . $lang['Set_DL_Status'] . '" title="' . $lang['Set_DL_Status'] . '" border="0" /></a>';
		}
	}
	//bt end
}
//bt
else if (($t_data['topic_poster'] == $userdata['user_id']) && $userdata['session_logged_in'] && $t_data['self_moderated'])
{
	$topic_mod .= "<a href=\"modcp.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;mode=move&amp;sid=" . $userdata['session_id'] . '"><img src="' . $images['topic_mod_move'] . '" alt="' . $lang['MOVE_TOPIC'] . '" title="' . $lang['MOVE_TOPIC'] . '" border="0" /></a>&nbsp;';
}
//bt end

// Report
//
// Get report topic module and create report link
//
require_once($phpbb_root_path . "includes/functions_report.$phpEx");
$report_topic = report_modules('name', 'report_topic');

if ($report_topic && $report_topic->auth_check('auth_write'))
{
	if ($forum_topic_data['topic_reported'])
	{
		$report_auth = ($userdata['user_level'] == ADMIN || (!$bb_cfg['report_list_admin'] && (!$bb_cfg['report_subject_auth'] || $is_auth['auth_mod'])));
		if ($report_topic->auth_check('auth_view') && $is_auth)
		{
			$target = ($bb_cfg['report_new_window']) ? ' target="_blank"' : '';
			$s_report_topic ='&nbsp;<a href="' . append_sid("report.$phpEx?mode=reported&amp;" . POST_CAT_URL . '=' . $report_topic->id . "&amp;id=$topic_id") . '"' . $target . '><img src="' . $images['topic_mod_reported'] . '" alt="' . $report_topic->lang['Duplicate_report'] . '" title="' . $report_topic->lang['Duplicate_report'] . '" border="0" /></a>&nbsp;';
		}
		else
		{
			$s_report_topic = '&nbsp;<img src="' . $images['topic_mod_reported'] . '" alt="' . $report_topic->lang['Duplicate_report'] . '" title="' . $report_topic->lang['Duplicate_report'] . '" border="0" />&nbsp;';
		}
	}
	else
	{
		$s_report_topic = '&nbsp;<a href="' . append_sid("report.$phpEx?mode=" . $report_topic->mode . "&amp;id=$topic_id") . '"><img src="' . $images['topic_mod_report'] . '" alt="' . $report_topic->lang['Write_report'] . '" title="' . $report_topic->lang['Write_report'] . '" border="0" /></a>&nbsp;';
	}
	
	$topic_mod .= $s_report_topic;
	$template->assign_var('S_REPORT_TOPIC', $s_report_topic);
}
// Report [END]

//
// Topic watch information
//

$s_watching_topic = $s_watching_topic_img = '';
if ( $can_watch_topic )
{
	if ( $is_watching_topic )
	{
		$s_watching_topic = "<a class=\"gensmall bold\" href=\"viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;unwatch=topic&amp;start=$start&amp;sid=" . $userdata['session_id'] . '">' . $lang['Stop_watching_topic'] . '</a>';
		$s_watching_topic_img = ( isset($images['topic_un_watch']) ) ? "<a href=\"viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;unwatch=topic&amp;start=$start&amp;sid=" . $userdata['session_id'] . '"><img src="' . $images['topic_un_watch'] . '" alt="' . $lang['Stop_watching_topic'] . '" title="' . $lang['Stop_watching_topic'] . '" border="0"></a>' : '';
	}
	else
	{
		$s_watching_topic = "<a class=\"gensmall\" href=\"viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;watch=topic&amp;start=$start&amp;sid=" . $userdata['session_id'] . '">' . $lang['Start_watching_topic'] . '</a>';
		$s_watching_topic_img = ( isset($images['Topic_watch']) ) ? "<a href=\"viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;watch=topic&amp;start=$start&amp;sid=" . $userdata['session_id'] . '"><img src="' . $images['Topic_watch'] . '" alt="' . $lang['Start_watching_topic'] . '" title="' . $lang['Start_watching_topic'] . '" border="0"></a>' : '';
	}
}

// Topic bookmark information
$s_bookmark_topic = '';
if ( $can_watch_topic )
{
	if ( $is_bookmark_topic )
	{
		$s_bookmark_topic = "<a class=\"gensmall bold\" href=\"viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;unbookmark=topic&amp;start=$start&amp;sid=" . $userdata['session_id'] . '">' . $lang['Stop_bookmark_topic'] . '</a>';
	}
	else
	{
		$s_bookmark_topic = "<a class=\"gensmall bold\" href=\"viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;bookmark=topic&amp;start=$start&amp;sid=" . $userdata['session_id'] . '">' . $lang['Start_bookmark_topic'] . '</a>';
	}
}


// If we've got a hightlight set pass it on to pagination,
$pg_url = TOPIC_URL . $topic_id;
$pg_url .= ($post_days) ? "&amp;postdays=$post_days" : '';
$pg_url .= ($post_order != 'asc') ? "&amp;postorder=$post_order" : '';
$pg_url .= isset($_REQUEST['single']) ? "&amp;single=1" : '';
$pg_url .= ($moderation) ? "&amp;mod=1" : '';
$pg_url .= ($posts_per_page != $bb_cfg['posts_per_page']) ? "&amp;ppp=$posts_per_page" : '';

$pagination = generate_pagination($pg_url, $total_replies, $posts_per_page, $start);

//
// Selects
//
$sel_previous_days = array(
	0   => $lang['All_Posts'],
	1   => $lang['1_Day'],
	7   => $lang['7_Days'],
	14  => $lang['2_Weeks'],
	30  => $lang['1_Month'],
	90  => $lang['3_Months'],
	180 => $lang['6_Months'],
	364 => $lang['1_Year'],
);

$sel_post_order_ary = array(
	$lang['Oldest_First'] => 'asc',
	$lang['Newest_First'] => 'desc',
);


// dj_maxx: add dynamic site description
$page_title_add = '';
$topic_title_prefix = '';
$topic_title_add = '';
// dj_maxx: add guest torrents
if ($t_data['allow_guest'] == 1)
{
		$topic_title_add .= $lang['site_description_free'];
}
// end of
if ($t_data['topic_dl_type'] == TOPIC_DL_TYPE_DL)
{
		$topic_title_prefix .= $lang['site_description_prefix'];
		$page_title_add .= $lang['page_title_dl_add'];
		$topic_title_add .= $lang['site_description_add'];
}
else
{
		$topic_title_add .= $lang['site_description_add_non_dl'];
}
// dj_maxx: add guest torrents
if ($t_data['allow_guest'] == 1)
{
		$page_title_add .= $lang['page_title_free_add'];
}
// end of

// dj_maxx: add dynamic site description
$rnd_keywords = get_keywords($topic_title);
// end of

//
// Send vars to template
//
$template->assign_vars(array(
	'PAGE_URL'            => $pg_url,
	'PAGE_URL_PPP'        => url_arg($pg_url, 'ppp', null),
	'PAGE_START'          => $start,
	'SHOW_JUMPBOX'        => true,

	'FORUM_ID'            => $forum_id,
	'FORUM_NAME'          => htmlCHR($forum_name),
	'TOPIC_ID'            => $topic_id,
	'PAGE_TITLE'          => $topic_title,
	
	// dj_maxx: add dynamic site description
	'PAGE_TITLE_ADD'	  => $page_title_add,
	'DESCRIPTION'         => $topic_title_prefix . $topic_title . $topic_title_add,
	'DYN_KEYWORDS'        => implode(', ', $rnd_keywords) . ', ',
	'CANONICAL'           => make_url($pg_url),
	// end of
	
	'TOPIC_TITLE'         => wbr($topic_title),
// dj_maxx: add topic color
	'TOPIC_COLOR'         => $topic_color,
// end of
// dj_maxx: remove unnecessary links in topic view
	'CLICKABLE_TOPIC_TITLE' => $clickable_topic_title,
// end of
	'PAGINATION'          => $pagination,
	'PAGE_NUMBER'         => sprintf($lang['Page_of'], ( floor($start/$posts_per_page) + 1 ), ceil( $total_replies / $posts_per_page )),
	'PORNO_FORUM'         => isset($porno_forums[$forum_id]),
	'REPLY_IMG'           => $reply_img,
	'SHOW_BOT_NICK'       => $bb_cfg['show_bot_nick'],
	'T_POST_REPLY'        => $reply_alt,

	'HIDE_FLAGS'          => ($user->opt_js['h_flag'] && $bb_cfg['show_poster_flag']),
	'HIDE_AVATAR'         => $user->opt_js['h_av'],
	'HIDE_RANK_IMG'       => ($user->opt_js['h_rnk_i'] && $bb_cfg['show_rank_image']),
	'HIDE_POST_IMG'       => $user->opt_js['h_post_i'],
	'HIDE_SMILE'          => $user->opt_js['h_smile'],
	'HIDE_SIGNATURE'      => $user->opt_js['h_sig'],
	'SPOILER_OPENED'      => $user->opt_js['sp_op'],

	'HIDE_FLAGS_DIS'      => !$bb_cfg['show_poster_flag'],
	'HIDE_RANK_IMG_DIS'   => !$bb_cfg['show_rank_image'],

	'AUTH_MOD'            => $is_auth['auth_mod'],
	'IN_MODERATION'       => $moderation,
	'L_SELECT_PPP'        => $lang['Select_posts_per_page'],
	'SELECT_PPP'          => ($moderation && $select_ppp && $total_replies > $posts_per_page) ? build_select('ppp', $select_ppp, $posts_per_page, null, null, 'onchange="$(\'#ppp\').submit();"') : '',

	'S_SELECT_POST_DAYS'  => build_select('postdays', array_flip($sel_previous_days), $post_days),
	'S_SELECT_POST_ORDER' => build_select('postorder', $sel_post_order_ary, $post_order),
	'S_POST_DAYS_ACTION'  => "viewtopic.$phpEx?t=$topic_id&amp;start=$start",
	'S_AUTH_LIST'         => $s_auth_can,
	'S_TOPIC_ADMIN'       => $topic_mod,
	'S_WATCH_TOPIC'       => $s_watching_topic,
	'S_WATCH_TOPIC_IMG'   => $s_watching_topic_img,
	'S_BOOKMARK_TOPIC'    => $s_bookmark_topic,
	'U_VIEW_TOPIC'        => TOPIC_URL . $topic_id,
	'U_VIEW_FORUM'        => $view_forum_url,
	'U_VIEW_OLDER_TOPIC'  => $view_prev_topic_url,
	'U_VIEW_NEWER_TOPIC'  => $view_next_topic_url,
	'U_POST_NEW_TOPIC'    => $new_topic_url,
	'U_POST_REPLY_TOPIC'  => $reply_topic_url,
	'U_SEARCH_SELF'       => "search.$phpEx?uid={$userdata['user_id']}&t=$topic_id&dm=1",

	// dj_maxx: add release rating
	'INCLUDE_JQUERY_RATER' => true,
	'L_RELEASE_RATING'    => $lang['Rate_rate'],
	// end of
));

// Does this topic contain DL-List?
$template->assign_vars(array(
	'SHOW_TOR_ACT'    => false,
	'PEERS_FULL_LINK' => false,
	'DL_LIST_HREF'    => TOPIC_URL ."$topic_id&amp;dl=names&amp;spmode=full",
));
require(INC_DIR .'torrent_show_dl_list.'. PHP_EXT);

//
// Does this topic contain a poll?
//
if ( !empty($t_data['topic_vote']) )
{
	$s_hidden_fields = '';

	$sql = "SELECT vd.vote_id, vd.vote_text, vd.vote_start, vd.vote_length, vr.vote_option_id, vr.vote_option_text, vr.vote_result
		FROM " . VOTE_DESC_TABLE . " vd, " . VOTE_RESULTS_TABLE . " vr
		WHERE vd.topic_id = $topic_id
			AND vr.vote_id = vd.vote_id
		ORDER BY vr.vote_option_id ASC";
	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, "Could not obtain vote data for this topic", '', __LINE__, __FILE__, $sql);
	}

	if ( $vote_info = $db->sql_fetchrowset($result) )
	{
		$db->sql_freeresult($result);
		$vote_options = count($vote_info);

		$vote_id = $vote_info[0]['vote_id'];
		$vote_title = $vote_info[0]['vote_text'];

		$sql = "SELECT vote_id
			FROM " . VOTE_USERS_TABLE . "
			WHERE vote_id = $vote_id
				AND vote_user_id = " . intval($userdata['user_id']);
		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, "Could not obtain user vote data for this topic", '', __LINE__, __FILE__, $sql);
		}

		$user_voted = ( $row = $db->sql_fetchrow($result) ) ? TRUE : 0;
		$db->sql_freeresult($result);

		if ( isset($HTTP_GET_VARS['vote']) || isset($HTTP_POST_VARS['vote']) )
		{
			$view_result = ( ( ( isset($HTTP_GET_VARS['vote']) ) ? $HTTP_GET_VARS['vote'] : $HTTP_POST_VARS['vote'] ) == 'viewresult' ) ? TRUE : 0;
		}
		else
		{
			$view_result = 0;
		}

		$poll_expired = ( $vote_info[0]['vote_length'] ) ? ( ( $vote_info[0]['vote_start'] + $vote_info[0]['vote_length'] < time() ) ? TRUE : 0 ) : 0;

		if ( $user_voted || $view_result || $poll_expired || !$is_auth['auth_vote'] || $t_data['topic_status'] == TOPIC_LOCKED )
		{
			$vote_results_sum = 0;

			for($i = 0; $i < $vote_options; $i++)
			{
				$vote_results_sum += $vote_info[$i]['vote_result'];
			}

			$vote_graphic = 0;
			$vote_graphic_max = count($images['voting_graphic']);

			for($i = 0; $i < $vote_options; $i++)
			{
				$vote_percent = ( $vote_results_sum > 0 ) ? $vote_info[$i]['vote_result'] / $vote_results_sum : 0;
				$vote_graphic_length = round($vote_percent * $bb_cfg['vote_graphic_length']);

				$vote_graphic_img = $images['voting_graphic'][$vote_graphic];
				$vote_graphic = ($vote_graphic < $vote_graphic_max - 1) ? $vote_graphic + 1 : 0;

				if ( count($orig_word) )
				{
					$vote_info[$i]['vote_option_text'] = preg_replace($orig_word, $replacement_word, $vote_info[$i]['vote_option_text']);
				}

				$template->assign_block_vars("poll_option", array(
					'POLL_OPTION_CAPTION' => $vote_info[$i]['vote_option_text'],
					'POLL_OPTION_RESULT' => $vote_info[$i]['vote_result'],
					'POLL_OPTION_PERCENT' => sprintf("%.1d%%", ($vote_percent * 100)),

					'POLL_OPTION_IMG' => $vote_graphic_img,
					'POLL_OPTION_IMG_WIDTH' => $vote_graphic_length)
				);
			}

			$template->assign_vars(array(
				'TPL_POLL_RESULT' => true,
				'TOTAL_VOTES' => $vote_results_sum,
			));
		}
		else
		{
			for($i = 0; $i < $vote_options; $i++)
			{
				if ( count($orig_word) )
				{
					$vote_info[$i]['vote_option_text'] = preg_replace($orig_word, $replacement_word, $vote_info[$i]['vote_option_text']);
				}

				$template->assign_block_vars("poll_option", array(
					'POLL_OPTION_ID' => $vote_info[$i]['vote_option_id'],
					'POLL_OPTION_CAPTION' => $vote_info[$i]['vote_option_text'])
				);
			}

			$template->assign_vars(array(
				'TPL_POLL_BALLOT' => true,
				'U_VIEW_RESULTS' => TOPIC_URL ."$topic_id&amp;vote=viewresult",
			));

			$s_hidden_fields = '<input type="hidden" name="topic_id" value="' . $topic_id . '" /><input type="hidden" name="mode" value="vote" />';
		}

		if ( count($orig_word) )
		{
			$vote_title = preg_replace($orig_word, $replacement_word, $vote_title);
		}

		$s_hidden_fields .= '<input type="hidden" name="sid" value="' . $userdata['session_id'] . '" />';

		$template->assign_vars(array(
			'TOPIC_HAS_POLL' => true,
			'POLL_QUESTION'  => $vote_title,

			'S_HIDDEN_FIELDS' => $s_hidden_fields,
			'S_POLL_ACTION' => "posting.$phpEx?mode=vote&amp;t=$topic_id",
		));
	}
}

if ($t_data['topic_attachment'])
{
	require(BB_ROOT .'attach_mod/attachment_mod.'. PHP_EXT);
	init_display_post_attachments($t_data['topic_attachment']);
}

//
// Update the topic view counter
//
$sql = "INSERT INTO ". BUF_TOPIC_VIEW_TABLE ."
	(topic_id,  topic_views) VALUES
	($topic_id, 1)
	ON DUPLICATE KEY UPDATE
	topic_views = topic_views + 1";

if ( !$db->sql_query($sql) )
{
	message_die(GENERAL_ERROR, "Could not update topic views.", '', __LINE__, __FILE__, $sql);
}

$prev_post_time = $max_post_time = 0;

// Report
//
// Get report post module
//
require_once($phpbb_root_path . "includes/functions_report.$phpEx");
$report_post = report_modules('name', 'report_post');
// Report [END]



// [MOD] Birthday

$this_year = create_date('Y', time(), $bb_cfg['board_timezone']);
$this_date = create_date('md', time(), $bb_cfg['board_timezone']);

// [MOD] Birthday [END]


//
// Okay, let's do the loop, yeah come on baby let's do the loop
// and it goes like this ...
//
for($i = 0; $i < $total_posts; $i++)
{
	$poster_id = $postrow[$i]['user_id'];
	$poster = ( $poster_id == ANONYMOUS ) ? $lang['Guest'] : $postrow[$i]['username'];

	// [MOD] Birthday
	
	if ( $postrow[$i]['user_birthday'] != 999999 )
	{
		$poster_birthdate = realdate('md', $postrow[$i]['user_birthday']);


		// [MOD] Zodiac
		
		$n = 0;
		while ($n < 26)
		{
			if ($poster_birthdate >= $zodiacdates[$n] && $poster_birthdate <= $zodiacdates[$n+1])
			{
				$zodiac = $lang[$zodiacs[($n/2)]];
				$u_zodiac = $images[$zodiacs[($n/2)]];
				$zodiac_img = '<img src="' . $u_zodiac . '" alt="' . $zodiac . '" title="' . $zodiac . '" align="absmiddle" border="0" />';
				$n = 26;
			} else
			{
				$n = $n+2;
			}
		}
		
		// [MOD] Zodiac [END]

		$poster_age = $this_year - realdate ('Y',$postrow[$i]['user_birthday']);
		if ($this_date < $poster_birthdate) $poster_age--;
		$poster_age = '<em>' . $lang['Age'] . ':</em> ' . $poster_age;
	} else
	{
		$poster_age = '';

		// [MOD] Zodiac
		
		$zodiac = '';
		$u_zodiac = '';
		$zodiac_img = '';

		// [MOD] Zodiac [END]

	}
	
	// [MOD] Birthday [END]


	$post_date = create_date($bb_cfg['post_date_format'], $postrow[$i]['post_time']);
	$max_post_time = max($max_post_time, $postrow[$i]['post_time']);

	$poster_posts = ( $postrow[$i]['user_id'] != ANONYMOUS ) ? $postrow[$i]['user_posts'] : '';

	$poster_from = ( $postrow[$i]['user_from'] && $postrow[$i]['user_id'] != ANONYMOUS ) ? $postrow[$i]['user_from'] : '';

// FLAGHACK-start
	$poster_from_flag = ( !$user->opt_js['h_flag'] && $postrow[$i]['user_from_flag'] && $postrow[$i]['user_id'] != ANONYMOUS ) ? make_user_flag($postrow[$i]['user_from_flag']) : "";
// FLAGHACK-end

	$poster_joined = ( $postrow[$i]['user_id'] != ANONYMOUS ) ? $lang['JOINED'] . ': ' . create_date($lang['DATE_FORMAT'], $postrow[$i]['user_regdate'], $bb_cfg['board_timezone']) : '';

	$upload = ( $postrow[$i]['user_id'] != ANONYMOUS ) ? $postrow[$i]['u_up_total'] : 0;
	$download = ( $postrow[$i]['user_id'] != ANONYMOUS ) ? $postrow[$i]['u_down_total'] : 0;
	$release = ( $postrow[$i]['user_id'] != ANONYMOUS ) ? $postrow[$i]['u_up_release'] : 0;
	$bonus = ( $postrow[$i]['user_id'] != ANONYMOUS ) ? $postrow[$i]['u_up_bonus'] : 0;
	$ratio = ($download > MIN_DL_FOR_RATIO) ? round((($upload + $release + $bonus) / $download), 2) : '-';
	
	// dj_maxx: add hide bbcode (bonuses)
	$seed_bonus = ( $postrow[$i]['user_id'] != ANONYMOUS ) ? round($postrow[$i]['user_bonus'],1) : 0;
	// end of
	
	$poster_longevity = ( $postrow[$i]['user_id'] != ANONYMOUS ) ? delta_time($postrow[$i]['user_regdate']) : '';

	$poster_avatar = '';
	if ( !$user->opt_js['h_av'] && $postrow[$i]['user_avatar_type'] && $poster_id != ANONYMOUS && $postrow[$i]['user_allowavatar'] )
	{
		switch( $postrow[$i]['user_avatar_type'] )
		{
			case USER_AVATAR_UPLOAD:
				$poster_avatar = ( $bb_cfg['allow_avatar_upload'] ) ? '<img src="' . $bb_cfg['avatar_path'] . '/' . $postrow[$i]['user_avatar'] . '" alt="" border="0" />' : '';
				break;
			case USER_AVATAR_REMOTE:
				$poster_avatar = ( $bb_cfg['allow_avatar_remote'] ) ? '<img src="' . $postrow[$i]['user_avatar'] . '" alt="" border="0" onload="imgFit(this, 100);" onclick="return imgFit(this, 100);" />' : '';
				break;
			case USER_AVATAR_GALLERY:
				$poster_avatar = ( $bb_cfg['allow_avatar_local'] ) ? '<img src="' . $bb_cfg['avatar_gallery_path'] . '/' . $postrow[$i]['user_avatar'] . '" alt="" border="0" />' : '';
				break;
		}
	}

	//
	// Generate ranks, set them to empty string initially.
	//
	$poster_rank = $rank_image = $poster_rank_2 = $rank_image_2 = '';

// Start add - Gender MOD
	$gender_image = '';
// End add - Gender MOD

	if (!$user->opt_js['h_rnk_i'] AND $user_rank = $postrow[$i]['user_rank'] AND isset($ranks[$user_rank]))
	{
		$rank_image = ($bb_cfg['show_rank_image'] && $ranks[$user_rank]['rank_image']) ? '<img src="'. $ranks[$user_rank]['rank_image'] .'" alt="" title="" border="0" />' : '';
		$poster_rank = ($bb_cfg['show_rank_text']) ? $ranks[$user_rank]['rank_title'] : '';
	}
	// dj_maxx: add secondary rank (award rank)
	if (!$user->opt_js['h_rnk_i'] AND $user_rank_2 = $postrow[$i]['user_rank_2'] AND isset($ranks[$user_rank_2]))
	{
		$rank_image_2 = ($bb_cfg['show_rank_image'] && $ranks[$user_rank_2]['rank_image']) ? '<img src="'. $ranks[$user_rank_2]['rank_image'] .'" alt="" title="" border="0" />' : '';
		$poster_rank_2 = ($bb_cfg['show_rank_text']) ? $ranks[$user_rank_2]['rank_title'] : '';
	}	
	// end of

	//
	// Handle anon users posting with usernames
	//
	if ( $poster_id == ANONYMOUS && $postrow[$i]['post_username'] != '' )
	{
		$poster = $postrow[$i]['post_username'];

		// [MOD] Birthday
			
		$poster_age = '';
		
		// [MOD] Birthday [END]


		// [MOD] Zodiac
		
		$zodiac = '';
		$u_zodiac = '';
		$zodiac_img = '';

		// [MOD] Zodiac [END]


	}

	// Buttons
	$pm_btn = '';
	$profile_btn = '';

	$delpost_btn = '';
	$edit_btn = '';
	$ip_btn = '';
// dj_maxx: add warnings & bans
	$warning_btn = '';
	$ban_btn = '';
	$reviews_btn = '';
	$warned_blk = '';
	$show_warnings = false;
// end of
	$quote_btn = '';


// Start add - Gender MOD
	switch ($postrow[$i]['user_gender'])
	{
		case 1  : $gender_image = "<img src=\"" . $images['icon_minigender_male'] . "\" alt=\"" . $lang['Gender'].  ":".$lang['Male']."\" title=\"" . $lang['Gender'] . ":".$lang['Male']. "\" border=\"0\" />"; break;
		case 2  : $gender_image = "<img src=\"" . $images['icon_minigender_female'] . "\" alt=\"" . $lang['Gender']. ":".$lang['Female']. "\" title=\"" . $lang['Gender'] . ":".$lang['Female']. "\" border=\"0\" />"; break;
		default : $gender_image = '';
	}
// End add - Gender MOD


	if ($poster_id != ANONYMOUS)
	{
		// profile
		$profile_btn = true;
		// pm
		$pm_btn = true;
	}

	if ($poster_id != BOT_UID)
	{
		// Quote
		$quote_btn = $userdata['session_logged_in'];
		// Edit
		$edit_btn = (($userdata['user_id'] == $poster_id && $is_auth['auth_edit']) || $is_auth['auth_mod']);
		// IP
		$ip_btn = ($is_auth['auth_mod'] || IS_MOD);

		// dj_maxx: add warnings & bans
		$almost_admin = in_array($userdata['user_id'], $bb_cfg['almost_admins']);

		$warning_btn = ($postrow[$i]['user_level'] != ADMIN) && ($postrow[$i]['user_level'] != MOD) && ($userdata['user_id'] != $poster_id) && ($is_auth['auth_mod'] || IS_MOD || $almost_admin);
		$ban_btn     = ($postrow[$i]['user_level'] != ADMIN) && ($postrow[$i]['user_level'] != MOD) && ($userdata['user_id'] != $poster_id) && ($is_auth['auth_mod'] || IS_MOD || $almost_admin);
		$reviews_btn = ($postrow[$i]['post_reviews'] > 0) && $userdata['session_logged_in'];
		$warned_blk  = ($postrow[$i]['post_warned']  > 0) && $userdata['session_logged_in'];


		$poster_warnings = '';
		$show_warnings = ($postrow[$i]['user_warnings'] > 0) || ($postrow[$i]['user_bans'] > 0);

		// glue icons according to count of warnings to display in profile
		if ($show_warnings)
		{
			for ($j = 0; $j < $postrow[$i]['user_warnings']; $j++)
			{
				$poster_warnings .= '<img src="'. $images['icon_yellow'].'" alt="Warn" title="" />';
			}
			for ($j = 0; $j < $postrow[$i]['user_bans']; $j++)
			{
				$poster_warnings .= '<img src="'. $images['icon_red'].'" alt="Ban" title="" />';
			}
		}
		// end of



	}
	// Delete
	$delpost_btn = ($is_auth['auth_mod'] || ($userdata['user_id'] == $poster_id && $is_auth['auth_delete'] && $t_data['topic_last_post_id'] == $postrow[$i]['post_id'] && $postrow[$i]['post_time'] + 3600*3 > TIMENOW));

	//
	// Parse message and sig
	//
	$post_subject = ( $postrow[$i]['post_subject'] != '' ) ? $postrow[$i]['post_subject'] : '';

	$message = get_parsed_post($postrow[$i]);
	
	$bbcode_uid = $postrow[$i]['bbcode_uid'];

	$user_sig = ($userdata['session_logged_in'] && $bb_cfg['allow_sig'] && !$user->opt_js['h_sig'] && $postrow[$i]['enable_sig'] && $postrow[$i]['user_sig']) ? $postrow[$i]['user_sig'] : '';
	$user_sig_bbcode_uid = $postrow[$i]['user_sig_bbcode_uid'];

	if ($user_sig && $user_sig_bbcode_uid)
	{
		$user_sig = ($bb_cfg['allow_bbcode']) ? bbencode_second_pass($user_sig, $user_sig_bbcode_uid) : preg_replace("/\:$user_sig_bbcode_uid/si", '', $user_sig);
	}
	if ($user_sig)
	{
		$user_sig = make_clickable($user_sig);
	}

	//
	// Parse smilies
	//
	if ($user_sig && $bb_cfg['allow_smilies'])
	{
		$user_sig = smilies_pass($user_sig);
	}

	//
	// Replace naughty words
	//
	if (count($orig_word))
	{
		$post_subject = preg_replace($orig_word, $replacement_word, $post_subject);

		if ($user_sig)
		{
			$user_sig = str_replace('\"', '"', substr(@preg_replace('#(\>(((?>([^><]+|(?R)))*)\<))#se', "@preg_replace(\$orig_word, \$replacement_word, '\\0')", '>' . $user_sig . '<'), 1, -1));
		}
		// dj_maxx:  auto censor fix
		/* $message = str_replace('\"', '"', substr(@preg_replace('#(\>(((?>([^><]+|(?R)))*)\<))#se', "@preg_replace(\$orig_word, \$replacement_word, '\\0')", '>' . $message . '<'), 1, -1)); */
		$message = preg_replace($orig_word, $replacement_word, $message);
		// end of
	}

	//
	// Replace newlines (we use this rather than nl2br because
	// till recently it wasn't XHTML compliant)
	//
	if ($user_sig)
	{
		$user_sig = '<br />_________________<br />' . str_replace("\n", "\n<br />\n", $user_sig);

        // dj_maxx: handle redirects and mirrors in signature
		$user_sig = href2int($user_sig);

    }

	//
	// Editing information
	//
	if ( $postrow[$i]['post_edit_count'] )
	{
		$l_edit_time_total = ( $postrow[$i]['post_edit_count'] == 1 ) ? $lang['Edited_time_total'] : $lang['Edited_times_total'];

		$l_edited_by = '<br /><br />' . sprintf($l_edit_time_total, $poster, create_date($bb_cfg['default_dateformat'], $postrow[$i]['post_edit_time'], $bb_cfg['board_timezone']), $postrow[$i]['post_edit_count']);
	}
	else
	{
		$l_edited_by = '';
	}

	// dj_maxx: add awards mod
	$awO = '';
	if( !empty($postrow[$i]['user_awards']) )
	{
	    $awards = @unserialize( $postrow[$i]['user_awards'] );
	    if( !$awards || count($awards) <= 0 )
	    {}
	    else
	    {
	        $awRc		= 0;
	        foreach( $awards AS $aw )
	        {
	            $awO .= '<img class="award_tip" src="/images/awards/' . $aw['award_file'] . '" title="' . $lang['AW_AWARD'] . ': ' . $aw['award_title'] . '|<b>' . $lang['AW_ZA'] . '</b>: ' . $aw['award_reason'] . '|<b>' . $lang['AW_KOGDA'] . '</b>: ' . bb_date($aw['award_time']) . '"';
	            $awRc++;
	            if( $awRc >= 1 )
	            {
	                $awO .= '<br>';
	                $awRc = 0;
	            }
	        }
	    }
	}
	// end of
	
	//
	// Again this will be handled by the templating
	// code at some point
	//

	// dj_maxx: add nick coloring
	if( $postrow[$i]['user_level'] == ADMIN )
	{
		$poster_name = '<span class="colorAdmin">' . wbr($poster) . '</span>';
	}
	else if( $postrow[$i]['user_level'] == MOD )
	{
		$poster_name = '<span class="colorMod">' . wbr($poster) . '</span>';
	}
	else
	{
		$poster_name = wbr($poster);
	}
	// end of

	$pg_row_class = !($i % 2) ? 'row2' : 'row1';

	// Report
	//
	// Create report links
	//
	if ($report_post && $report_post->auth_check('auth_write'))
	{
		if ($postrow[$i]['post_reported'])
		{
			$report_auth = ($userdata['user_level'] == ADMIN || (!$bb_cfg['report_list_admin'] && (!$bb_cfg['report_subject_auth'] || $is_auth['auth_mod'])));
			if ($report_post->auth_check('auth_view') && $report_auth)
			{
				$temp_url = append_sid("report.$phpEx?mode=reported&amp;" . POST_CAT_URL . '=' . $report_post->id . '&amp;id=' . $postrow[$i]['post_id']);
				$target = ($bb_cfg['report_new_window']) ? ' target="_blank"' : '';
				$report_img = '<a href="' . $temp_url . '"' . $target . '><img src="' . $images['icon_reported'] . '" alt="' . $report_post->lang['Duplicate_report'] . '" title="' . $report_post->lang['Duplicate_report'] . '" border="0" /></a>';
				$report = '<a href="' . $temp_url . '"' . $target . '>' . $report_post->lang['Duplicate_report'] . '</a>';
			}
			else
			{
				$report_img = '<img src="' . $images['icon_reported'] . '" alt="' . $report_post->lang['Duplicate_report'] . '" title="' . $report_post->lang['Duplicate_report'] . '" border="0" />';
				$report = $report_post->lang['Duplicate_report'];
			}
		}
		else
		{
			$temp_url = append_sid("report.$phpEx?mode=" . $report_post->mode . '&amp;id=' . $postrow[$i]['post_id']);
			$report_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_report'] . '" alt="' . $report_post->lang['Write_report'] . '" title="' . $report_post->lang['Write_report'] . '" border="0" /></a>';
			$report = '<a class="txtb" href="' . $temp_url . '">' . $report_post->lang['Write_report'] . '</a>';
		}
	}
	else
	{
		$report_img = $report = '';
	}
	// Report [END]
	


	//Online/Offline
	if (($postrow[$i]['user_session_time'] >= ( time() - 300 )) && ($postrow[$i]['user_allow_viewonline']))
	{
		$on_off_hidden = '<img src="' . $images['icon_online'] . '" alt="' . $lang['Online'] . '" title="' . $lang['Online'] . '" border="0" />';
	}
	else if ($postrow[$i]['user_allow_viewonline'] == 0)
	{
		$on_off_hidden = '<img src="' . $images['icon_hidden'] . '" alt="' . $lang['Hidden'] . '" title="' . $lang['Hidden'] . '" border="0" />';
	}
	else if ($poster_id == ANONYMOUS)
	{
		$on_off_hidden = '';
	}
	else
	{
		$on_off_hidden = '<img src="' . $images['icon_offline'] . '" alt="' . $lang['Offline'] . '" title="' . $lang['Offline'] . '" border="0" />';
	}

	// dj_maxx: add redirector to external links (not containing $bb_cfg['sitename']) and try to fix internal links
	$message = href2int($message);
	// end of
	
	// dj_maxx: add SAPE client
	// $message = $sape_context->replace_in_text_segment($message);
	// end of

	// dj_maxx: is_first post
	$is_first_post = (!$start && ($postrow[$i]['post_id'] == $t_data['topic_first_post_id']));
	// end of
	
	$template->assign_block_vars('postrow', array(
		'ROW_CLASS'          => !($i % 2) ? 'row1' : 'row2',
		'POST_ID'            => $postrow[$i]['post_id'],
		'IS_NEWEST'          => ($postrow[$i]['post_id'] == $newest),

// dj_maxx: add nick coloring
		//'POSTER_NAME'        => wbr($poster),
		'POSTER_NAME'        => $poster_name,
// end of

		// [MOD] Zodiac
	
		'ZODIAC_IMG' => $zodiac_img,
		'ZODIAC' => $zodiac,
		'U_ZODIAC' => $u_zodiac,
		'L_ZODIAC' => ($zodiac) ? '<em>' . $lang['Zodiac'] . ':</em> ' : '',
	
		// [MOD] Zodiac [END]


		// [MOD] Birthday
		
		'POSTER_AGE' => $poster_age,
		
		// [MOD] Birthday [END]


		'POSTER_NAME_JS'     => addslashes($poster),
		'POSTER_RANK'        => $poster_rank,
// dj_maxx: add secondary rank (award rank)
	    'POSTER_RANK_2'        => $poster_rank_2,
// end of	     
// Start add - Gender MOD
		'POSTER_GENDER'	     => $gender_image,
// End add - Gender MOD

		'RANK_IMAGE'         => $rank_image,
// dj_maxx: add secondary rank (award rank)
	    'RANK_IMAGE_2'         => $rank_image_2,
// end of
        'POSTER_JOINED'      => ($bb_cfg['show_poster_joined']) ? $poster_longevity : '',

// dj_maxx: add custom group properties
		'POSTER_VIP'	     => $postrow[$i]['user_vip'],
		'POSTER_RELEASER'    => $postrow[$i]['user_releaser'],
		'POSTER_HALF_DL'     => $postrow[$i]['user_half_dl'],
// end of
// dj_maxx: add warnings & bans [podsli4niki edition]
		'POSTER_REPUTATION'  => $postrow[$i]['user_reputation'] . ( ($postrow[$i]['poster_id'] != $userdata['user_id']) ? ' <a href="warn.'.$phpEx.'?mode=reputation&action=new&p='.$postrow[$i]['post_id'].'"><img src="'.$images['thumb_up'].'" alt="+" title="Reputation up" align="absmiddle" /></a>' : ''),
		'POSTER_WARNINGS'    => $show_warnings ? ("<a href='warn.$phpEx?action=view&amp;mode=warn&amp;u=".$postrow[$i]['poster_id']."'>".$poster_warnings."</a>") : '',
// end of
		'POSTER_JOINED_DATE' => $poster_joined,
		'POSTER_POSTS'       => ($bb_cfg['show_poster_posts']) ? $poster_posts : '',
		'POSTER_FROM'        => ($bb_cfg['show_poster_from']) ? wbr($poster_from) : '',
		'POSTER_BOT'         => ($poster_id == BOT_UID),
		'POSTER_ID'          => $poster_id,
		'POSTED_AFTER'       => ($prev_post_time) ? delta_time($postrow[$i]['post_time'], $prev_post_time) : '',
		'POSTER_FROM_FLAG'   => ($bb_cfg['show_poster_flag']) ? $poster_from_flag : '',
		'IS_UNREAD'          => is_unread($postrow[$i]['post_time'], $topic_id, $forum_id),
		'IS_FIRST_POST'      => $is_first_post,
		'MOD_CHECKBOX'       => ($moderation && ($start || defined('SPLIT_FORM_START'))),
		'POSTER_AVATAR'      => $poster_avatar,
		'POSTER_ONLINE'      => $on_off_hidden,
		'POST_NUMBER'        => ($i + $start + 1),
		'POST_DATE'          => $post_date,
		'POST_SUBJECT'       => $post_subject,
		'MESSAGE'            => $message,
		'SIGNATURE'          => $user_sig,
		'EDITED_MESSAGE'     => $l_edited_by,
// dj_maxx: add awards mod
		'AWARDS_HTML'		 => $awO,
// end of

		'UPLOAD' => '<b>' . $lang['Topic_Stats_UL'] . '</b>: ' . humn_size(@$upload),
		'DOWNLOAD' => '<b>' . $lang['Topic_Stats_DL'] . '</b>: ' . humn_size(@$download),
		'UP_DOWN_RATIO' => '<p style="color: green;"><b>' . $lang['Topic_Stats_Ratio'] . '</b>: ' . $ratio . '</p>',
		// dj_maxx: add hide bbcode (bonuses)
		'SEED_BONUS'    => '<p style="color: darkgreen;"><b>' . $lang['SEED_BONUS'] . '</b>: ' . $seed_bonus . '</p>',
		// end of

		// dj_maxx: add coolness mod (with temporary hint, need to be rewritten in "bar" style)
		'COOLNESS'      => '<p class="coolness"><b>' . $lang['COOLNESS'] . '</b>: ' . round($postrow[$i]['user_coolness'],0) .
							' <img src="./templates/default/images/icon_mini_faq.gif" align="absmiddle" width="12" height="13" title=",      ."></p>',
		// end of

		'PM'      => $pm_btn,
		'PROFILE' => $profile_btn,

		'QUOTE'   => $quote_btn,
		'EDIT'    => $edit_btn,
		'DELETE'  => $delpost_btn,

// Start add - Gender MOD
		'L_GENDER' => $lang['Gender'],
// End add - Gender MOD

		'IP'      => $ip_btn,
// dj_maxx: add warnings & bans
		'WARN'    => $warning_btn,
		'BAN'     => $ban_btn,
		'REVIEWS' => $reviews_btn,
		'WARNED_BLK' => $warned_blk,
// end of
		
		// Report
		'REPORT_IMG' => $report_img,
		'REPORT'     => $report,
		// Report [END]
	));


// dj_maxx: add similarity check
	if ($is_first_post && $t_data['allow_reg_tracker'] /*&& $userdata['session_logged_in']*/)
	{

		// dj_maxx: add sphinx engine (temporary disabled due to bugs in phrase build algorithm)
		//if (SPHINX_ENABLE)
		if (FALSE)
		{

			// search only in forums we have rights to read
			$excluded_forums_csv = $user->get_excluded_forums(AUTH_READ);

			if ($bb_cfg['porno_forums'])                $excluded_forums_csv .= ','.$bb_cfg['porno_forums'];
			if ($bb_cfg['trash_forum_id'])              $excluded_forums_csv .= ','.$bb_cfg['trash_forum_id'];
			if ($bb_cfg['latest_discussions_forum_id']) $excluded_forums_csv .= ','.$bb_cfg['latest_discussions_forum_id'];

			$allowed_forums = array_diff(explode(',', $forums['tracker_forums']), explode(',', $excluded_forums_csv));

			// Sphinx init...
			if (!SPHINX_PECL)
			{
				include ($phpbb_root_path . 'includes/sphinxapi.php');
			}
			$sphinx = new SphinxClient ();
			$sphinx->SetConnectTimeout( (int) SPHINX_TIMEOUT );
			$sphinx->SetServer( (string) SPHINX_HOST, (int) SPHINX_PORT);

			$sphinx->SetMatchMode(SPH_MATCH_PHRASE);

			$sphinx->SetFilter('forum_id', $allowed_forums);
			$sphinx->SetFilter('id', Array( (int) $topic_id), true);

			$sphinx->SetLimits(0, 10, 10);
			
			
			// sphinx phrase build
			if (preg_match("#(.*) \((.*)\) \[(.*)\](.*?)#is", $topic_title, $regs))
			{
				$sphx_query = $regs[1];
			}
			elseif (preg_match("#(.*) \[(.*)\](.*?)#is", $topic_title, $regs))
			{
				$sphx_query = $regs[1];
			}
			else
			{
				$sphx_query = substr($topic_title,0,12)."*";
			}
			
			// Sphinx escape
			$sphx_query = preg_replace('#(?<=\S)\-#', ' ', $sphx_query);                    // "1-2-3" -> "1 2 3"
			$sphx_query = preg_replace('#[^0-9a-zA-Z--߸\-_*|]#', ' ', $sphx_query);    //   ( "  )
			$sphx_query = str_replace('-', ' -', $sphx_query);                              // -    
			$sphx_query = str_replace('*', '* ', $sphx_query);                              // *    
			$sphx_query = preg_replace('#\s*\|\s*#', '|', $sphx_query);                     // "| " -> "|"
			$sphx_query = preg_replace('#\|+#', ' | ', $sphx_query);                        // "||" -> "|"
			$sphx_query = preg_replace('#(?<=\s)[\-*]+\s#', ' ', $sphx_query);              //  " - ", " * "
			$sphx_query = trim($sphx_query, ' -|');
			$sphx_query = str_compact($sphx_query);
			// Sphinx escape End.
			$sphx_query = preg_replace('/[]/', '', $sphx_query);

// debug
			$db->query("SELECT * FROM bb_users where username='".$db->escape($sphx_query)."'");
// end

			if ( !$sphinx_result = $sphinx->Query($sphx_query, 'topics') )
			{
				message_die(GENERAL_ERROR, 'Could not query similar torrents information (Sphinx is down?)', '', __LINE__, __FILE__, $sphinx->GetLastError());
			}


			$count_similar = $sphinx_result['total'];


			if ($count_similar)
			{
				$template->assign_vars(array('HAS_SIMILAR_TOPICS' => 1));

				foreach ($sphinx_result['matches'] as $id => $topic)
				{

					$title = wbr(str_short($topic['attrs']['title'], 200));
					$topic_url = '<a title="'.$topic['attrs']['title'].'" href="'. append_sid("viewtopic.php?". POST_TOPIC_URL .'='. $id) .'">'. $title . '</a>';

					$poster_url = append_sid("profile.php?mode=viewprofile&amp;". POST_USERS_URL .'='. $topic['attrs']['topic_poster']);
					
					$poster_username = '<a class="genmed" href="'. $poster_url .'">'. wbr($topic['attrs']['topic_poster_name']) .'</a>';

					$forum_url = append_sid("viewforum.php?f=". $topic['attrs']['forum_id']);
					$forum = '<a class="genmed" href="'. $forum_url .'">'. $forums['f'][$topic['attrs']['forum_id']]['forum_name'] .'</a>';

					$tor_size = humn_size($topic['attrs']['size']);
				
					$template->assign_block_vars('postrow.similar_topics', array(
					    'TOPICS'    => $topic_url,
						'AUTHOR'    => $poster_username,
						'FORUM'      => $forum,
						'TOR_SIZE'    => $tor_size,
					));


				}
			} // $count_similar

			unset($sphinx_result);

		}
		else
		{
		// end of

			$title = (strlen($topic_title) > 10) ? (substr($topic_title, 0, 10) . '') : $topic_title;
    		$sql_search = "t.topic_title LIKE '" . addslashes($title) . "%'";

			$porno_forums = $bb_cfg['porno_forums'] ? $bb_cfg['porno_forums'] : '0';
			$trash_forums = $bb_cfg['trash_forum_id'] ? $bb_cfg['trash_forum_id'] : '0';
			$forbidden_forums = $bb_cfg['latest_discussions_forum_id'] ? $bb_cfg['latest_discussions_forum_id'] : '0';
            
			// very bloating query (how to get rid of LIKE?)
			$sql = "SELECT t.*, u.user_id, u.username, u2.user_id AS last_user_id, u2.username AS last_username,
			        f.forum_id, f.forum_name, tor.size, tor.tor_status, tor.complete_count, tor.attach_id,
			        IF(sn.seeders > sn.seeders_ext, sn.seeders, sn.seeders_ext) AS seeders,
			        IF(sn.leechers > sn.leechers_ext, sn.leechers, sn.leechers_ext) AS leechers

			        FROM ". TOPICS_TABLE ." t
			        LEFT JOIN ". USERS_TABLE ." u ON (t.topic_poster = u.user_id)
			        LEFT JOIN ". FORUMS_TABLE ." f ON (t.forum_id = f.forum_id)
			        LEFT JOIN ". BT_TORRENTS_TABLE ." tor ON (t.topic_id = tor.topic_id)
			        LEFT JOIN " . BT_TRACKER_SNAP_TABLE ." sn ON (tor.topic_id = sn.topic_id)
			        LEFT JOIN ". POSTS_TABLE ." p2 ON (t.topic_last_post_id = p2.post_id)
			        LEFT JOIN ". USERS_TABLE ." u2 ON (p2.poster_id = u2.user_id)
			        
          		 	WHERE t.topic_id != $topic_id
			 	    AND $sql_search
            		AND f.allow_reg_tracker = 1
            		AND f.forum_id NOT IN ($trash_forums, $porno_forums, $forbidden_forums)
            		LIMIT 10";


			if ( !($result = $db->sql_query($sql)) )
			{
				message_die(GENERAL_ERROR, "Could not get main information for similar topics", '', __LINE__, __FILE__, $sql);
			}
			$similar = array();
			while ( $row = $db->sql_fetchrow($result) )
			{
				$similar[] = $row;
			}

			$count_similar = count($similar);


			if ( $count_similar > 0)
			{
				$template->assign_vars(array('HAS_SIMILAR_TOPICS' => 1));

				for($j = 0; $j < $count_similar; $j++)
				{
					$title = wbr(str_short($similar[$j]['topic_title'], 200));
					$topic_url = '<a title="'.$similar[$j]['topic_title'].'" href="'. append_sid("viewtopic.php?". POST_TOPIC_URL .'='. $similar[$j]['topic_id']) .'">'. $title . '</a>';

					$poster_url = append_sid("profile.php?mode=viewprofile&amp;". POST_USERS_URL .'='. $similar[$j]['user_id']);
					$similar[$j]['username'] = wbr($similar[$j]['username']);
					$poster_username = '<a class="genmed" href="'. $poster_url .'">'. $similar[$j]['username'] .'</a>';

					$forum_url = append_sid("viewforum.php?f=". $similar[$j]['forum_id']);
					$forum = '<a class="genmed" href="'. $forum_url .'">'. $similar[$j]['forum_name'] .'</a>';

					$template->assign_block_vars('postrow.similar_topics', array(
					    'TOPIC_ICON'  => get_topic_icon($similar[$j], 0),
					    'TOR_STATUS' => (int) $similar[$j]['tor_status'],
					    'TOR_FROZEN' => (isset($similar[$j]['tor_status']) && ($similar[$j]['tor_status'] == TOR_STATUS_FROZEN || $similar[$j]['tor_status'] == 3 || $similar[$j]['tor_status'] == 4 || $similar[$j]['tor_status'] == 7 || $similar[$j]['tor_status'] == 11)),  // dj_maxx: add torrent status fucking copyright warning 
					    'TOPICS'    => $topic_url,
					    'VIEWS'     => (int) $similar[$j]['topic_views'],
					    'REPLIES'   => (int) $similar[$j]['topic_replies'],
					    'LAST_POST_ID'      => $similar[$j]['topic_last_post_id'],
					    'LAST_POSTER_HREF'  => ($similar[$j]['last_user_id'] != ANONYMOUS) ? $similar[$j]['last_user_id'] : '',
					    'LAST_POSTER_NAME'  => ($similar[$j]['last_username']) ? str_short($similar[$j]['last_username'], 15) : $lang['Guest'],
					    'LAST_POST_TIME'    => bb_date($similar[$j]['topic_last_post_time']),
						'AUTHOR'    => $poster_username,
						'FORUM'     => $forum,
					));
					
					if (isset($similar[$j]['size']))
					{
					    $tor_size = humn_size($similar[$j]['size']);
					    
					    $template->assign_block_vars('postrow.similar_topics.tor', array(
					            'SEEDERS'    => (int) $similar[$j]['seeders'],
					            'LEECHERS'   => (int) $similar[$j]['leechers'],
					            'TOR_SIZE'   => $tor_size,
					            'COMPL_CNT'  => (int) $similar[$j]['complete_count'],
					            'ATTACH_ID'  => (int) $similar[$j]['attach_id'],
					    ));
					}
				}
			}

		// dj_maxx: add sphinx engine
		}

		// end of

    }
// end of
	
	
// dj_maxx: add warnings & bans [podsli4niki edition]
	if ($warned_blk)
	{
		// fetch warnings for post, where they are
		$sql = "SELECT  r.*, rt.review_text, u.user_id, u.username
			FROM " . REVIEWS_TABLE . " r
			LEFT JOIN " . REVIEWS_TEXT_TABLE . " rt ON (rt.review_id = r.review_id)
			LEFT JOIN " . USERS_TABLE . " u ON (u.user_id = r.poster_id)
			WHERE r.review_type in ('warn','ban') AND r.post_id = " . $postrow[$i]['post_id'];

		if ( $result = $db->fetch_rowset($sql) )
		{
			foreach ($result as $row_num => $row)
			{
				$poster_url = "<a href='profile.$phpEx?mode=viewprofile&amp;u=".$row['user_id']."'>".$row['username']."</a>";

				$template->assign_block_vars('postrow.warned_blk', array(
					'WARN'       => $row['review_type'] == 'warn',
					'BAN'        => $row['review_type'] == 'ban',
					'TEXT'       => $row['review_text'],
					'POSTER_URL' => $poster_url,
					'GIVEN'      => create_date($bb_cfg['post_date_format'], $row['review_date']),
					'EXPIRE'     => ($row['review_value'] == 1) ? '  ' : create_date($bb_cfg['post_date_format'], $row['review_expire_date']),
				));
			}
		}
	}
// end of


	if ($postrow[$i]['post_attachment'] && $is_auth['auth_download'] && function_exists('display_post_attachments'))
	{
		display_post_attachments($postrow[$i]['post_id'], $postrow[$i]['post_attachment']);
	}

	if ($moderation && !defined('SPLIT_FORM_START') && ($start || $postrow[$i]['post_id'] == $t_data['topic_first_post_id']))
	{
		define('SPLIT_FORM_START', TRUE);
	}

	if ($poster_id != BOT_UID)
	{
		$prev_post_time = $postrow[$i]['post_time'];
	}
}

set_tracks(COOKIE_TOPIC, $tracking_topics, $topic_id, $max_post_time);

if (defined('SPLIT_FORM_START'))
{
	$template->assign_vars(array(
		'SPLIT_FORM'     => true,
		'START'          => $start,
		'S_SPLIT_ACTION' => "modcp.$phpEx",
		'POST_FORUM_URL' => POST_FORUM_URL,
		'POST_TOPIC_URL' => POST_TOPIC_URL,
	));
}

//
// Quick Reply
//
if ($bb_cfg['show_quick_reply'])
{
	if ($is_auth['auth_reply'] && !($t_data['forum_status'] == FORUM_LOCKED || $t_data['topic_status'] == TOPIC_LOCKED))
	{

		// dj_maxx: generate smilies for quick reply
		require(INC_DIR .'functions_post.'. PHP_EXT);
		generate_smilies('inline');
		// end of

		$template->assign_vars(array(
			'QUICK_REPLY'     => true,
			'QR_POST_ACTION'  => "posting.$phpEx",
			'QR_TOPIC_ID'     => $topic_id,
		));
		if (!IS_GUEST)
		{
			$template->assign_vars(array(
				'QR_ATTACHSIG_CHECKED' => bf($userdata['user_opt'], 'user_opt', 'attachsig'),
				'QR_NOTIFY_CHECKED'    => ($userdata['user_notify'] || $is_watching_topic),
			));
		}
	}
}

$template->assign_vars(array(
	'PG_ROW_CLASS' => isset($pg_row_class) ? $pg_row_class : 'row1',
));

if (IS_ADMIN)
{
	$template->assign_vars(array(
		'U_LOGS' => "admin/admin_log.$phpEx?sid={$userdata['session_id']}&amp;t=$topic_id&amp;db=900",
		'L_LOGS' => 'Logs',
	));
}


print_page('viewtopic.tpl');
