<?php
/*
	dj_maxx: add warnings & bans [podsli4niki edition]
 */

//die("DEBUG");

define('IN_PHPBB', true);
define('BB_ROOT', './');
define('BB_SCRIPT', 'warn');
$phpEx = substr(strrchr(__FILE__, '.'), 1);

require(BB_ROOT ."common.$phpEx");


$page_cfg['load_tpl_vars'] = array(
	'post_buttons',
	'post_icons',
	'topic_icons',
);

// Start session management
$user->session_start(array('req_login' => true));

// 
//------------------------------------------------------------------------------
function check_already()
{
	global $bb_cfg, $db, $mode, $count_reviews, $post_id, $poster_id, $victim_id;  // all variables global, no need input params

	// check if already banned
	if ($mode == 'ban')
	{
		if ($count_reviews > 0)
		{
			message_die(GENERAL_ERROR, '  !', '', __LINE__, __FILE__);
		} 

        // check for record in bb's banlist table
		$sql = "SELECT * FROM " . BANLIST_TABLE . " WHERE ban_userid = $victim_id";
		if ( $row = $db->fetch_row($sql) )  // record in banlist table exists
		{
			message_die(GENERAL_ERROR, '    !', '', __LINE__, __FILE__);
		}
		//else
		//{
		//	message_die(GENERAL_ERROR, 'Could not obtain bans information', '', __LINE__, __FILE__, $sql);
		//}
	}
	//

	// check if already warned
	if ($mode == 'warn')
	{
		if ($count_reviews >= $bb_cfg['max_warnings'])
		{
			message_die(GENERAL_ERROR, '    !', '', __LINE__, __FILE__);
		}
	}

	// reputation time limits
	if ($mode == 'reputation')
	{
		if ($count_reviews > 0) // if has reputation set in given time slice
		{
			message_die(GENERAL_ERROR, '        ' .delta_time(0, $bb_cfg['reputation_timeslice'], 'seconds'). '!', '-', __LINE__, __FILE__);
		}
	}
	// end of

	// do not allow multiple reviews from same user to same post (even expired)
	if ($mode == 'warn' || $mode == 'ban') 
	{
		$where = " AND review_type in ('warn','ban')";
	}
	else
	{
		$where = " AND review_type = '$mode'";
	}

	$sql = "SELECT COUNT(*) AS cnt FROM " . REVIEWS_TABLE . " 
		WHERE poster_id = $poster_id AND user_id = $victim_id AND post_id = $post_id $where";
	
	if ( $row = $db->fetch_row($sql) )
	{
		if ($row['cnt'] > 0)
		{
			message_die(GENERAL_ERROR, '      !', '-', __LINE__, __FILE__, $sql);
		}
	}
	else
	{
		message_die(GENERAL_ERROR, 'Could not check for multiple reviews', '', __LINE__, __FILE__, $sql);
	}
	// end of

}
//------------------------------------------------------------------------------


// obtain global parameters
//------------------------------------------------------------------------------

$current_date = TIMENOW;

$action = @$_REQUEST['action'];  // action

if ($action != 'new' && $action != 'edit' && $action != 'view')
{
	message_die(GENERAL_ERROR, 'action: bad parameters!', '', __LINE__, __FILE__);
}

$almost_admin = in_array($userdata['user_id'], $bb_cfg['almost_admins']);
// end of obtain global parameters
//------------------------------------------------------------------------------


if ($action == 'edit')
{

	$review_id = isset($_REQUEST['r']) ? intval($_REQUEST['r']) : 0;

	$sql = "SELECT  r.*, rt.review_text
		FROM " . REVIEWS_TABLE . " r, " . REVIEWS_TEXT_TABLE . " rt 
		WHERE rt.review_id = r.review_id AND r.review_id = $review_id";

	if ($row = $db->fetch_row($sql))
	{
		$mode = $row['review_type'];
		$poster_id = intval($row['poster_id']);
		$victim_id = intval($row['user_id']);
		$post_id = intval($row['post_id']);
		$review_date = $row['review_date'];
		$review_expire_date = $row['review_expire_date'];
		$message = $row['review_text'];

		if ($mode != 'warn' && $mode != 'ban' && $mode != 'reputation')
		{
			message_die(GENERAL_ERROR, 'mode: bad parameters read from DB!', '', __LINE__, __FILE__);
		}
		if (!$poster_id)
		{
			message_die(GENERAL_ERROR, 'poster_id: bad parameters read from DB!', '', __LINE__, __FILE__);
		}
		if (!$victim_id)
		{
			message_die(GENERAL_ERROR, 'victim_id: bad parameters read from DB!', '', __LINE__, __FILE__);
		}

		if (!IS_ADMIN && ($poster_id != $userdata['user_id']))  // check for access rights
		{       	
			message_die(GENERAL_ERROR, '      !', '', __LINE__, __FILE__);
		}


	}
	else
	{
		message_die(GENERAL_ERROR, 'Cannot obtain data for editing!', '', __LINE__, __FILE__);
	}

}
elseif ($action == 'new')
{
	// obtain local parameters
	$mode = @$_REQUEST['mode'];  // mode
	$poster_id = $userdata['user_id'];
	$post_id = isset($_REQUEST['p']) ? intval($_REQUEST['p']) : 0;         	 // target post (0 if review from profile)

	$victim_id = 0;

	if (!$post_id)
	{
		$victim_id = isset($_REQUEST['u']) ? intval($_REQUEST['u']) : 0;  // target user_id
	}
	else
	{
		$sql = "SELECT poster_id FROM " . POSTS_TABLE . " WHERE post_id = $post_id";
		if ($row = $db->fetch_row($sql))
		{
			$victim_id = $row['poster_id'];
		}
	}
	//

	if (!$victim_id)
	{
		message_die(GENERAL_ERROR, 'victim_id: bad parameters!', '', __LINE__, __FILE__);
	}

	if ($mode != 'warn' && $mode != 'ban' && $mode != 'reputation')
	{
		message_die(GENERAL_ERROR, 'mode: bad parameters!', '', __LINE__, __FILE__);
	}
	// end of


	// check for access rights
	if ($mode == 'warn' && !(IS_ADMIN || IS_MOD || $almost_admin))
	{
		message_die(GENERAL_ERROR, '    !', '', __LINE__, __FILE__);
	
	}
	if ($mode == 'ban' && !(IS_ADMIN || $almost_admin))
	{
		message_die(GENERAL_ERROR, '    !', '', __LINE__, __FILE__);
	}


	$count_reviews = 0;  // number of existing reviews of given type for given victim

	// different conditions for reputation and expirable reviews
	$where = ($mode == 'reputation') ? (" AND (".TIMENOW." - review_date) < " . $bb_cfg['reputation_timeslice']) : (" AND review_expire_date > " . TIMENOW);

	$sql = "SELECT COUNT(*) AS cnt FROM " . REVIEWS_TABLE . " WHERE review_type = '$mode' AND user_id = $victim_id $where";

	if ( $row = $db->fetch_row($sql) )
	{
		$count_reviews = $row['cnt'];
	}
	else
	{
		message_die(GENERAL_ERROR, 'Could not obtain reviews count information', '', __LINE__, __FILE__, $sql);
	}


	check_already();   // perform checks if already warned/banned

}
elseif ($action == 'view')
{
	require(BB_ROOT ."includes/bbcode.$phpEx");

	// obtain local parameters
	$mode = @$_REQUEST['mode'];  // mode
	$post_id = isset($_REQUEST['p']) ? intval($_REQUEST['p']) : 0;         // target post (0 if review from profile)
	$victim_id = isset($_REQUEST['u']) ? intval($_REQUEST['u']) : 0;       // target user_id

	$start = isset($_REQUEST['start']) ? abs(intval($_REQUEST['start'])) : 0;

	$bb_cfg['topics_per_page'] = 30;
	//

	// Cat/forum data
	$forums = $datastore->get('cat_forums');
	$forum_name_html = $forums['forum_name_html'];


	if ($mode != 'warn' && $mode != 'reputation' && $mode != 'all')  // warn => warn + ban
	{
		message_die(GENERAL_ERROR, 'mode: bad parameters!', '', __LINE__, __FILE__);
	}

	$where = '';

	if ($post_id == 0 || $victim_id > 0)
	{
		$where .= " r.user_id = $victim_id";
		$base_url = "warn.$phpEx?action=view&amp;mode=$mode&amp;u=$victim_id";

	}
	elseif ($post_id > 0 || $victim_id == 0)
	{
		$where .= " r.post_id = $post_id";
		$base_url = "warn.$phpEx?action=view&amp;mode=$mode&amp;p=$post_id";
	}
	else
	{
		message_die(GENERAL_ERROR, 'post_id, victim_id: bad parameters!', '', __LINE__, __FILE__);
	}

	// different conditions for reputation and expirable reviews
	if ($mode != 'reputation' && $mode != 'all') 
	{ 
		$where .= " AND r.review_expire_date > " . TIMENOW;
	}

	// filter by review mode if not 'all'
	if ($mode == 'warn')
	{
		$where .= " AND r.review_type in ('warn','ban')";
	}
	elseif ($mode == 'reputation')
	{
		$where .= " AND r.review_type = '$mode'";
	}


	// count of reviews to be displayed (for pagination)
	$sql = "SELECT COUNT(review_id) AS cnt FROM " . REVIEWS_TABLE . " r WHERE $where";
	if ( $row = $db->fetch_row($sql) )
	{
		$total_reviews = $row['cnt'];
	}
	else
	{
		message_die(GENERAL_ERROR, 'Could not obtain reviews count information', '', __LINE__, __FILE__, $sql);
	}	

	// existing non-expired reviews (bans, warnings or reputation)
	$sql = "SELECT  r.*, rt.review_text, u.username, p.topic_id, t.forum_id, t.topic_title, t.topic_type, t.topic_dl_type, t.topic_replies, t.topic_status, t.topic_replies
		FROM " . REVIEWS_TABLE . " r
 		LEFT JOIN " . REVIEWS_TEXT_TABLE . " rt ON (rt.review_id = r.review_id)
 		LEFT JOIN " . USERS_TABLE . " u ON (u.user_id = r.poster_id)
		LEFT JOIN " . POSTS_TABLE . " p ON (p.post_id = r.post_id)
		LEFT JOIN " . TOPICS_TABLE . " t ON (t.topic_id = p.topic_id)
		WHERE $where LIMIT $start, " . $bb_cfg['topics_per_page'];


	if ( $result = $db->fetch_rowset($sql) )
	{

		foreach ($result as $row_num => $row)
		{
			$message = $row['review_text'];

			if ($bb_cfg['allow_smilies'])
			{
				$message = smilies_pass($message);
			}

			$template->assign_block_vars("p", array(
				'ROW_NUM'     => $row_num,
				'POSTER_ID'   => $row['poster_id'],
				'POSTER_NAME' => $row['username'],
				'POST_ID'     => $row['post_id'],
				'TOPIC_ID'    => $row['topic_id'],
				'TOPIC_TITLE' => $row['topic_title'],
				'TOPIC_ICON'  => get_topic_icon($row, false),
				'FORUM_ID'    => $row['forum_id'],
				'FORUM_NAME'  => @$forum_name_html[$row['forum_id']],
				'REVIEW_ID'   => $row['review_id'],

				'EDIT'        => IS_ADMIN || ($row['poster_id'] == $userdata['user_id']),
				'DELETE'      => IS_ADMIN, // in this release only admins can see IP and delete reviews
				'IP'          => IS_ADMIN, //

				'POST_DATE'   => create_date($bb_cfg['post_date_format'], $row['review_date']),
				'MESSAGE'     => $message
			)
			);
		}


		$pagination = generate_pagination($base_url, $total_reviews, $bb_cfg['topics_per_page'], $start). '&nbsp;';

		$template->assign_vars(array(
			'VIEW_REVIEWS' => true,
			'PAGINATION' => $pagination,
			'PAGE_NUMBER' => sprintf($lang['Page_of'], ( floor( $start / $bb_cfg['topics_per_page'] ) + 1 ), ceil( $total_reviews / $bb_cfg['topics_per_page'] )),

		));


	}
	else
	{
		message_die(GENERAL_ERROR, ' !', '', __LINE__, __FILE__, $sql);
	}



}

if ($action != 'view')   // 'new' or 'edit'
{
	$victim_name = '';   // target username

	// check for valid user id and rights (we don't want to give podsli4nik to admins/moders)
	$sql = "SELECT username, user_level FROM " . USERS_TABLE . " WHERE user_id = $victim_id";
	if ($row = $db->fetch_row($sql))
	{
		if (($action == 'new' || $action == 'edit') && ($mode == 'warn' || $mode == 'ban') && ($row['user_level'] == ADMIN || $row['user_level'] == MOD) )
		{
			message_die(GENERAL_ERROR, 'Cannot give podsli4nik to administrator or moderator!', '', __LINE__, __FILE__);
		}

		if ($victim_id == $poster_id)
		{
			message_die(GENERAL_ERROR, 'Cannot review yourself!', '', __LINE__, __FILE__);
		}

		$victim_name = $row['username'];
	}
	else
	{
		message_die(GENERAL_ERROR, 'victim_id: no such user exists!', '', __LINE__, __FILE__);
	}
	// end of
}



if (empty($_POST))  // form not submitted
{


	//------------------------------------------------------------------------------

 	// fill hidden fields	
	$s_hidden_fields =  '<input type="hidden" name="u" value="'. $victim_id .'" />' . "\n";
	$s_hidden_fields .= '<input type="hidden" name="p" value="'. $post_id .'" />' . "\n";
	$s_hidden_fields .= '<input type="hidden" name="action" value="'. $action .'" />' . "\n";
	$s_hidden_fields .= '<input type="hidden" name="mode" value="'. $mode .'" />' . "\n";
	//

	if ($action == 'new')
	{

		if ($mode == 'warn')
		{
			$mode_img = '<img src="'. $images['icon_yellow']     .'" alt="Warn" title="'. $lang['Warn_user'] .'" />';	
			$mode_action_title = '  ';
			$mode_title = ' ';
			$mode_action = '<input type="text" name="duration" maxlength="50" size="4" value="3"/> (-) &nbsp;[ 1  '.$bb_cfg['max_warning_days'].' ]';
		}
		if ($mode == 'ban')
		{
			$mode_img = '<img src="'. $images['icon_red']     .'" alt="Ban" title="'. $lang['Ban_user'] .'" />';	
			$mode_action_title = '  ';
			$mode_title = ' ';
			$mode_action = '<input type="text" name="duration" maxlength="50" size="4" value="3"/> (-) &nbsp;[ 1  '.$bb_cfg['max_warning_days'].' ] <br/><input type="checkbox" name="permanent" value="1"/> <br/><input type="checkbox" name="reset_passkey" value="1"/>   (  )';
		}
		if ($mode == 'reputation')
		{
			$mode_img = '';	
			$mode_action_title = ' ';
			$mode_title = ' ';
			$mode_action = ' ';
		}


		$template->assign_vars(array(
			'NEW_REVIEW' => true,
			'MODE_IMG' => $mode_img,
			'PAGE_TITLE' => " ",
			'USERNAME' => $victim_name,
			'MODE_ACTION_TITLE' => $mode_action_title,
			'MODE_ACTION' => $mode_action,
			'MODE_TITLE' => $mode_title,

			'S_NEW_ACTION' => 'warn.'.$phpEx.'',
			'S_HIDDEN_FIELDS' => $s_hidden_fields,
		));

	}
	elseif ($action == 'edit')
	{
		
		$s_hidden_fields .= '<input type="hidden" name="r" value="'. $review_id .'" />' . "\n";


		if ($mode == 'warn')
		{
			$mode_img = '<img src="'. $images['icon_yellow']     .'" alt="Warn" title="'. $lang['Warn_user'] .'" />';	
			$mode_action_title = '   ()';
			$mode_title = ' ';

			$seconds_left = $review_expire_date - $current_date;
			$days_left = floor($seconds_left / 86400);
			$hours_left = floor(($seconds_left - ($days_left * 86400)) / 3600);
			$minutes_left = floor(($seconds_left - ($days_left * 86400) - ($hours_left*3600)) / 60);

			$mode_action = '<input type="text" name="duration" maxlength="50" size="4" value="'.$days_left.'"/> (-) <input type="text" name="duration_h" maxlength="50" size="4" value="'.$hours_left.'"/> (-) <input type="text" name="duration_m" maxlength="50" size="4" value="'.$minutes_left.'"/> (-) &nbsp;[ 1  '.$bb_cfg['max_warning_days'].' , 0 -  ]';
		}
		if ($mode == 'ban')
		{
			$mode_img = '<img src="'. $images['icon_red']     .'" alt="Ban" title="'. $lang['Ban_user'] .'" />';	
			$mode_action_title = '   ()';
			$mode_title = ' ';

			$seconds_left = $review_expire_date - $current_date;
			$days_left = floor($seconds_left / 86400);
			$hours_left = floor(($seconds_left - ($days_left * 86400)) / 3600);
			$minutes_left = floor(($seconds_left - ($days_left * 86400) - ($hours_left*3600)) / 60);

			$mode_action = '<input type="text" name="duration" maxlength="50" size="4" value="'.$days_left.'"/> (-) &nbsp;[ 1  '.$bb_cfg['max_warning_days'].' ,  0 -  ] <br/><input type="checkbox" name="permanent" value="0"/> <br/><input type="checkbox" name="reset_passkey" value="0"/>   (  )';
		}
		if ($mode == 'reputation')
		{
			$mode_img = '';	
			$mode_action_title = ' ';
			$mode_title = ' ';
			$mode_action = ' ';
		}



		$template->assign_vars(array(
			'EDIT_REVIEW' => true,


			'MODE_IMG' => $mode_img,
			'PAGE_TITLE' => " ",
			'USERNAME' => $victim_name,
			'MODE_ACTION_TITLE' => $mode_action_title,
			'MODE_ACTION' => $mode_action,
			'MODE_TITLE' => $mode_title,

			'MESSAGE' => $message,

			'S_EDIT_ACTION' => 'warn.'.$phpEx.'',
			'S_HIDDEN_FIELDS' => $s_hidden_fields,
		));

	}

}
else    // handle POST  (save changes to database)
{

	// expire date for warnings & bans
	if ($mode != 'reputation')  
	{

		$duration_days = intval(@$_POST['duration']);

		if ($duration_days < 1)
		{
			message_die(GENERAL_ERROR, '    - 1 !', '', __LINE__, __FILE__);
		}

		$duration_hours = intval(@$_POST['duration_h']);
		$duration_minutes = intval(@$_POST['duration_m']);

		if ($duration_hours > 23)
		{
			message_die(GENERAL_ERROR, '   23!', '', __LINE__, __FILE__);
		}
		if ($duration_minutes > 59)
		{
			message_die(GENERAL_ERROR, '   59!', '', __LINE__, __FILE__);
		}

		$duration = $duration_days*86400 + $duration_hours*3600 + $duration_minutes*60;

		if (($duration / 86400) > $bb_cfg['max_warning_days'])
		{
			message_die(GENERAL_ERROR, '   !   - ' . $bb_cfg['max_warning_days'] . ' !', '', __LINE__, __FILE__);
		}

		$review_expire_date = $duration ? ($current_date + $duration) : 0;

		if ($mode == 'ban')
		{
			if (intval(@$_POST['permanent']))
			{
				$review_expire_date = '9999999999';
			}
			$reset_passkey = intval(@$_POST['reset_passkey']);
		}

	} 
	else
	{
		$review_expire_date = 0;
	}
	//

	if ($action == 'new')
	{

		if ($mode == 'reputation')
		{
			$value = 1;  // can be -1 for negative reputation (will be implemented soon)
			$post_table_field = 'post_reviews';  // field to update in posts table
		}
		else
		{
			$value = 0;  // default value for warn & ban (auto changed to 1 on expire after cron job runs)
			$post_table_field = 'post_warned'; // field to update in posts table
		}


		$poster_ip = USER_IP;

		$sql = "INSERT INTO " . REVIEWS_TABLE . " (poster_id, poster_ip, editor_ip, user_id, post_id, review_type, review_value, review_date, review_edit_date, review_expire_date) 
			VALUES ($poster_id, '$poster_ip', '$poster_ip', $victim_id, $post_id, '$mode', $value, $current_date, $current_date, $review_expire_date)";
		if ( !$db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, "Could not insert review", "", __LINE__, __FILE__, $sql);
		}

		$review_id = $db->sql_nextid();
		$review_text = $db->escape($_POST['message']);

		$sql = "INSERT INTO " . REVIEWS_TEXT_TABLE . " (review_id, review_text) 
			VALUES ($review_id, '$review_text')";
		if ( !$db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, "Could not insert review text", "", __LINE__, __FILE__, $sql);
		}


		$sql = "UPDATE " . POSTS_TABLE . " SET $post_table_field = $post_table_field + 1 WHERE post_id = $post_id";
		if ( !$db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, "Could not update post reviews/warnings", "", __LINE__, __FILE__, $sql);
		}


		// update reputation in users table
		if ($mode == 'reputation')
		{
			$user_table_field = 'user_reputation';
		}
		elseif ($mode == 'warn')
		{
			$user_table_field = 'user_warnings';
		}
		elseif ($mode = 'ban')
		{
			$user_table_field = 'user_bans';
		}


		$sql = "UPDATE " . USERS_TABLE . " 
			SET $user_table_field = $user_table_field + 1 
			WHERE user_id = $victim_id";

		if ( !$db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, "Could not update user reputation/warning", "", __LINE__, __FILE__, $sql);
		}


		// ban user
		if ($mode == 'ban')
		{
			$sql = "INSERT INTO " . BANLIST_TABLE . " (ban_userid)
				VALUES ($victim_id)";
			if ( !$db->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, "Couldn't insert ban_userid info into database", "", __LINE__, __FILE__, $sql);
			}

			$sql = "DELETE FROM " . SESSIONS_TABLE . " WHERE session_user_id = $victim_id";
			if ( !$db->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, "Couldn't clear session", "", __LINE__, __FILE__, $sql);
			}

			if ($reset_passkey)
			{
				require(INC_DIR .'functions_torrent.'. PHP_EXT);
				generate_passkey ($victim_id, true);
			}
			
		}



		$message = '  .' . '<br /><br />' . sprintf($lang['Click_view_message'], '<a href="' . append_sid("viewtopic.$phpEx?" . POST_POST_URL . "=" . $post_id) . '#' . $post_id . '">', '</a>');
		message_die(GENERAL_MESSAGE, $message);

	}

	elseif ($action == 'edit')
	{

		$poster_ip = USER_IP;

		$sql = "UPDATE " . REVIEWS_TABLE . " SET 
				editor_ip = '$poster_ip',
				review_edit_date = $current_date, 
				review_expire_date = $review_expire_date
			WHERE review_id = $review_id";
		if ( !$db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, "Could not update review", "", __LINE__, __FILE__, $sql);
		}

		$review_text = $db->escape($_POST['message']);

		$sql = "UPDATE " . REVIEWS_TEXT_TABLE . " SET review_text = '$review_text' WHERE review_id = $review_id";
		if ( !$db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, "Could not update review text", "", __LINE__, __FILE__, $sql);
		}


		$message = '  .' . '<br /><br />' . sprintf($lang['Click_view_message'], '<a href="' . append_sid("viewtopic.$phpEx?" . POST_POST_URL . "=" . $post_id) . '#' . $post_id . '">', '</a>');
		message_die(GENERAL_MESSAGE, $message);

	}




}

print_page('warn.tpl');
